1 IMPLICIT% x,y,y1,ax,kk,pum,type,prty
20 TURBO_objfil 'ram1_eptr2wda104':TURBO_taskn 'ep2wda v1.04':TURBO_objdat 100
30 TURBO_repfil 'ram1_err':TURBO_struct 1:TURBO_windo 0:TURBO_buffersz 300
40 TURBO_model '>'
50 DIM version$(12):version$="1.04"
60 :
100 REMark Program to set WDa from Easyptr "menus" - 22 MAR 04
110 REMark Eptr2WDA104_bas
120 :
130 REMark *****************************************************************
140 REMark * A window definition is called a "menu" in Easyptr             *
150 REMark * Its format appears to be as follows:                          *
160 REMark * A 28 byte header with                                         *
170 REMark * 1. Eight bytes of "suicide" code                              *
180 REMark * 2. A four byte identifier "menu"                              *
190 REMark * 3. The window's name (limited to 14 bytes)                    *
200 REMark *                                                               *
210 REMark * After the window definition proper come                       *
220 REMark * text objects , sprites, blobs and patterns.                   *
230 REMark *                                                               *
240 REMark * All window definitions for a program can be (are?)            *
250 REMark * rolled together in a _CDE file which also contains            *
260 REMark * the extras needing to be loaded.                              *
270 REMark *                                                               *
280 REMark * The window definitions seem to be set at the end              *
290 REMark * of this file, as an appendix. This is signalled               *
300 REMark * by the identifier "EASYMEN" which is followed by a zero byte. *
310 REMark *                                                               *
320 REMark * Then follow the window definitions each with an eight         *
330 REMark * byte header: four bytes "+men", then a long word              *
340 REMark * containing the length of the window definition file _men.     *
350 REMark *                                                               *
360 REMark * The window definitions for the WDA file can be taken from     *
370 REMark * the Easytpr _CDE file (or separate _men files if needed).     *
380 REMark * The text_list file can be assembled as we go through          *
390 REMark * the parts of the window definition pointing to objects.       *
400 REMark *                                                               *
410 REMark * The tmpo file is slightly different.                          *
420 REMark * Each sprite, blob or pattern must have a pointer              *
430 REMark * inside the "menu". This must point to the object              *
440 REMark * held in the latter part of each "menu".                       *
450 REMark * By noting the smallest address pointed to in each             *
460 REMark * "menu" we can determine the limits in each menu               *
470 REMark * of the area holding sprites, blobs and patterns.              *
480 REMark * After completing the window definitions, we copy              *
490 REMark * the appropriate end bits of each "menu" to an                 *
500 REMark * area created for tmpo.                                        *
510 REMark * This tmpo file will not be exactly as described               *
520 REMark * in the manual. Instead, the header will contain               *
530 REMark * all the pointers for sprites, blobs and patterns. Then        *
540 REMark * will follow the areas plucked from the "menus".               *
550 REMark *****************************************************************
560 :
1000 OPEN#0,con:INK#0,GREEN%:wch%=100
1010 OPEN#3,con:REMark for use with the information window
1020 IF NOT Set_Win:PRINT#0,"I can't open my windows":Stip
1030 g_mxw:REMark sets _max_x% & _max_y%
1040 mmx%=PEEK_W(wd(0)+48)&&4095:mmy%=PEEK_W(wd(0)+50)&&4095
1050 wwd=M_SETUP(#wch%,wd(0),mmx%*2^16+mmy%)
1060 chid=M_PRPOS(wwd,-1)
1070 SET_CHANNEL#3,SWIN(0,0,wwd)
1080 :
1090 Inita:Prt1
1100 :
1110 REPeat lp
1120  k=WRPTR(wwd):REMark k indicates whether loose item, event or application
1130  r=255&&get_x%(k)
1140  SELect ON r
1150   =255:REMark loose items
1160     IF Do_loose%(get_y%(k)):EXIT lp
1170   =254:REMark event
1180     IF Do_event%(get_y%(k)):EXIT lp
1190  END SELect
1200  Prt1
1210 END REPeat lp
1220 STOP
1230 :
1240 DEFine FuNction Do_loose%(num)
1250  SELect ON num
1260   =0:Mve1
1270   =1:Finish:RETurn 1
1280   =2:Do_Trans
1290  END SELect
1300  D_LDRW num,wwd
1310  RETurn 0
1320 END DEFine
1330 :
1340 DEFine PROCedure Mve1
1350  BCHWIN wwd
1360  SET_CHANNEL#3,SWIN(0,0,wwd)
1370 END DEFine
1380 :
1390 DEFine PROCedure Finish
1400  BUNST wwd:CLOS chid
1410  CLOSE#3
1420  BRECHP
1430 END DEFine
1440 :
1450 DEFine FuNction Do_event%(num)
1460  REMark sleep later?
1470  RETurn 0
1480 END DEFine
1490 :
1500 DATA "EASYMEN not found in","menu not found in"
1510 DATA "I can't find the file","Can't open _WDA for"
1515 DATA "Can't open _NME for","Can't open f.. files"
1517 DATA "Address out of all windows!!"
1520 :
1530 DEFine PROCedure Inita
1540  LOCal x
1550  DIM cm%(8),eh$(6,50),ename$(42)
1560  RESTORE 1500
1570  FOR x=0 TO 6:READ eh$(x)
1580  Set_PD_Def:fatal=0
1590 END DEFine
1600 :
1610 DEFine PROCedure Do_Trans
1620  LOCal a$(40),lp,x,k
1630  no_sp%=-1:no_bl%=-1:no_pa%=-1:h1=28:no_te%=-1
1640  DIM ssp(200),sbl(200),spa(200)
1650  out%=Set_Dv%:CLOSE#out%:IF NOT Ope_fil1%:a$="Good Bye":Prt2 5:STOP
1660  REPeat lp
1665   IF QM_Here:a$=Fle_Sel$:ELSE :a$=Do_NoQM$
1672   IF a$="":Clean_Up 1:RETurn
1674   x=Chk_Fle:IF x=0:EXIT lp
1690   Noise:Prt2 x
1700  END REPeat lp
1710  fen=F_Size(a$)
1720  m0=ALLOCATION(fen):LBYTES a$,m0
1730  wh=SEARCH_MEMORY(m0,fen,"EASYMEN"&CHR$(0))
1740  IF wh=0:Noise:Prt2 0:Clean_Up 0:RETurn :ELSE :Set_Pip
1755  no_w%=0
1760  REPeat lp
1765   k=SEARCH_MEMORY(wh+2,fen+m0-wh-2,"+men")
1767   IF k=0:EXIT lp:ELSE :wh=k
1775   PRINT#nout%,PEEK$(wh+22,PEEK_W(wh+20)):REMark Output the menu name
1780   no_w%=no_w%+1
1790   REMark lfen=PEEK_L(wh+4)
1800   PRINT#p_out%,wh+36
1810   REMark wh=wh+8+lfen
1820   REMark IF wh>=fen+m0:EXIT lp
1830  END REPeat lp
1835  IF no_w%=0:Prt2 0:Noise:Clean_Up 0:RETurn
1840  DIM w_ad(no_w%)
1850  FOR x=0 TO no_w%-1:INPUT#p_in%,w_ad(x)
1860  w_ad(no_w%)=fen+m0+h1
1870  CLOSE#p_in%:CLOSE#p_out%
1880  Do_Fwd:Do_Tmpo:CLOSE#tf%:CLOSE#nout%:FOR x=0 TO 8:CLOSE#cm%(x)
1885  IF fatal:fatal=0:Clean_Up 2:DEALLOCATE m0:RETurn
1890  Set_Hex ename$,-1
1892  Show_How_Much 3,1,1,20,20
1895  Do_Seewin
1897  Prt3:SUSPEND_TASK 150
1900  DEALLOCATE m0
1910 END DEFine
1920 :
1930 DEFine PROCedure Do_Fwd
1940  REMark The addresses of no_w%-1 windows are in
1950  REMark the array w_ad(). [dimension 200]
1960  REMark The "menus" of Easyptr are at those addresses
1970  REMark Here we assume that cm%(0) = dv$&"ram1_fwd" etc,
1980  LOCal lp,x,y,z,st
1990  PRINT#cm%(0),no_w%-1
2000  FOR x=0 TO no_w%-1
2010   no_reps%=Find_Reps%:PRINT#cm%(0),no_reps%
2020   no_apps%=Find_Apps%:PRINT#cm%(0),no_apps%
2030   FOR y=0 TO 14 STEP 2:PRINT#cm%(0),PEEK_W(w_ad(x)+y)
2040   PRINT#cm%(0),Set_Sbp_Ad%(no_sp%,ssp,Spr(w_ad(x)+$10))
2050   FOR y=$12 TO $18 STEP 2:PRINT#cm%(0),PEEK_W(w_ad(x)+y)
2060   PRINT#cm%(0),Set_Sbp_Ad%(no_bl%,sbl,Spr(w_ad(x)+$1A))
2070   PRINT#cm%(0),Set_Sbp_Ad%(no_pa%,spa,Spr(w_ad(x)+$1C))
2080   FOR y=$1E,$20:PRINT#cm%(0),PEEK_W(w_ad(x)+y)
2090   PRINT#cm%(0),Set_Sbp_Ad%(no_bl%,sbl,Spr(w_ad(x)+$22))
2100   PRINT#cm%(0),Set_Sbp_Ad%(no_pa%,spa,Spr(w_ad(x)+$24))
2110   FOR y=$26,$28:PRINT#cm%(0),PEEK_W(w_ad(x)+y)
2120   PRINT#cm%(0),Set_Sbp_Ad%(no_bl%,sbl,Spr(w_ad(x)+$2A))
2130   PRINT#cm%(0),Set_Sbp_Ad%(no_pa%,spa,Spr(w_ad(x)+$2C))
2140  REMark Now come the repeated sections
2150   st=w_ad(x)+$30
2160   FOR z=0 TO no_reps%
2170    FOR y=0,2:PRINT#cm%(0),PEEK_W(st+y)
2180    Do_Fiw
2190    Do_Fli
2200    Do_Fap
2210   END FOR z
2215   Show_How_Much 3,3*x,4*no_w%,20,20
2220  END FOR x
2230  PRINT#tf%:REMark Put end marker to Text_List
2240 END DEFine
2250 :
2260 DEFine PROCedure Do_Fiw
2270  REMark Assume st=address of repeat
2280  LOCal ad,lp,x,y,z,no_f%,st1
2290  REMark Find number of inf windows
2300  no_f%=-1
2310  ad=Spr(st+4)
2320  IF ad
2330   st1=ad
2340   REPeat lp
2350    IF PEEK_W(ad)=-1:EXIT lp
2360    ad=ad+$12:no_f%=no_f%+1
2370   END REPeat lp
2380  END IF
2390  PRINT#cm%(1),no_f%
2400  IF no_f%>-1
2410   FOR x=0 TO no_f%
2420    FOR y=0 TO 14 STEP 2:PRINT#cm%(1),PEEK_W(st1+y)
2430    Do_Fio Spr(st1+$10)
2440    st1=st1+$12
2450   END FOR x
2460  END IF
2470 END DEFine
2480 :
2490 DEFine PROCedure Do_Fio(adr)
2500  LOCal x,y,ty,tp%(200),sp%(200),bp%(200),pp%(200),nt%,ns%,nb%,np%,n_obj%,st,lp
2510  IF adr=0:PRINT#cm%(3),-1:RETurn
2520  nt%=-1:ns%=-1:nb%=-1:np%=-1:REMark numbers of text,sprites, etc
2530  n_obj%=-1:st=adr
2540  REPeat lp
2550   IF PEEK_W(st)=-1:EXIT lp
2560   n_obj%=n_obj%+1:st=st+$10
2570  END REPeat lp
2580  PRINT#cm%(3),n_obj%:IF n_obj%=-1:RETurn
2590  FOR x=0 TO n_obj%
2600   FOR y=0 TO 6 STEP 2:PRINT#cm%(3),PEEK_W(adr+y)
2610   ty=Set_Type%(PEEK(adr+8)):PRINT#cm%(3),ty
2620   SELect ON ty
2650    =2:PRINT#cm%(3),0:ns%=ns%+1:sp%(ns%)=Set_Sbp_Ad%(no_sp%,ssp,Spr(adr+$E))
2660    =4:PRINT#cm%(3),Set_Sbp_Ad%(no_pa%,spa,Spr(adr+$A)):bp%(nb%)=Set_Sbp_Ad%(no_bl%,sbl,Spr(adr+$E))
2670    =6:PRINT#cm%(3),Set_Sbp_Ad%(no_bl%,sbl,Spr(adr+$A)):pp%(np%)=Set_Sbp_Ad%(no_pa%,spa,Spr(adr+$E))
2675    =REMAINDER :PRINT#cm%(3),65536*PEEK_W(adr+$A)+PEEK_W(adr+$C)
2677      nt%=nt%+1:tp%(nt%)=Set_Text_Ad%(Spr(adr+$E))
2680   END SELect
2690  END FOR x
2700  Do_Itend1 3
2710 END DEFine
2720 :
2730 REFERENCE inf%(0)
2740 DEFine PROCedure Do_Itend(ch%,num%,inf%)
2750  LOCal x
2760  PRINT#cm%(ch%),num%
2770  IF num%>-1
2780   FOR x=0 TO num%:PRINT#cm%(ch%),inf%(x)
2790  END IF
2800 END DEFine
2810 :
2820 DEFine PROCedure Do_Fli
2830  LOCal x,y,ty,tp%(200),sp%(200),bp%(200),pp%(200),nt%,ns%,nb%,np%,n_obj%,lp,st1,ad
2840  ad=Spr(st+6):no_obj%=-1:nt%=-1:ns%=-1:nb%=-1:np%=-1
2850  IF ad
2860   st1=ad
2870   REPeat lp
2880    IF PEEK_W(st1)=-1:EXIT lp
2890    st1=st1+$12:no_obj%=no_obj%+1
2900   END REPeat lp
2910  END IF
2920  PRINT#cm%(2),no_obj%
2930  IF no_obj%>-1
2940   FOR x=0 TO no_obj%
2950    FOR y=0 TO 6 STEP 2:PRINT#cm%(2),PEEK_W(ad+y)
2960    FOR y=8,9:PRINT#cm%(2),PEEK(ad+y)
2970    ty=Set_Type%(PEEK(ad+$A))
2980    PRINT#cm%(2),ty:PRINT#cm%(2),PEEK(ad+$B):PRINT#cm%(2),PEEK_W(ad+$E)
2990    SELect ON ty
3000     =2:ns%=ns%+1:sp%(ns%)=Set_Sbp_Ad%(no_sp%,ssp,Spr(ad+$C))
3010     =4:nb%=nb%+1:bp%(nb%)=Set_Sbp_Ad%(no_bl%,sbl,Spr(ad+$C))
3020     =6:np%=np%+1:pp%(np%)=Set_Sbp_Ad%(no_pa%,spa,Spr(ad+$C))
3030     =REMAINDER :nt%=nt%+1:tp%(nt%)=Set_Text_Ad%(Spr(ad+$C))
3040    END SELect
3050    ad=ad+$12
3060   END FOR x
3070   Do_Itend1 2
3080  END IF
3090 END DEFine
3100 :
3110 DEFine PROCedure Do_Fap
3120  LOCal lp,x,y,ad,ext%,nr%,nc%,maxw%,maxh%,xsze%,ysze%
3130  PRINT#cm%(4),nor_app%(z)
3140  IF nor_app%(z)=-1:RETurn
3150  ad=Spr(st+8):REMark adress of list of apps
3160  FOR x=0 TO nor_app%(z)
3170   apad=Spr(ad):ad=ad+4:xsze%=PEEK_W(apad):ysze%=PEEK_W(apad+2)
3180   FOR y=0 TO 14 STEP 2:PRINT#cm%(4),PEEK_W(apad+y)
3190   PRINT#cm%(4),Set_Sbp_Ad%(no_sp%,ssp,Spr(apad+$10))
3200   nxsc%=PEEK_W(apad+$1A):PRINT#cm%(4),nxsc%
3210   nysc%=PEEK_W(apad+$1C):PRINT#cm%(4),nysc%
3220   PRINT#cm%(4),PEEK(apad+$1E)
3230   ext%=POSITION(#cm%(4)):PRINT#cm%(4),0
3240   apad=apad+$20
3250   IF nxsc%*nysc%
3260    FOR x=1 TO (nxsc%<>0)+(nysc%<>0)
3270     FOR y=0 TO 6 STEP 2:PRINT#cm%(4),PEEK_W(apad+y)
3280     PRINT#cm%(4),Set_Sbp_Ad%(no_bl%,sbl,Spr(apad+$E))
3290     PRINT#cm%(4),Set_Sbp_Ad%(no_pa%,spa,Spr(apad+$10))
3300     FOR y=$12 TO $16 STEP 2:PRINT#cm%(4),PEEK_W(apad+y)
3310     apad=apad+$18
3320    END FOR x
3330   END IF
3340   y=POSITION(#cm%(4)):SET_POSITION#cm%(4),ext%
3350   ext%=(PEEK_W(apad+$2E)<>0):PRINT#cm%(4),ext%:SET_POSITION#cm%(4),y
3360   IF ext%=1
3370    FOR y=2 TO 8 STEP 2:PRINT#cm%(4),PEEK_W(apad+y)
3380    PRINT#cm%(4),Set_Sbp_Ad%(no_bl%,sbl,Spr(apad+$A))
3390    PRINT#cm%(4),Set_Sbp_Ad%(no_pa%,spa,Spr(apad+$C))
3400    FOR y= $E,$10:PRINT#cm%(4),PEEK_W(apad+y)
3410    PRINT#cm%(4),Set_Sbp_Ad%(no_bl%,sbl,Spr(apad+$12))
3420    PRINT#cm%(4),Set_Sbp_Ad%(no_pa%,spa,Spr(apad+$14))
3430    FOR y= $16,$18:PRINT#cm%(4),PEEK_W(apad+y)
3440    PRINT#cm%(4),Set_Sbp_Ad%(no_bl%,sbl,Spr(apad+$1A))
3450    PRINT#cm%(4),Set_Sbp_Ad%(no_pa%,spa,Spr(apad+$1C))
3460    nr%=PEEK_W(apad+$1E):PRINT#cm%(4),nr%
3470    nc%=PEEK_W(apad+$20):PRINT#cm%(4),nc%
3480    FOR y=$22 TO $24 STEP 2:PRINT#cm%(4),PEEK_W(apad+y)
3490    Do_Fao1:REMark Do the index lists
3500    Do_Fas Spr(apad+$26),nr%,maxw%: Do_Fas Spr(apad+$28),nc%,maxh%
3510    maxw%=(xsze%-16) DIV maxw%:maxh%=(ysze%-8) DIV maxh%
3520    Do_Frw
3530    IF nxsc%>0:Do_Fcd nxsc%,maxw%
3540    IF nysc%>0:Do_Fcd nysc%,maxh%
3550   END IF
3560  END FOR x
3570 END DEFine
3580 :
3590 REFERENCE mx%
3600 DEFine PROCedure Do_Fas(ad,num%,mx%)
3610  LOCal x,y,h%
3620  IF num%=0:RETurn
3630  mx%=0:y=num%:IF PEEK_W(ad)<0:y=1
3640  PRINT#cm%(6),y-1
3650  FOR x=0 TO y-1
3660   PRINT#cm%(6),PEEK_W(ad+4*x)
3670   h%=PEEK_W(ad+4*x+2)
3680   PRINT#cm%(6),h%:IF h%<0:h%=-h%
3690   h%=$3FFF&&h%:IF h%>mx%:mx%=h%
3700  END FOR x
3710 END DEFine
3720 :
3730 DEFine PROCedure Do_Frw
3740  LOCal ad,x,y,ty,tp%(200),sp%(200),bp%(200),pp%(200),nt%,ns%,nb%,np%,n_obj%,st,lp,kn%,rno%,ptr
3750  nt%=-1:ns%=-1:nb%=-1:np%=-1:REMark numbers of text,sprites, etc
3760  PRINT#cm%(8),nr%-1
3770  ad=Spr(apad+$2E):rno%=0
3780  FOR x=0 TO nr%-1
3790   ptr=Spr(ad):kn%=(Spr(ad+2)-ptr) DIV 10
3800   PRINT#cm%(8),rno%:rno%=rno%+kn%:PRINT#cm%(8),rno%
3810   Do_Obj ptr,kn%-1:ad=ad+4
3820  END FOR x
3830  Do_Itend1 7
3840 END DEFine
3850 :
3860 DEFine PROCedure Do_Fao1
3870  REMark This is just for Index Objects
3880  LOCal ad,x,y,z,ty,tp%(200),sp%(200),bp%(200),pp%(200),nt%,ns%,nb%,np%,n_obj%,st,lp%,kn%,rno%,ptr
3890  nt%=-1:ns%=-1:nb%=-1:np%=-1:REMark numbers of text,sprites, etc
3900  lp%=nc%
3910  FOR x=$2A,$2C
3920   st=Spr(apad+x)
3930   IF st=0
3940    PRINT#cm%(7),-1
3950   ELSE
3960    PRINT#cm%(7),lp%-1
3970    Do_Obj st,lp%-1
3980    Do_Itend1 7
3990   END IF
4000   lp%=nr%
4010  END FOR x
4020 END DEFine
4030 :
4040 DEFine PROCedure Do_Obj(adr,num%)
4050  LOCal st,y,z,ty
4060  st=adr
4070  PRINT#cm%(7),num%
4080  FOR y=0 TO num%
4090   FOR z=0,1:PRINT#cm%(7),PEEK(st+z)
4100   ty=Set_Type%(PEEK(st+2)):PRINT#cm%(7),ty:PRINT#cm%(7),PEEK(st+3)
4110   SELect ON ty
4120    =2:ns%=ns%+1:sp%(ns%)=Set_Sbp_Ad%(no_sp%,ssp,Spr(st+4))
4130    =4:nb%=nb%+1:bp%(nb%)=Set_Sbp_Ad%(no_bl%,sbl,Spr(st+4))
4140    =6:np%=np%+1:pp%(np%)=Set_Sbp_Ad%(no_pa%,spa,Spr(st+4))
4150    =REMAINDER :nt%=nt%+1:tp%(nt%)=Set_Text_Ad%(Spr(st+4))
4160   END SELect
4170   PRINT#cm%(7),PEEK_W(st+6)
4180   st=st+10
4190  END FOR y
4200 END DEFine
4210 :
4220 DEFine PROCedure Do_Itend1(ch%)
4230  Do_Itend ch%,nt%,tp%
4240  Do_Itend ch%,ns%,sp%
4250  Do_Itend ch%,nb%,bp%
4260  Do_Itend ch%,np%,pp%
4270 END DEFine
4280 :
4290 DEFine PROCedure Do_Fcd(o%,mx%)
4300  LOCal x
4310  PRINT#cm%(8),o%-1\0\0\mx%
4320  IF o%>1:FOR x=1 TO o%-1:PRINT#cm%(8),0\0\0
4330 END DEFine
4340 :
4350 DEFine PROCedure Do_Tmpo
4360  LOCal x,hl%,st,m0,top,tote
4370  DIM wsp%(no_sp%+1),wbl%(no_bl%+1),wpa%(no_pa%+1),l_ad(no_w%),m_ad(no_w%)
4380  FOR x=0 TO no_w%-1:l_ad(x)=w_ad(x+1)-h1
4390  Set_Wnos wsp%,ssp,no_sp%:IF fatal:RETurn
4400  Set_Wnos wbl%,sbl,no_bl%:IF fatal:RETurn
4410  Set_Wnos wpa%,spa,no_pa%:IF fatal:RETurn
4420  hl%=16+2*(no_sp%+no_bl%+no_pa%):top=hl%-h1*no_w%
4430  FOR x=0 TO no_w%-1:top=top+w_ad(x+1)-l_ad(x)
4440  tote=top:REMark the size
4450  m0=ALLOCATION(top):top=m0+top:grub$="Setting tmpo"
4460  st=m0+hl%
4470  FOR x=0 TO no_w%-1:m%=w_ad(x+1)-h1-l_ad(x):m_ad(x)=m%: SPOKE$ st,PEEK$(l_ad(x),m%)
4480  bl=2+2*(no_sp%+1)
4490  pa=bl+2+2*(no_bl%+1)
4500  st=m0:SPOKE_W st,bl:SPOKE_W st,pa:SPOKE_W st,no_sp%
4510  Do_wads
4520  IF no_sp%>-1:FOR x=0 TO no_sp%:SPOKE_W st,Dereal%(wad(wsp%(x))+ssp(x)-l_ad(wsp%(x))-m0-4)
4530  SPOKE_W st,no_bl%
4540  IF no_bl%>-1:FOR x=0 TO no_bl%:SPOKE_W st,Dereal%(wad(wbl%(x))+sbl(x)-l_ad(wbl%(x))-m0-4)
4550  SPOKE_W st,no_pa%
4560  IF no_pa%>-1:FOR x=0 TO no_pa%:SPOKE_W st,Dereal%(wad(wpa%(x))+spa(x)-l_ad(wpa%(x))-m0-4)
4570  SBYTES dv$&"tmpo",m0,tote
4580  DEALLOCATE m0
4590 END DEFine
4600 :
4610 DEFine FuNction Find_Reps%
4620  LOCal ans%,lp,st
4630  ans%=-1:st=w_ad(x)+$30
4640  REPeat lp
4650   ans%=ans%+1
4660   IF PEEK_W(st+$A)=-1:EXIT lp
4670   st=st+$A
4680  END REPeat lp
4690  RETurn ans%
4700 END DEFine
4710 :
4720 DEFine FuNction Find_Apps%
4730  LOCal ans%,ans1%,lp,st,y,ad
4740  ans%=-1:DIM nor_app%(no_reps%)
4750  st=w_ad(x)+$38:REMark address of app list in 1st repeat
4760  FOR y=0 TO no_reps%
4770   ans1%=-1
4780   ad=Spr(st):st=st+10
4790   IF ad
4800    REPeat lp
4810     IF PEEK_W(ad)=0:EXIT lp
4820     ad=ad+4:ans%=ans%+1:ans1%=ans1%+1
4830    END REPeat lp
4840   END IF
4850   nor_app%(y)=ans1%
4860  END FOR y
4870  RETurn ans%
4880 END DEFine
4890 :
4900 REFERENCE num%,sx(0)
4910 DEFine FuNction Set_Sbp_Ad%(num%,sx,ad)
4920  LOCal x,found
4930  found=0
4940  IF ad=0:RETurn -1
4950  IF num%>-1
4960   FOR x=0 TO num%
4970    IF ad=sx(x):found=1:EXIT x
4980   END FOR x
4990  END IF
5000  IF NOT found
5010   num%=num%+1
5020   x=num%
5030   sx(x)=ad
5040  END IF
5050  RETurn x
5060 END DEFine
5070 :
5080 DEFine FuNction Set_Text_Ad%(ad)
5090  LOCal x,found,a$(100),b$(100)
5100  found=0:b$=PEEK$(ad+2,PEEK_W(ad))
5110  IF no_te%>-1
5120   SET_POSITION#tf%,0
5130   FOR x=0 TO no_te%
5140    INPUT#tf%,a$
5150    IF a$=b$:found=1:EXIT x
5160   END FOR x
5170  END IF
5180  IF NOT found:no_te%=no_te%+1:PRINT#tf%,b$:x=no_te%
5190  RETurn x
5200 END DEFine
5210 :
5220 DEFine FuNction Which_Window(ad)
5230  LOCal x,found,a$(12)
5240  found=0
5250  FOR x=0 TO no_w%-1
5260   IF ad<w_ad(x+1):found=1:EXIT x
5270  END FOR x
5280  IF NOT found:a$="$"&HEX$(ad,32):fatal =1:Noise:Prt2 6:RETurn -1
5290  IF ad<l_ad(x):l_ad(x)=ad
5300  RETurn x
5310 END DEFine
5320 :
5330 REFERENCE wx%(0),sxx(0)
5340 DEFine PROCedure Set_Wnos(wx%,sxx,no_x%)
5350  LOCal x
5360  IF no_x%<0:RETurn
5370  FOR x=0 TO no_x%:wx%(x)=Which_Window(sxx(x))
5380 END DEFine
5390 :
5400 DEFine PROCedure Set_Pip
5410  LOCal p1%,p2%
5420  p1%=N_CHAN%:OPEN#p1%,scr
5430  p2%=N_CHAN%
5440  CLOSE#p1%
5450  p_out%=max%(p1%,p2%):p_in%=min%(p1%,p2%)
5460  OPEN#p_out%,pipe_1024
5470  CONNECT p_out% TO p_in%
5480 END DEFine
5490 :
5500 DEFine FuNction Ope_fil1%
5510  REMark to set cm%() -> f..
5520  REMark and open dv$&text_list
5530  LOCal lp,lp1,x%,a$(4),good%
5540  RESTORE 5710:good%=0:x%=0
5550  REPeat lp
5560   READ a$
5570   IF a$="":good%=1:EXIT lp
5580   cm%(x%)=N_CHAN%
5590   IF DEVICE_STATUS(2,dv$&a$)<0:EXIT lp
5600   OPEN_NEW#cm%(x%),dv$&a$
5610   x%=x%+1
5620  END REPeat lp
5630  IF NOT good% AND x%
5640   REPeat lp1
5650    x%=x%-1:CLOSE#cm%(x%)
5660    IF x%=0:EXIT lp1
5670   END REPeat lp1
5680  END IF
5690  tf%=N_CHAN%:OPEN_NEW#tf%,dv$&"text_list"
5700  RETurn good%
5710  DATA 'fwd','fiw','fli','fio','fap','fcd','fas','fao','frw',''
5720 END DEFine
5730 :
5740 DEFine FuNction Set_wd(x)
5750  REMark To set the address in tmpo of the xth window (0,1 . .)
5760  IF x=0:RETurn m0+hl%
5770  RETurn Set_wd(x-1)+m_ad(x-1)
5780 END DEFine
5790 :
5800 DEFine PROCedure Do_wads
5810  LOCal x
5820  DIM wad(no_w%)
5840  FOR x=0 TO no_w%-1:wad(x)=Set_wd(x)
5850 END DEFine
5860 :
5870 DEFine PROCedure Noise
5880  BEEP 27000,43,127,40,7,5
5890 END DEFine
5900 :
5910 DEFine FuNction Do_NoQM$
5920  LOCal a$(42)
5930  PAPER#3,WHITE%:CLS#3
5940  INK#3,BLACK%:PRINT#3,"Give the filename:"
5950  INK#3,RED%:AT#3,2,0
5960  a$=EDIT$(#3,"")
5970  RETurn a$
5980 END DEFine
5990 :
6000 DEFine FuNction Adj_Nme$(a$)
6010  REMark strip name of _cde and return last
6020  REMark string after final "_"
6030  LOCal b$(42),lg%
6040  lg%=LEN(a$)
6050  IF lg%<5:RETurn a$
6060  b$=a$
6070  IF b$(lg%-3 TO lg%)=="_CDE":b$=b$(1 TO lg%-4)
6080  RETurn Strip_Nme$(b$)
6090 END DEFine
6100 :
6110 DEFine FuNction Strip_Nme$(a$)
6120  LOCal o%,lg%,b$(42)
6130  b$=a$:lg%=LEN(a$)
6140  o%="_" INSTR a$
6150  IF o%=0:RETurn b$
6160  IF o%=lg%:RETurn ""
6170  RETurn Strip_Nme$(b$(o%+1 TO))
6180 END DEFine
6190 :
6200 DEFine PROCedure Prt1
6210  REMark To print the opening statement
6220  USE 3:PAPER BLACK%:INK GREEN%:CLS
6230  PRINT "   Eptr2WDA v"&version$:INK WHITE%
6240  AT 2,0:PRINT "Press s to pick the"\"Easyptr _CDE file."
6250  Look_Seew:USE
6260 END DEFine
6270 :
6280 DEFine PROCedure Do_Seewin
6290  LOCal a$(40)
6300  a$=d_prog$&"seewin"
6310  IF DEVICE_STATUS(1,a$)<0
6320   a$=PROGD$&"seewin"
6330   IF DEVICE_STATUS(1,a$)<0:RETurn
6340  END IF
6350  EW a$;ename$
6355  SET_PTR wwd,10*65537,-1
6360 END DEFine
6370 :
6380 DEFine PROCedure Look_Seew
6390  REMark This finds if SEEWIN is available.
6400  REMark if not it prints a note to set PROGD$
6410  IF DEVICE_STATUS(1,d_prog$&"seewin")<0
6420   IF DEVICE_STATUS(1,PROGD$&"seewin")<0
6430   AT 5,0:PRINT "(Set directory of"\"SEEWIN by PROG_USE.)"
6440  END IF :END IF
6450 END DEFine
6460 :
6470 DEFine PROCedure Clean_Up(o%)
6480  LOCal x,b$(12)
6490  IF o%=0 OR o%=2:DEALLOCATE m0
6500  IF o%=0: CLOSE#nout%:DELETE "ram1_"&ename$&"_nme"
6510  IF o%=0 OR o%=1: CLOSE#tf%:FOR x=0 TO 8:CLOSE#cm%(x)
6520  RESTORE 23336:FOR x=1 TO 12:READ b$:IF NOT x=2:DELETE dv$&b$
6530 END DEFine
6540 :
6550 DEFine PROCedure Prt2(o%)
6560  USE 3
6570  PAPER RED%:INK WHITE%:CLS
6580  PRINT "     ERROR"
6590  AT 2,0:PRINT eh$(o%)
6595  AT 3,0:PRINT a$
6600  USE:SUSPEND_TASK 150
6610 END DEFine
6620 :
6630 DEFine FuNction Chk_Fle
6640  LOCal ans,c$(42),b$(42),x
6645  ans=DEVICE_STATUS(1,a$):IF ans<0:RETurn 2
6647  ename$=Adj_Nme$(a$)
6648  IF ename$="":ename$="test"
6650  c$="ram1_"&ename$:b$=c$&"_WDA"
6660  FOR x=3,4
6700   ans=DEVICE_STATUS(2,b$)
6710   IF ans<0:IF ans=-8:DELETE b$:ELSE :RETurn x
6720   b$=c$&"_NME"
6730   IF x=4:nout%=N_CHAN%:OPEN_NEW#nout%,b$
6740  END FOR x
6750  RETurn 0
6760 END DEFine
6770 :
6780 DEFine PROCedure Prt3
6790  USE 3
6800  PAPER WHITE%:INK RED%:CLS
6810  AT 1,0:PRINT ename$
6820  INK BLACK%:AT 3,0:PRINT "Completed"
6830  USE
6840 END DEFine
6850 :
6860 DEFine FuNction Set_Type%(o%)
6870  REMark To set 255 etc -> -1 etc
6880  IF o%>155:RETurn o%-256:ELSE : RETurn o%
6890 END DEFine
6900 :
6910 DEFine FuNction QM_Here
6920  IF NOT qm_set
6930   adrfl_sel=BASIC_ADR(BASIC_INDEX%("FILE_SELECT$"))
6940   IF adrfl_sel>0
6950    qm_set=1
6960    vadr1=TURBO_V("TURBO_DUMMY$")
6970   END IF
6980  END IF
6990  RETurn qm_set
7000 END DEFine
7010 :
7020 DEFine FuNction Fle_Sel$
7030  REMark First increase window size
7040  REMark Then ask QMenu for answer
7050  REMark finally replace old window
7060  LOCal wh,a$(42),xz%,yz%
7070  wh=PEEK_L(wd(0)+4)+PEEK_L(wwd+$24):REMark Current window position
7080  xz%=_max_x%-4*PEEK(wwd+41)-4*PEEK_W(wwd+42):yz%=_max_y%-3*PEEK(wwd+41)-2*PEEK_W(wwd+42)
7090  mv=xz%*2^16+yz%
7100  BUNST wwd:BRCHP wwd
7110  wwd=M_SETUP(#wch%,wd(0),mv)
7120  chid=M_PRPOS(wwd,-1)
8000  POKE_L vadr1,adrfl_sel
8010  a$=TURBO_DUMMY$("Pick a CDE file",,"ram1_","_CDE")
8020  BUNST wwd:BRCHP wwd
8030  wwd=M_SETUP(#wch%,wd(0),mmx%*2^16+mmy%)
8040  chid=M_PRPOS(wwd,wh)
8080  SET_CHANNEL#3,SWIN(0,0,wwd)
8090  RETurn a$
9020 END DEFine
9030 :
9040 DEFine PROCedure Puse
9050  LOCal a$(2),o%
9060  o%=N_CHAN%
9070  OPEN#o%,con:a$=INKEY$(#o%,-1)
9080  CLOSE#o%
9090 END DEFine
9100 :
9110 DEFine PROCedure Show_How_Much(ch%,o,o1,x,y)
9120  REMark To "show" at x,y in channel ch%
9130  IF o=0
9140   _sva=BSVPW(#ch%,0,0,0,54,14,x,y,54,14)
9150   BLOCK#ch%,54,14,20,20,GREEN%
9160   BLOCK#ch%,50,12,22,21,WHITE%
9170  END IF
9180  o%=INT(50*o/o1)
9190  BLOCK#ch%,o%,12,22,21,RED%
9200  IF o>=o1:BRSPW#ch%,_sva,0,0,54,14,x,y
9210 END DEFine
9220 :
18999 DEBUG 1
19000 DEFine PROCedure ss
19010  SAVE win1_qptr_basic_eptr2wda104_bas
19020 END DEFine
19025 DEBUG 0
19030 :
19600 DATA 9504
19601 DATA 11,17747,17162,21364,24946,29706,2596,547,-1501,-1024,1792,8708
19602 DATA -4088,13845,-7146,21017,-18403,8224,-29692,-8184,9749,-11242,16921,-22499
19603 DATA 3616,32291,-5631,0,0,4096,3328,1024,256,0,3072,0
19604 DATA 15360,0,27648,0,12,3072,12,3072,12,3072,13,3456
19605 DATA -32691,19888,-20371,28084,-19347,28084,-19345,28668,-897,32764,-961,16380
19606 DATA -961,16376,-2017,8176,-4084,3072,30,7680,30,7680,31,8064
19607 DATA -32673,24544,-7937,-4,-769,-2,-257,-2,-257,-2,-257,-2
19608 DATA -385,32766,-385,32764,-961,16376,-2047,256,0,8192,3328,1024
19609 DATA 256,0,3072,0,28672,0,-11264,0,0,0,0,160
19610 DATA -4096,0,0,160,-4096,0,0,160,-4096,0,0,162
19611 DATA -3200,-16384,32,12450,-3190,-12544,40,15522,-3190,-12512,12328,15522
19612 DATA -3190,-12512,12328,15530,-86,-96,-4054,16298,-86,-96,-4086,4010
19613 DATA -86,-96,-4086,4010,-86,-128,-16382,938,-86,-256,0,240
19614 DATA -4096,0,3,1020,-1024,0,3,1020,-1024,0,3,1023
19615 DATA -64,-16384,51,13311,-4,-1024,255,-1,-1,-16,-3841,-1
19616 DATA -1,-4,-769,-1,-1,-4,-769,-1,-1,-4,-769,-1
19617 DATA -1,-4,-961,16383,-1,-4,-961,16383,-1,-16,-4081,4095
19618 DATA -1,-64,-16382,8448,0,3840,3328,1024,256,0,3072,1
19619 DATA -22528,0,0,0,0,0,0,0,0,0,0,0
19620 DATA 0,0,0,0,0,0,0,0,0,0,255,-257
19621 DATA -512,0,0,0,0,0,0,0,0,0,0,0
19622 DATA 0,0,255,-257,-512,0,0,0,0,0,0,0
19623 DATA 0,0,0,0,0,0,255,-257,-512,0,0,0
19624 DATA 0,0,0,0,0,0,0,0,0,0,255,-257
19625 DATA -512,255,-257,-512,0,0,0,0,0,0,0,255
19626 DATA -512,0,255,-257,-512,255,-257,-512,255,-257,-512,0
19627 DATA 0,0,0,255,-257,-512,255,-257,-512,255,-257,-512
19628 DATA 255,-257,-512,255,-512,0,0,255,-257,-512,255,-257
19629 DATA -512,255,-257,-512,255,-257,-512,255,-512,0,0,255
19630 DATA -257,-512,255,-257,-257,-257,-257,-257,-257,-257,-257,-257
19631 DATA -512,0,0,255,-257,-257,-257,-257,-257,-257,-257,-257
19632 DATA -257,-257,-257,-257,-512,0,0,0,255,-257,-257,-257
19633 DATA -257,-257,-257,-257,-257,-257,-257,-257,-512,0,0,0
19634 DATA 255,-257,-257,-257,-257,-257,-257,-257,-257,-257,-257,-512
19635 DATA 0,0,0,0,0,255,-257,-257,-257,-257,-257,-257
19636 DATA -257,-257,-512,0,0,0,0,0,0,0,255,-1
19637 DATA -256,0,0,0,0,0,0,0,0,0,0,0
19638 DATA 0,255,-1,-1,-1,-256,0,0,0,0,0,0
19639 DATA 0,0,0,0,0,255,-1,-1,-1,-256,0,0
19640 DATA 0,0,0,0,0,0,0,0,0,255,-1,-1
19641 DATA -1,-1,-1,-256,0,0,0,0,0,0,0,255
19642 DATA -256,255,-1,-1,-1,-1,-1,-1,-1,-256,0,0
19643 DATA 0,0,255,-1,-1,-1,-1,-1,-1,-1,-1,-1
19644 DATA -1,-1,-1,-1,-256,0,255,-1,-1,-1,-1,-1
19645 DATA -1,-1,-1,-1,-1,-1,-1,-1,-1,-256,255,-1
19646 DATA -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
19647 DATA -1,-256,255,-1,-1,-1,-1,-1,-1,-1,-1,-1
19648 DATA -1,-1,-1,-1,-1,-256,255,-1,-1,-1,-1,-1
19649 DATA -1,-1,-1,-1,-1,-1,-1,-1,-1,-256,0,255
19650 DATA -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
19651 DATA -1,-256,0,255,-1,-1,-1,-1,-1,-1,-1,-1
19652 DATA -1,-1,-1,-1,-256,0,0,0,255,-1,-1,-1
19653 DATA -1,-1,-1,-1,-1,-1,-1,-256,0,0,0,3171
19654 DATA 28788,24424,24942,25695,29552,29185,32,0,1280,1280,512,512
19655 DATA 0,3072,0,7168,0,11264,0,32,8192,80,20480,32
19656 DATA 8192,0,0,32,8192,112,28672,248,-2048,112,28672,32
19657 DATA 8192,1,64,0,2304,1792,1024,768,0,3072,0,9216
19658 DATA 0,15360,0,8,2048,20,5120,34,8704,20,5120,8
19659 DATA 2048,0,0,8,2048,28,7168,62,15872,127,32512,62
19660 DATA 15872,28,7168,8,2048,1,288,0,3072,1280,512,512
19661 DATA 0,3072,0,7168,0,11264,0,8,3072,34,13056,8
19662 DATA 3072,0,0,12,3072,63,16128,255,-64,-16321,16128,12
19663 DATA 3072,1,320,0,5120,2304,1024,768,0,3072,0,20480
19664 DATA 0,-27648,0,0,0,0,128,-16384,0,2,800,12288
19665 DATA 0,8,3080,3072,0,32,12290,768,0,8,3080,3072
19666 DATA 0,2,800,12288,0,0,128,-16384,0,0,0,0
19667 DATA 0,0,192,-16384,0,3,1008,-4096,0,15,4092,-1024
19668 DATA 0,63,16383,-256,0,255,-1,-64,-16384,63,16383,-256
19669 DATA 0,15,4092,-1024,0,3,1008,-4096,0,0,192,-16384
19670 DATA 0,2,8480,0,1280,1280,512,512,0,3072,0,17408
19671 DATA 0,31744,0,0,0,0,0,0,0,255,-512,0
19672 DATA 0,0,255,-512,255,-512,0,0,0,255,-512,0
19673 DATA 0,0,0,0,0,0,0,0,0,255,-256,0
19674 DATA 0,0,255,-1,-1,-256,0,255,-1,-1,-1,-1
19675 DATA -256,0,255,-1,-1,-256,0,0,0,255,-256,0
19676 DATA 0,2,8512,0,2304,1792,1024,768,0,3072,0,-27648
19677 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19678 DATA 0,0,0,255,-512,0,0,0,0,0,0,0
19679 DATA 255,-512,255,-512,0,0,0,0,0,255,-512,0
19680 DATA 0,255,-512,0,0,0,0,0,255,-512,255,-512
19681 DATA 0,0,0,0,0,0,0,255,-512,0,0,0
19682 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19683 DATA 0,0,0,255,-256,0,0,0,0,0,0,0
19684 DATA 255,-1,-1,-256,0,0,0,0,0,255,-1,-1
19685 DATA -1,-1,-256,0,0,0,255,-1,-1,-1,-1,-1
19686 DATA -1,-256,0,0,0,255,-1,-1,-1,-1,-256,0
19687 DATA 0,0,0,0,255,-1,-1,-256,0,0,0,0
19688 DATA 0,0,0,255,-256,0,0,0,0,0,2915,28788
19689 DATA 24420,26977,24435,28786,1,3,0,3584,2560,1536,1024,0
19690 DATA 3072,0,12288,0,21504,0,7,128,28,2016,-32708,8176
19691 DATA -8068,16376,-3972,16376,-4036,8176,-8164,2016,-32761,128,0,0
19692 DATA 7,1920,-32737,8160,-8129,16368,-3969,32760,-1793,-4,-769,-4
19693 DATA -897,32760,-1985,16368,-4065,8160,-8185,1920,-32767,6,0,3584
19694 DATA 2560,1536,1024,0,3072,0,12288,0,21504,0,7,128
19695 DATA 31,1888,-32706,7984,-8068,16248,-3976,16376,-4047,8176,-8165,2016
19696 DATA -32761,128,0,0,7,1920,-32737,8160,-8129,16368,-3969,32760
19697 DATA -1793,-4,-769,-4,-897,32760,-1985,16368,-4065,8160,-8185,1920
19698 DATA -32767,9,0,3584,2560,1536,1024,0,3072,0,12288,0
19699 DATA 21504,0,7,128,31,2016,-32705,8176,-8096,16152,-4000,16152
19700 DATA -4033,8176,-8161,2016,-32761,128,0,0,7,1920,-32737,8160
19701 DATA -8129,16368,-3969,32760,-1793,-4,-769,-4,-897,32760,-1985,16368
19702 DATA -4065,8160,-8185,1920,-32767,12,0,3584,2560,1536,1024,0
19703 DATA 3072,0,12288,0,21504,0,7,128,27,2016,-32719,8176
19704 DATA -8072,16376,-3972,16248,-4034,7984,-8161,1888,-32761,128,0,0
19705 DATA 7,1920,-32737,8160,-8129,16368,-3969,32760,-1793,-4,-769,-4
19706 DATA -897,32760,-1985,16368,-4065,8160,-8185,1920,-32767,259,0,7168
19707 DATA 2560,3072,1024,0,3072,0,22528,0,-23552,0,0,0
19708 DATA 0,42,128,0,2,160,15016,-16384,10,928,-1366,-1024
19709 DATA 42,4000,-1366,-128,42,4000,-1366,-128,10,928,-1366,-1024
19710 DATA 2,160,15016,-16384,0,42,128,0,0,0,0,0
19711 DATA 0,63,16320,-16384,3,1023,-4,-1024,15,4095,-1,-256
19712 DATA 63,16383,-1,-64,-16129,-1,-1,-16,-3841,-1,-1,-16
19713 DATA -4033,16383,-1,-64,-16369,4095,-1,-256,3,1023,-4,-1024
19714 DATA 0,63,16320,-16384,1,262,0,7168,2560,3072,1024,0
19715 DATA 3072,0,22528,0,-23552,0,0,0,0,42,128,0
19716 DATA 2,170,16168,-32768,10,936,-502,-21504,42,4000,-1494,-16512
19717 DATA 42,3968,-5462,-128,10,770,-21590,-1024,2,138,12200,-16384
19718 DATA 0,42,128,0,0,0,0,0,0,63,16320,-16384
19719 DATA 3,1023,-4,-1024,15,4095,-1,-256,63,16383,-1,-64
19720 DATA -16129,-1,-1,-16,-3841,-1,-1,-16,-4033,16383,-1,-64
19721 DATA -16369,4095,-1,-256,3,1023,-4,-1024,0,63,16320,-16384
19722 DATA 1,265,0,7168,2560,3072,1024,0,3072,0,22528,0
19723 DATA -23552,0,0,0,0,42,128,0,2,170,16296,-16384
19724 DATA 10,938,-86,-1024,40,3584,-22014,-21632,40,3584,-22014,-21632
19725 DATA 10,938,-86,-1024,2,170,16296,-16384,0,42,128,0
19726 DATA 0,0,0,0,0,63,16320,-16384,3,1023,-4,-1024
19727 DATA 15,4095,-1,-256,63,16383,-1,-64,-16129,-1,-1,-16
19728 DATA -3841,-1,-1,-16,-4033,16383,-1,-64,-16369,4095,-1,-256
19729 DATA 3,1023,-4,-1024,0,63,16320,-16384,1,268,0,7168
19730 DATA 2560,3072,1024,0,3072,0,22528,0,-23552,0,0,0
19731 DATA 0,42,128,0,2,138,12200,-16384,10,770,-21590,-1024
19732 DATA 42,3968,-5462,-128,42,4000,-1494,-16512,10,936,-502,-21504
19733 DATA 2,170,16168,-32768,0,42,128,0,0,0,0,0
19734 DATA 0,63,16320,-16384,3,1023,-4,-1024,15,4095,-1,-256
19735 DATA 63,16383,-1,-64,-16129,-1,-1,-16,-3841,-1,-1,-16
19736 DATA -4033,16383,-1,-64,-16369,4095,-1,-256,3,1023,-4,-1024
19737 DATA 0,63,16320,-16384,2,8451,0,3584,2560,1536,1024,0
19738 DATA 3072,1,8192,2,13312,0,0,0,0,0,0,0
19739 DATA 0,0,0,0,0,0,0,0,0,0,0,248
19740 DATA 248,248,248,0,0,0,0,0,0,0,0,248
19741 DATA 248,255,-505,-16377,-16129,-264,248,0,0,0,0,0
19742 DATA 248,255,-257,-257,-505,-16377,-16129,-257,-257,-264,0,0
19743 DATA 0,248,255,-257,-257,-257,-505,-16377,-16129,-257,-257,-257
19744 DATA -264,0,0,248,255,-257,-257,-257,-505,-16377,-16129,-257
19745 DATA -257,-257,-264,0,0,0,248,255,-257,-257,-505,-16377
19746 DATA -16129,-257,-257,-264,0,0,0,0,0,248,248,255
19747 DATA -505,-16377,-16129,-264,248,0,0,0,0,0,0,0
19748 DATA 0,248,248,248,248,0,0,0,0,0,0,0
19749 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19750 DATA 0,0,0,0,0,255,-1,-1,-1,-256,0,0
19751 DATA 0,0,0,0,0,255,-1,-1,-1,-1,-1,-1
19752 DATA -1,-256,0,0,0,0,255,-1,-1,-1,-1,-1
19753 DATA -1,-1,-1,-1,-256,0,0,255,-1,-1,-1,-1
19754 DATA -1,-1,-1,-1,-1,-1,-1,-256,255,-1,-1,-1
19755 DATA -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
19756 DATA -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
19757 DATA -256,255,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
19758 DATA -1,-256,0,0,255,-1,-1,-1,-1,-1,-1,-1
19759 DATA -1,-1,-256,0,0,0,0,255,-1,-1,-1,-1
19760 DATA -1,-1,-1,-256,0,0,0,0,0,0,0,255
19761 DATA -1,-1,-1,-256,0,0,0,0,2,8454,0,3584
19762 DATA 2560,1536,1024,0,3072,1,8192,2,13312,0,0,0
19763 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19764 DATA 0,0,0,248,248,248,248,0,0,0,0,0
19765 DATA 0,0,0,248,248,255,-257,-257,-505,-16136,248,0
19766 DATA 0,0,0,0,248,255,-257,-257,-257,-505,-16377,-16377
19767 DATA -16129,-264,0,0,0,248,255,-257,-257,-257,-505,-16377
19768 DATA -16377,-16129,-257,-257,-264,0,0,248,255,-257,-257,-505
19769 DATA -16377,-16377,-16129,-257,-257,-257,-264,0,0,0,248,255
19770 DATA -505,-16377,-16377,-16129,-257,-257,-257,-264,0,0,0,0
19771 DATA 0,248,248,7,-16129,-257,-257,-264,248,0,0,0
19772 DATA 0,0,0,0,0,248,248,248,248,0,0,0
19773 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19774 DATA 0,0,0,0,0,0,0,0,0,255,-1,-1
19775 DATA -1,-256,0,0,0,0,0,0,0,255,-1,-1
19776 DATA -1,-1,-1,-1,-1,-256,0,0,0,0,255,-1
19777 DATA -1,-1,-1,-1,-1,-1,-1,-1,-256,0,0,255
19778 DATA -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-256
19779 DATA 255,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
19780 DATA -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
19781 DATA -1,-1,-1,-1,-256,255,-1,-1,-1,-1,-1,-1
19782 DATA -1,-1,-1,-1,-1,-256,0,0,255,-1,-1,-1
19783 DATA -1,-1,-1,-1,-1,-1,-256,0,0,0,0,255
19784 DATA -1,-1,-1,-1,-1,-1,-1,-256,0,0,0,0
19785 DATA 0,0,0,255,-1,-1,-1,-256,0,0,0,0
19786 DATA 2,8457,0,3584,2560,1536,1024,0,3072,1,8192,2
19787 DATA 13312,0,0,0,0,0,0,0,0,0,0,0
19788 DATA 0,0,0,0,0,0,0,248,248,248,248,0
19789 DATA 0,0,0,0,0,0,0,248,248,255,-257,-257
19790 DATA -257,-264,248,0,0,0,0,0,248,255,-257,-257
19791 DATA -257,-257,-257,-257,-257,-264,0,0,0,248,255,-505
19792 DATA -16377,-16377,-16377,-16377,-16377,-16377,-16377,-16129,-264,0,0,248
19793 DATA 255,-505,-16377,-16377,-16377,-16377,-16377,-16377,-16377,-16129,-264,0
19794 DATA 0,0,248,255,-257,-257,-257,-257,-257,-257,-257,-264
19795 DATA 0,0,0,0,0,248,248,255,-257,-257,-257,-264
19796 DATA 248,0,0,0,0,0,0,0,0,248,248,248
19797 DATA 248,0,0,0,0,0,0,0,0,0,0,0
19798 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19799 DATA 0,255,-1,-1,-1,-256,0,0,0,0,0,0
19800 DATA 0,255,-1,-1,-1,-1,-1,-1,-1,-256,0,0
19801 DATA 0,0,255,-1,-1,-1,-1,-1,-1,-1,-1,-1
19802 DATA -256,0,0,255,-1,-1,-1,-1,-1,-1,-1,-1
19803 DATA -1,-1,-1,-256,255,-1,-1,-1,-1,-1,-1,-1
19804 DATA -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
19805 DATA -1,-1,-1,-1,-1,-1,-1,-1,-256,255,-1,-1
19806 DATA -1,-1,-1,-1,-1,-1,-1,-1,-1,-256,0,0
19807 DATA 255,-1,-1,-1,-1,-1,-1,-1,-1,-1,-256,0
19808 DATA 0,0,0,255,-1,-1,-1,-1,-1,-1,-1,-256
19809 DATA 0,0,0,0,0,0,0,255,-1,-1,-1,-256
19810 DATA 0,0,0,0,2,8460,0,3584,2560,1536,1024,0
19811 DATA 3072,1,8192,0,0,0,0,0,0,0,0,0
19812 DATA 0,0,0,0,0,0,0,0,0,0,0,248
19813 DATA 248,248,248,0,0,0,0,0,0,0,0,248
19814 DATA 248,7,-16129,-257,-257,-264,248,0,0,0,0,0
19815 DATA 248,255,-505,-16377,-16377,-16129,-257,-257,-257,-264,0,0
19816 DATA 0,248,255,-257,-257,-505,-16377,-16377,-16129,-257,-257,-257
19817 DATA -264,0,0,248,255,-257,-257,-257,-505,-16377,-16377,-16129
19818 DATA -257,-257,-264,0,0,0,248,255,-257,-257,-257,-505
19819 DATA -16377,-16377,-16129,-264,0,0,0,0,0,248,248,255
19820 DATA -257,-257,-505,-16136,248,0,0,0,0,0,0,0
19821 DATA 0,248,248,248,248,0,0,0,0,0,0,0
19822 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19823 DATA 0,0,0,0,0,255,-1,-1,-1,-256,0,0
19824 DATA 0,0,0,0,0,255,-1,-1,-1,-1,-1,-1
19825 DATA -1,-256,0,0,0,0,255,-1,-1,-1,-1,-1
19826 DATA -1,-1,-1,-1,-256,0,0,255,-1,-1,-1,-1
19827 DATA -1,-1,-1,-1,-1,-1,-1,-256,255,-1,-1,-1
19828 DATA -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
19829 DATA -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
19830 DATA -256,255,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1
19831 DATA -1,-256,0,0,255,-1,-1,-1,-1,-1,-1,-1
19832 DATA -1,-1,-256,0,0,0,0,255,-1,-1,-1,-1
19833 DATA -1,-1,-1,-256,0,0,0,0,0,0,0,255
19834 DATA -1,-1,-1,-256,0,0,0,0,0,3171,28788,24419
19835 DATA 26994,25439,29552,29185,0,0,512,256,0,0,0,3072
19836 DATA 0,3072,0,3072,0,0,0,1,256,0,1024,256
19837 DATA 0,0,0,3072,0,3072,0,3072,0,0,0,2
19838 DATA 8448,0,512,256,0,0,0,3072,0,3072,0,0
19839 DATA 0,0,0,0,2915,28788,24430,30060,24435,28786,1,0
19840 DATA 0,4608,1792,0,768,0,3072,0,16384,0,29698,512
19841 DATA 0,0,12,3073,384,-32768,60,15366,1536,0,255,-8
19842 DATA -2048,0,60,15366,1536,0,12,3073,384,-32768,2,512
19843 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19844 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19845 DATA 0,0,0,0,0,0,1,256,0,9216,1792,0
19846 DATA 768,0,3072,0,23552,0,-21504,8,3072,0,0,0
19847 DATA 0,160,-4096,2,896,-16384,10,4000,-4096,40,15360,0
19848 DATA 170,-86,-86,-128,-16384,0,10,4000,-4096,40,15360,0
19849 DATA 0,160,-4096,2,896,-16384,0,8,3072,0,0,0
19850 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19851 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19852 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19853 DATA 0,0,0,0,0,0,2,8448,0,4352,1792,0
19854 DATA 768,0,3072,1,1024,0,0,0,0,0,0,0
19855 DATA 255,-512,0,0,0,0,0,0,0,0,0,0
19856 DATA 0,0,0,0,255,-257,-512,0,0,0,0,0
19857 DATA 0,0,0,255,-257,-512,0,0,255,-257,-257,-257
19858 DATA -512,0,0,0,0,0,0,255,-257,-512,0,0
19859 DATA 255,-257,-257,-257,-257,-257,-257,-257,-257,-257,-257,-257
19860 DATA -257,-512,0,0,0,0,0,0,255,-257,-257,-257
19861 DATA -512,0,0,0,0,0,0,255,-257,-512,0,0
19862 DATA 0,0,0,0,255,-257,-512,0,0,0,0,0
19863 DATA 0,0,0,255,-257,-512,0,0,0,0,0,0
19864 DATA 255,-512,0,0,0,0,0,0,0,0,0,0
19865 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19866 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19867 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19868 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19869 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19870 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19871 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19872 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19873 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19874 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19875 DATA 0,0,0,0,0,0,0,3171,28788,24428,25958,29791
19876 DATA 29552,29185,0,0,4608,1792,4096,768,0,3072,0,16384
19877 DATA 0,29696,32,8192,0,192,-16360,6144,0,48,12318,7680
19878 DATA 0,15,4095,-128,-32768,48,12318,7680,0,192,-16360,6144
19879 DATA 0,0,32,8192,0,0,0,0,0,0,0,0
19880 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19881 DATA 0,0,0,0,0,0,0,0,0,1,256,0
19882 DATA 9216,1792,4096,768,0,3072,0,23552,0,-21504,0,8
19883 DATA 3072,0,0,160,-4096,2,896,-16384,0,10,3840,2
19884 DATA 936,-1024,0,0,170,-86,-86,-128,-16384,10,3840,2
19885 DATA 936,-1024,0,160,-4096,2,896,-16384,0,0,0,8
19886 DATA 3072,0,0,0,0,0,0,0,0,0,0,0
19887 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19888 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19889 DATA 0,0,0,0,0,0,0,0,0,2,8448,0
19890 DATA 4352,1792,4096,768,0,3072,1,1024,0,0,0,0
19891 DATA 0,0,0,0,0,0,0,255,-512,0,0,0
19892 DATA 0,0,0,255,-257,-512,0,0,0,0,0,0
19893 DATA 0,0,255,-257,-512,0,0,0,0,0,0,255
19894 DATA -257,-512,0,0,0,0,0,0,255,-257,-257,-257
19895 DATA -512,0,0,0,0,0,0,255,-257,-257,-257,-257
19896 DATA -257,-257,-257,-257,-257,-257,-257,-257,-512,0,0,255
19897 DATA -257,-512,0,0,0,0,0,0,255,-257,-257,-257
19898 DATA -512,0,0,255,-257,-512,0,0,0,0,0,0
19899 DATA 0,0,255,-257,-512,0,0,0,0,0,0,0
19900 DATA 0,0,0,0,0,0,0,255,-512,0,0,0
19901 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19902 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19903 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19904 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19905 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19906 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19907 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19908 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19909 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19910 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19911 DATA 0,0,0,0,0,0,0,0,0,0,3427,28788
19912 DATA 24434,26983,26740,24435,28786,1,0,0,3072,2816,1024,0
19913 DATA 0,3072,0,13312,0,23556,1024,14,3584,31,7936,63
19914 DATA 16256,-32668,25792,-16252,-31712,8196,1024,4,1024,10,2560,17
19915 DATA 4352,32,8320,-32768,0,0,0,0,0,0,0,0
19916 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19917 DATA 0,1,256,0,6144,2816,1024,0,0,3072,0,24576
19918 DATA 0,-19456,32,12288,0,0,168,-1024,0,2,938,-256
19919 DATA 0,10,4010,-128,-16384,40,15392,12448,-4096,128,-16352,12296
19920 DATA 3072,0,32,12288,0,0,32,12288,0,0,136,-13312
19921 DATA 0,2,770,768,0,8,3072,128,-16384,0,0,0
19922 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19923 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19924 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19925 DATA 0,0,0,0,0,2,8448,0,2816,2816,1024,0
19926 DATA 0,3072,1,4096,0,0,0,0,0,0,255,-512
19927 DATA 0,0,0,0,0,0,0,0,0,255,-257,-257
19928 DATA -512,0,0,0,0,0,0,0,255,-257,-257,-257
19929 DATA -257,-512,0,0,0,0,0,255,-257,-257,-257,-257
19930 DATA -257,-257,-512,0,0,0,255,-257,-512,0,255,-512
19931 DATA 0,255,-257,-512,0,255,-512,0,0,0,255,-512
19932 DATA 0,0,0,255,-512,0,0,0,0,0,255,-512
19933 DATA 0,0,0,0,0,0,0,0,0,0,255,-512
19934 DATA 0,0,0,0,0,0,0,0,0,255,-512,255
19935 DATA -512,0,0,0,0,0,0,0,255,-512,0,0
19936 DATA 255,-512,0,0,0,0,0,255,-512,0,0,0
19937 DATA 0,255,-512,0,0,0,0,0,0,0,0,0
19938 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19939 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19940 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19941 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19942 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19943 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19944 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19945 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19946 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19947 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19948 DATA 0,0,0,0,0,0,2659,28788,24437,28767,29552,29185
19949 DATA 0,0,3072,2816,1024,2560,0,3072,0,13312,0,23584
19950 DATA 8320,-32751,4352,10,2560,4,1024,4,1024,132,-31712,8292
19951 DATA 25792,-16321,16256,-32737,7936,14,3584,4,1024,0,0,0
19952 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19953 DATA 0,0,0,0,0,0,0,1,256,0,6144,2816
19954 DATA 1024,2560,0,3072,0,24576,0,-19448,3072,128,-16384,2
19955 DATA 770,768,0,0,136,-13312,0,0,32,12288,0,0
19956 DATA 32,12288,0,128,-16352,12296,3072,40,15392,12448,-4096,10
19957 DATA 4010,-128,-16384,2,938,-256,0,0,168,-1024,0,0
19958 DATA 32,12288,0,0,0,0,0,0,0,0,0,0
19959 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19960 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19961 DATA 0,0,0,0,0,0,0,0,0,0,0,2
19962 DATA 8448,0,2816,2816,1024,2560,0,3072,1,4096,0,0
19963 DATA 0,255,-512,0,0,0,0,255,-512,0,0,0
19964 DATA 0,0,255,-512,0,0,255,-512,0,0,0,0
19965 DATA 0,0,0,255,-512,255,-512,0,0,0,0,0
19966 DATA 0,0,0,0,255,-512,0,0,0,0,0,0
19967 DATA 0,0,0,0,255,-512,0,0,0,0,0,255
19968 DATA -512,0,0,0,255,-512,0,0,0,255,-512,0
19969 DATA 255,-257,-512,0,255,-512,0,255,-257,-512,0,0
19970 DATA 0,255,-257,-257,-257,-257,-257,-257,-512,0,0,0
19971 DATA 0,0,255,-257,-257,-257,-257,-512,0,0,0,0
19972 DATA 0,0,0,255,-257,-257,-512,0,0,0,0,0
19973 DATA 0,0,0,0,255,-512,0,0,0,0,0,0
19974 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19975 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19976 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19977 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19978 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19979 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19980 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19981 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19982 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19983 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19984 DATA 0,0,0,0,0,0,0,0,0,0,0,0
19985 DATA 3171,28788,24420,28535,28255,29552,29439,-1,-256,22320,2609,2605
19986 DATA 12554,12592,12594,2613,12342,2614,2612,2609,2609,2612,2610,12592
19987 DATA 2609,2609,2608,2615,2612,2605,12554,11569,2615,2608,2605,12554
19988 DATA 11569,2608,2615,2605,12554,11569,2609,13877,12852,2609,13876,14390
19989 DATA 2609,13875,14388,2609,12810,30,12298,12598,13618,12298,12598,13366
19990 DATA 14602,12810,12598,2608,2609,2612,2608,2605,12554,127,12810,12848
19991 DATA 2609,13066,12810,12554,12298,12298,12810,13578,12298,12848,2609,13066
19992 DATA 12598,13616,12810,12554,12298,12298,12298,13066,12554,12598,13367,13834
19993 DATA 12595,2610,13322,12554,12298,12298,11569,2616,13066,12810,12554,12298
19994 DATA 12554,12298,11575,2605,12554,11569,2608,2609,13876,12340,2609,12810
19995 DATA 12298,12298,12298,12298,12298,12298,12298,12298,12298,11569,2605,12554
19996 DATA 11569,2560,813,12554,6,11569,2605,12554,0,0,0,0
19997 DATA 57693
20000 REMark ********************
20004 REMark * List of routines *
20008 REMark *     TPTR_BAS     *
20012 REMark *   Version 5.07   *
20016 REMark *    7  MAR 04     *
20020 REMark ********************
20024 :
20028 REMark ***********************************************
20032 REMark * There are three sets of instructions whose  *
20036 REMark * removal reduces TPTR_BAS by about a third.  *
20040 REMark * If any of the sets is not needed in a       *
20044 REMark * program it can be removed as shown here.    *
20048 REMark *                                             *
20052 REMark * The sets are:                               *
20056 REMark * 1. Sprite production (RD_SPRT)              *
20060 REMark * 2. Sleep routines    (Do_Sleep)             *
20064 REMark * 3. Setting a menu    (set_ap)               *
20068 REMark *                                             *
20072 REMark * To remove any simply type:                  *
20076 REMark * 1. Remove_Sprite                            *
20080 REMark * 2. Remove_Sleep                             *
20084 REMark * 3. Remove_Menu                              *
20088 REMark ***********************************************
20092 :
20096 DEFine FuNction max%(a%,b%)
20100  REMark returns the maximum of a%,b%
20104  IF a%>b%:RETurn a%:ELSE RETurn b%
20108 END DEFine
20112 :
20116 DEFine FuNction min%(a%,b%)
20120  REMark returns the minimun of a%,b%
20124  IF a%<b%:RETurn a%:ELSE RETurn b%
20128 END DEFine
20132 :
20136 DEFine PROCedure init
20140  LOCal x,lp
20144  DIM txt%(0),sprt%(0),blob%(0),patt%(0),cm%(8)
20148  DIM f%(0,0),om%(0,0),im(0),act(0),alc_ad(0)
20152  nad%=-1:al_stp%=30
20156  Set_sbp1:addr=set_text
20160  IF ope_fil%
20164   _mli%=Do_Linos%:REMark sets maximum size of loose items status area
20168   INPUT#cm%(0),wm%:DIM wd(wm%):FOR x=0 TO wm%:wd(x)=M_WDEF
20172   init1
20176  ELSE
20180   wrong 1
20184  END IF
20188 END DEFine
20192 :
20196 DEFine FuNction set_text
20200  LOCal ch%,a$(100),len%,num%,x,lp
20204  ch%=N_CHAN%
20208  IF DEVICE_STATUS(1,dv$&'text_list')<0:wrong 3
20212  OPEN_IN#ch%,dv$&'text_list':DIM text$(100,100)
20216  len%=0:num%=-1
20220  REPeat lp
20222   IF EOF(#ch%):EXIT lp
20224   INPUT#ch%,a$
20232   IF LEN(a$)>len%:len%=LEN(a$)
20236   num%=num%+1
20240  END REPeat lp
20244  IF num%=-1:CLOSE#ch%:RETurn 0
20246  len%=max%(2,ev%(len%))
20252  DIM text$(num%,len%)
20256  SET_POSITION#ch%,0
20260  FOR x=0 TO num%:INPUT#ch%,text$(x)
20264  CLOSE#ch%
20268  RETurn m_sext(text$)
20272 END DEFine
20276 :
20280 DEFine PROCedure set_sbp
20284  LOCal _ch%(2),ad%,bd%,x,y,num%,b$(100),lp,sad(2),c$(40)
20288  _ch%(1)=N_CHAN%
20292  lp=DEVICE_STATUS(2,dv$&'tmpo'):lp=(lp>0)*4+(lp<0)*2+(lp=-8)
20296  SELect ON lp
20300   =3:DELETE dv$&'tmpo'
20304   =4:REMark OK
20308   =REMAINDER :wrong 4
20312  END SELect
20316  OPEN_NEW#_ch%(1),dv$&'tmpo'
20320  PRINT#_ch%(1),INTEGER$(0)&INTEGER$(0);:REMark make space for offsets
20324  ad%=4:RESTORE 20464
20328  FOR x=0 TO 2
20332   sad(x)=ad%:bd%=ad%+2
20336   READ c$:_ch%(0)=N_CHAN%
20340   IF DEVICE_STATUS(1,dv$&c$)<0:CLOSE#_ch%(1):wrong 5:ELSE :OPEN_IN#_ch%(0),dv$&c$
20344   num%=0
20348   REPeat lp
20352    IF EOF(#_ch%(0)):CLOSE#_ch%(0):CLOSE#_ch%(1):wrong 6
20356    INPUT#_ch%(0),b$
20360    IF b$="":EXIT lp
20364    num%=num%+1
20368   END REPeat lp
20372   PRINT#_ch%(1),INTEGER$(num%-1);
20376   ad%=ad%+2
20380   IF num%>0
20384    PRINT#_ch%(1),FILL$(" ",num%+num%);
20388    ad%=POSITION(#_ch%(1))
20392    SET_POSITION#_ch%(0),0
20396    FOR y=1 TO num%
20400     SET_POSITION#_ch%(1),bd%
20404     bd%=bd%+2
20408     PRINT #_ch%(1),INTEGER$(ad%-4);
20412     INPUT#_ch%(0),b$
20416     _ch%(2)=F_In(b$)
20420     IF _ch%(2)<0:CLOSE#_ch%(0):CLOSE#_ch%(1):wrong 7
20424     SET_POSITION#_ch%(1),ad%
20428     PRINT#_ch%(1),INPUT$(#_ch%(2),F_Len(_ch%(2)));
20432     CLOSE#_ch%(2):ad%=POSITION(#_ch%(1))
20436    END FOR y
20440   END IF
20444   CLOSE#_ch%(0):DELETE dv$&c$
20448  END FOR x
20452  SET_POSITION#_ch%(1),0:PRINT#_ch%(1),INTEGER$(sad(1)-4)&INTEGER$(sad(2)-4);
20456  CLOSE#_ch%(1)
20460 :
20464  DATA 'sprite_list'
20468  DATA 'blob_list'
20472  DATA 'patt_list'
20476 END DEFine
20480 :
20484 DEFine FuNction set_infl
20488  LOCal x,y,n%
20492  DIM txt%(0),sprt%(0),blob%(0),patt%(0)
20496  INPUT#cm%(3),n%
20500  IF n%<0:RETurn 0
20504  DIM f%(n%,4),im(n%)
20508  FOR y=0 TO n%
20512   FOR x=0 TO 4:INPUT#cm%(3),f%(y,x)
20516   INPUT#cm%(3),im(y)
20520  END FOR y
20524  INPUT#cm%(3),n%
20528  IF n%<0
20532   txt%(0)=0
20536  ELSE
20540   DIM txt%(n%)
20544   FOR x=0 TO n%:INPUT#cm%(3),txt%(x)
20548  END IF
20552  INPUT#cm%(3),n%
20556  IF n%<0
20560   sprt%(0)=0
20564  ELSE
20568   DIM sprt%(n%)
20572   FOR x=0 TO n%:INPUT#cm%(3),sprt%(x)
20576  END IF
20580  INPUT#cm%(3),n%
20584  IF n%<0
20588   blob%(0)=0
20592  ELSE
20596   DIM blob%(n%)
20600   FOR x=0 TO n%:INPUT#cm%(3),blob%(x)
20604  END IF
20608  INPUT#cm%(3),n%
20612  IF n%<0
20616   patt%(0)=0
20620  ELSE
20624   DIM patt%(n%)
20628   FOR x=0 TO n%:INPUT#cm%(3),patt%(x)
20632  END IF
20636  RETurn M_IOL(f%,im,txt%,sprt%,blob%,patt%)
20640 END DEFine
20644 :
20648 DEFine FuNction set_mobj
20652  LOCal x,y,n%
20656  DIM txt%(0),sprt%(0),blob%(0),patt%(0)
20660  INPUT#cm%(7),n%
20664  IF n%<0:RETurn 0:REMark could be "no index"
20668  DIM om%(n%,4)
20672  FOR y=0 TO n%
20676   FOR x=0 TO 4:INPUT#cm%(7),om%(y,x)
20680  END FOR y
20684  INPUT#cm%(7),n%:REMark the number of text items
20688  IF n%<0
20692   txt%(0)=0
20696  ELSE
20700   DIM txt%(n%)
20704   FOR x=0 TO n%:INPUT#cm%(7),txt%(x)
20708  END IF
20712  INPUT#cm%(7),n%:REMark the number of sprite items
20716  IF n%<0
20720   sprt%(0)=0
20724  ELSE
20728   DIM sprt%(n%)
20732   FOR x=0 TO n%:INPUT#cm%(7),sprt%(x)
20736  END IF
20740  INPUT#cm%(7),n%:REMark the number of blob items
20744  IF n%<0
20748   blob%(0)=0
20752  ELSE
20756   DIM blob%(n%)
20760   FOR x=0 TO n%:INPUT#cm%(7),blob%(x)
20764  END IF
20768  INPUT#cm%(7),n%:REMark the number of pattern items
20772  IF n%<0
20776   patt%(0)=0
20780  ELSE
20784   DIM patt%(n%)
20788   FOR x=0 TO n%:INPUT#cm%(7),patt%(x)
20792  END IF
20796  RETurn M_AOL(om%,txt%,sprt%,blob%,patt%)
20800 END DEFine
20804 :
20808 DEFine FuNction set_litm
20812  LOCal x,y,n%,f%(0,0),act(0)
20816  DIM txt%(0),sprt%(0),blob%(0),patt%(0)
20820  INPUT#cm%(2),n%
20824  IF n%<0:RETurn 0
20828  DIM f%(n%,8),act(n%)
20832  FOR y=0 TO n%
20836   FOR x=0 TO 8:INPUT#cm%(2),f%(y,x)
20840   act(y)=M_LACT
20844  END FOR y
20848  INPUT#cm%(2),n%
20852  IF n%<0
20856   txt%(0)=0
20860  ELSE
20864   DIM txt%(n%)
20868   FOR x=0 TO n%:INPUT#cm%(2),txt%(x)
20872  END IF
20876  INPUT#cm%(2),n%
20880  IF n%<0
20884   sprt%(0)=0
20888  ELSE
20892   DIM sprt%(n%)
20896   FOR x=0 TO n%:INPUT#cm%(2),sprt%(x)
20900  END IF
20904  INPUT#cm%(2),n%
20908  IF n%<0
20912   blob%(0)=0
20916  ELSE
20920   DIM blob%(n%)
20924   FOR x=0 TO n%:INPUT#cm%(2),blob%(x)
20928  END IF
20932  INPUT#cm%(2),n%
20936  IF n%<0
20940   patt%(0)=0
20944  ELSE
20948   DIM patt%(n%)
20952   FOR x=0 TO n%:INPUT#cm%(2),patt%(x)
20956  END IF
20960  RETurn M_LIL(f%,act,txt%,sprt%,blob%,patt%)
20964 END DEFine
20968 :
20972 DEFine FuNction g_sbp(u%,i%)
20976  REMark u%=0 for sprite, 1 for blob, 2 for pattern
20980  REMark u%=3 for loose item sprite
20984  REMark i% is the number of item in sad(u%)
20988  REMark this returns the address of the item
20992  IF u%>3 OR u%<0:wrong 9
20996  IF u%=3
21000   IF i%<-1:POKE wst(rept)+(_mli%<57)*(28-(_mli% DIV 2))+36+_mli%+y,-i%-1:RETurn 0
21004   u%=0
21008  END IF
21012  IF i%<0:RETurn 0:REMark no item
21016  IF i%>PEEK_W(sad(u%)):PRINT#0,i%,PEEK_W(sad(u%)):wrong 10
21020  RETurn sad(0)+Real(PEEK_W(sad(u%)+2+i%+i%))
21024 END DEFine
21028 :
21032 DEFine FuNction g_txt(k)
21036  REMark returns the address of text item i%
21040  IF k<0:RETurn 0:REMark no item
21044  IF k>PEEK_W(addr):wrong 11
21048  RETurn addr+k*PEEK_W(addr+2)+4
21052 END DEFine
21056 :
21060 REFERENCE st$(0,0)
21064 DEFine FuNction m_sext(st$)
21068  REMark Returns the address of an area containing
21072  REMark the strings in st$
21076  LOCal adr,n%,m%,x,d,top
21080  REMark "top" is the top of the ALLOCATed area
21084  n%=DIMN(st$,1):m%=DIMN(st$,2)
21088  top=(n%+1)*(m%+2)+4
21092  adr=BALCHP(top):d=adr:top=top+adr
21096  SPOKE_W d,n%
21100  SPOKE_W d,m%+2
21104  FOR x=0 TO n%
21108   SPOKE_W d,LEN(st$(x))
21112   SPOKE$ d,st$(x)
21116  END FOR x
21120  RETurn adr
21124 END DEFine
21128 :
21132 REFERENCE f%(0,0),imod(0),txt%(0),sprt%(0),blob%(0),patt%(0)
21136 DEFine FuNction M_IOL(f%,imod,txt%,sprt%,blob%,patt%)
21140  LOCal adr,n%,x,y,d,s%,b%,p%,type,ptr,t%,top
21144  grub$="M_IOL"
21148  n%=DIMN(f%):s%=0:b%=0:p%=0:t%=0
21152  IF DIMN(f%,2)<>4 OR DIMN(imod)<>n%:wrong 12
21156  top=24*n%+26
21160  adr=BALCHP(top):d=adr:ptr=16*n%+18+adr:top=top+adr
21164  FOR y=0 TO n%
21168   FOR x=0 TO 3:SPOKE_W d,f%(y,x)
21172   SPOKE d,f%(y,4):REMark type
21176   SPOKE d,0:REMark padding
21180   type=f%(y,4)
21184   SELect ON type
21188    =0,2,-100 TO -1:SPOKE_L d,imod(y)
21192    =4:set_adr d,g_sbp(2,imod(y)):SPOKE_W d,0
21196    =6:set_adr d,g_sbp(1,imod(y)):SPOKE_W d,0
21200    =REMAINDER :wrong 13
21204   END SELect
21208 :
21212   SELect ON type
21216    =2:set_adr d,g_sbp(0,SGET%(sprt%,s%))
21220    =4:set_adr d,g_sbp(1,SGET%(blob%,b%))
21224    =6:set_adr d,g_sbp(2,SGET%(patt%,p%))
21228    =0,-100 TO -1:set_adr d,g_txt(SGET%(txt%,t%))
21232    =REMAINDER :wrong 13
21236   END SELect
21240  END FOR y
21244  POKE_W d,-1:REMark mark end
21248  RETurn adr
21252 END DEFine
21256 :
21260 DEFine FuNction M_IWL
21264  LOCal adr,n%,x,y,d,ptr,k%,top
21268  grub$="M_IWL"
21272  INPUT#cm%(1),n%
21276  IF n%<0:RETurn 0
21280  top=22*n%+24:adr=BALCHP(top):d=adr:ptr=adr+18*n%+20
21284  top=top+adr
21288  FOR x=0 TO n%
21292   FOR y=0 TO 7:INPUT#cm%(1),k%:SPOKE_W d,k%
21296   set_adr d,set_infl
21300  END FOR x
21304  POKE_W d,-1:REMark mark end
21308  RETurn adr
21312 END DEFine
21316 :
21320 DEFine FuNction M_WDEF
21324  LOCal adr,n%,k%,x,sze,ptr,wst(0),sz_ad,d,top
21328  grub$="M_WDEF"
21332  REMark Fetch the number of repeated parts of the main window (n%)
21336  REMark and the total number of application windows (k%)
21340  INPUT#cm%(0),n%:INPUT#cm%(0),k%:top=186+_mli%+(90+_mli%)*n%+12*k%
21344  DIM wst(n%)
21348  adr=BALCHP(top):d=adr:top=top+adr
21352  ptr=adr+130+_mli%+(78+_mli%)*n%:FOR x=0 TO n%:wst(x)=adr+62+10*n%+(68+_mli%)*x
21356  FOR x=1 TO 5:INPUT#cm%(0),k%:SPOKE_W d,k%
21360  INPUT#cm%(0),k%:SPOKE_W d,k%-32768:REMark mark new style WDEF
21364  FOR x=1 TO 2:INPUT#cm%(0),k%:SPOKE_W d,k%
21368  INPUT#cm%(0),k%:set_adr d,g_sbp(0,k%)
21372  FOR x=1 TO 4:INPUT#cm%(0),k%:SPOKE_W d,k%
21376  FOR x=1,2:INPUT#cm%(0),k%:set_adr d,g_sbp(x,k%)
21380  FOR x=1,2:INPUT#cm%(0),k%:SPOKE_W d,k%
21384  FOR x=1,2:INPUT#cm%(0),k%:set_adr d,g_sbp(x,k%)
21388  FOR x=1,2:INPUT#cm%(0),k%:SPOKE_W d,k%
21392  FOR x=1,2:INPUT#cm%(0),k%:set_adr d,g_sbp(x,k%)
21396  set_adr d,0:REMark no help
21400  REMark *** Fixed part done ***
21404  FOR rept=0 TO n%
21408   INPUT#cm%(0),k%:SPOKE_W d,k%:INPUT#cm%(0),k%:SPOKE_W d,k%
21412   set_adr d,M_IWL
21416   set_adr d,set_litm
21420   set_adr d,M_AWL
21424  END FOR rept
21428  SPOKE_W d,-1:REMark mark end
21432  POKE_W d,_mli%:REMark set maximium loose item area size
21436 :
21440  REMark Now go through window def
21444  REMark 1. for size
21448  REMark 2. to alter rels to wstat rels
21452 :
21456  d=adr+48
21460  FOR rept=0 TO n%
21464   sze=124:sz_ad=wst(rept)+64+_mli%
21468   do_appl Spr(wd_pappl%+d)
21472   do_litm Spr(wd_plitm%+d)
21476   do_info Spr(wd_pinfo%+d)
21480   SPOKE_L sz_ad,sze
21484   d=d+10
21488  END FOR rept
21492  RETurn adr
21496 END DEFine
21500 :
21504 DEFine PROCedure do_appl(l)
21508  LOCal u,w,lp
21512  IF l
21516   REPeat lp
21520    w=Spr(l):l=l+2:sze=sze+104
21524    IF w=0:EXIT lp
21528    REMark Now do addresses in control section
21532    u=w+wda_blen%
21536    IF PEEK_W(wda_nxsc%+w):ws_rel u:u=u+wda_clen%
21540    IF PEEK_W(wda_nysc%+w):ws_rel u:u=u+wda_clen%
21544    IF PEEK(wda_ext%+w)
21548     POKE wda_ext%+w,0:ws_rel u
21552     sze=sze+72+18*PEEK_W(wda_ncol%+u)+PEEK_W(wda_nrow%+u)*(26+14*PEEK_W(wda_ncol%+u))
21556    END IF
21560   END REPeat lp
21564  END IF
21568 END DEFine
21572 :
21576 DEFine PROCedure do_litm(l)
21580  LOCal lp
21584  IF l
21588   REPeat lp
21592    IF PEEK_W(l)=-1:EXIT lp
21596    sze=sze+22
21600    l=l+18
21604   END REPeat lp
21608  END IF
21612 END DEFine
21616 :
21620 DEFine PROCedure do_info(l)
21624  LOCal v,lp,lp1
21628  IF l
21632   REPeat lp
21636    IF PEEK_W(l)=-1:EXIT lp
21640    sze=sze+22
21644    v=Spr(wdi_pobl%+l)
21648    l=l+18
21652    IF v<>0
21656     REPeat lp1
21660      IF PEEK_W(v)=-1:EXIT lp1
21664      sze=sze+18
21668      v=v+16
21672     END REPeat lp1
21676    END IF
21680   END REPeat lp
21684  END IF
21688 END DEFine
21692 :
21696 REFERENCE om%(0,0),txt%(0),sprt%(0),blob%(0),patt%(0)
21700 DEFine FuNction M_AOL(om%,txt%,sprt%,blob%,patt%)
21704 REMark * om%(n,4)
21708 REMark * x_just   0
21712 REMark * y_just   1
21716 REMark * type     2
21720 REMark * selk     3
21724 REMark * item     4
21728  LOCal x,y,d,adr,ptr,nob%,type,s%,b%,p%,t%,top
21732  grub$="M_AOL"
21736  nob%=DIMN(om%):s%=0:t%=0:b%=0:p%=0:ptr=nob%:top=ptr*18+18
21740  adr=BALCHP(top):ptr=adr+ptr*10+10:d=adr:top=top+adr
21744  FOR y=0 TO nob%
21748   FOR x=0 TO 3:SPOKE d,om%(y,x)
21752   type=om%(y,2)
21756   SELect ON type
21760    =2:set_adr d,g_sbp(0,SGET%(sprt%,s%))
21764    =4:set_adr d,g_sbp(1,SGET%(blob%,b%))
21768    =6:set_adr d,g_sbp(2,SGET%(patt%,p%))
21772    =0,-100 TO -1:set_adr d,g_txt(SGET%(txt%,t%))
21776    =REMAINDER :wrong 15
21780   END SELect
21784   SPOKE_W d,om%(y,4)
21788   set_adr d,M_MACT
21792  END FOR y
21796  RETurn adr
21800 END DEFine
21804 :
21808 DEFine FuNction M_ASL
21812  REMark *  size      0
21816  REMark *  spce      1
21820  LOCal x,y,d,adr,n%,k%,top
21824  INPUT#cm%(6),n%:IF n%<0:wrong 16
21828  top=4*n%+4:adr=BALCHP(top):d=adr:top=top+adr
21832  FOR y=0 TO n%
21836   FOR x=0,1:INPUT#cm%(6),k%:SPOKE_W d,k%
21840  END FOR y
21844  RETurn adr
21848 END DEFine
21852 :
21856 DEFine FuNction M_CDEF
21860  REMark *  spos      0
21864  REMark *  sstt      1
21868  REMark *  ssiz      2
21872  LOCal x,y,d,adr,n%,k%,top
21876  INPUT#cm%(5),n%:IF n%<0:RETurn 0
21880  top=6*n%+8:adr=BALCHP(top):d=adr:top=top+adr
21884  SPOKE_W d,1:REMark 29/02/04  n%+1 -> 1
21888  FOR y=0 TO n%
21892   FOR x=0 TO 2:INPUT#cm%(5),k%:SPOKE_W d,k%
21896  END FOR y
21900  RETurn adr
21904 END DEFine
21908 :
21912 DEFine FuNction M_RWL(l)
21916  REMark *  rows      0
21920  REMark *  rowe      1
21924  REMark at entry y=address of object list
21928  LOCal x,y1,d,adr,ptr,n%,k,top
21932  grub$="M_RWL"
21936  INPUT#cm%(8),n%
21940  ptr=n%:top=12*ptr+12:adr=BALCHP(top):d=adr:ptr=adr+ptr*4+4:top=top+adr
21944  FOR y1=0 TO n%
21948   FOR x=0,1:INPUT#cm%(8),k:set_adr d,l+10*k
21952  END FOR y1
21956  RETurn adr
21960 END DEFine
21964 :
21968 DEFine FuNction M_APPW
21972  LOCal af%(12),x,y,d,adr,ptr,mst,k%,mf%(17),pf%(1,10),top
21976  grub$="M_APPW"
21980  FOR x=0 TO 12:INPUT#cm%(4),af%(x)
21984  d=32:y=20:mst=0
21988  FOR x=9,10
21992   IF af%(x)
21996    d=d+24:y=y+12
22000    FOR ptr=0 TO 10:INPUT#cm%(4),pf%(x-9,ptr)
22004   END IF
22008  END FOR x
22012  IF af%(12)
22016   FOR x=0 TO 17:INPUT#cm%(4),mf%(x)
22020   d=d+48:y=y+24:mst=d
22024   d=d+mf%(14)*mf%(15): REMark size of status block
22028   IF d&&1:d=d+1
22032  END IF
22036  ptr=d:top=d+y:adr=BALCHP(top):top=top+adr
22040  mst=mst+adr:ptr=ptr+adr:d=adr
22044  FOR x=0 TO 7:SPOKE_W d,af%(x)
22048  set_adr d,g_sbp(0,af%(8))
22052  set_adr d,0
22056  IF af%(12):set_adr d,M_MDRW:ELSE set_adr d,0
22060  set_adr d,M_MHIT
22064  IF af%(9) OR af%(10):set_adr d,ACR:ELSE set_adr d,0
22068  FOR x=9,10:SPOKE_W d,af%(x)
22072  SPOKE d,af%(11):SPOKE d,af%(12)
22076  FOR y=0,1
22080   IF af%(9+y)
22084    set_adr d,M_CDEF
22088    FOR x=0 TO 5:SPOKE_W d,pf%(y,x)
22092    FOR x=1,2:set_adr d,g_sbp(x,pf%(y,x+5))
22096    FOR x=8 TO 10:SPOKE_W d,pf%(y,x)
22100   END IF
22104  END FOR y
22108  IF af%(12)
22112   set_adr d,mst:mst=adr+18:set_adr mst,M_LMEN
22116   FOR x=0 TO 3:SPOKE_W d,mf%(x)
22120   FOR x=1,2:set_adr d,g_sbp(x,mf%(x+3))
22124   FOR x=6,7:SPOKE_W d,mf%(x)
22128   FOR x=1,2:set_adr d,g_sbp(x,mf%(x+7))
22132   FOR x=10,11:SPOKE_W d,mf%(x)
22136   FOR x=1,2:set_adr d,g_sbp(x,mf%(x+11))
22140   FOR x=14 TO 17:SPOKE_W d,mf%(x)
22144   FOR x=1,2:set_adr d,M_ASL
22148   FOR x=1,2:set_adr d,set_mobj:REMark to get INDEX lists
22152   set_adr d,M_RWL(set_mobj)
22156  END IF
22160  RETurn adr
22164 END DEFine
22168 :
22172 DEFine FuNction M_AWL
22176  LOCal adr,ptr,ax,d,n%,k%,top
22180  grub$="M_AWL"
22184  INPUT#cm%(4),n%:IF n%<0:RETurn 0
22188  REMark DIM aptr(n%)
22192  ptr=n%:top=6*ptr+8:adr=BALCHP(top):top=top+adr
22196  ptr=adr+ptr*2+4:d=adr
22200  FOR ax=0 TO n%:set_adr d,M_APPW
22204  SPOKE_W d,0: REMark mark end
22208  RETurn adr
22212 END DEFine
22216 :
22220 REFERENCE f%(0,0),act(0),txt%(0),sprt%(0),blob%(0),patt%(0)
22224 DEFine FuNction M_LIL(f%,act,txt%,sprt%,blob%,patt%)
22228  LOCal adr,n%,x,y,d,ptr,s%,b%,p%,t%,top
22232  n%=DIMN(f%):s%=0:b%=0:p%=0:t%=0
22236  IF DIMN(act)<>n%:wrong 17
22240  ptr=n%:top=26*ptr+28:adr=BALCHP(top):top=top+adr
22244  ptr=adr+ptr*18+20:d=adr
22248  FOR y=0 TO n%
22252   FOR x=0 TO 3:SPOKE_W d,f%(y,x)
22256   FOR x=4 TO 7:SPOKE d,f%(y,x)
22260   type=f%(y,6)
22264   grub$="M_LIL - "&type
22268   SELect ON type
22272    =2:set_adr d,g_sbp(3,SGET%(sprt%,s%))
22276    =4:set_adr d,g_sbp(1,SGET%(blob%,b%))
22280    =6:set_adr d,g_sbp(2,SGET%(patt%,p%))
22284    =0,-100 TO -1:set_adr d,g_txt(SGET%(txt%,t%))
22288    =REMAINDER :wrong 8
22292   END SELect
22296   SPOKE_W d,f%(y,8)
22300   grub$="M_LIL - 15680"
22304   set_adr d,act(y)
22308  END FOR y
22312  SPOKE_W d,-1:REMark mark end
22316  RETurn adr
22320 END DEFine
22324 :
22328 REFERENCE address
22332 DEFine PROCedure SPOKE_W(address,item%)
22336  IF address+2>top:PRINT#0,"SPOKE_W would overrun "&grub$:Stip
22340  POKE_W address,item%:address=address+2
22344 END DEFine
22348 :
22352 REFERENCE address
22356 DEFine PROCedure SPOKE$(address,item$)
22360  IF LEN(item$)+address>top:PRINT#0,"SPOKE$ would overrun "&grub$:Stip
22364  POKE$ address,item$:address=address+m%
22368 END DEFine
22372 :
22376 REFERENCE address
22380 DEFine PROCedure SPOKE_L(address,item)
22384  IF address+4>top:PRINT#0,"SPOKE_L would overrun "&grub$:Stip
22388  POKE_L address,item:address=address+4
22392 END DEFine
22396 :
22400 REFERENCE address
22404 DEFine PROCedure SPOKE(address,item%)
22408  IF address+1>top:PRINT#0,"SPOKE would overrun "&grub$:Stip
22412  REMark IF address+1>top:PRINT#0,"SPOKE would overrun "&grub$:Stip
22416  POKE address,item%:address=address+1
22420 END DEFine
22424 :
22428 REFERENCE wher%,thing%(0)
22432 DEFine FuNction SGET%(thing%,wher%)
22436  LOCal ans%
22440  ans%=thing%(wher%):wher%=wher%+1
22444  RETurn ans%
22448 END DEFine
22452 :
22456 DEFine FuNction Spr(pr)
22460  REMark Gets true address from address of pointer
22464  LOCal v
22468  v=PEEK_W(pr)
22472  IF v=0:RETurn v
22476  IF v&&1
22480   v=v-1+pr
22484   RETurn PEEK_L(v)+v
22488  ELSE
22492   RETurn PEEK_W(pr)+pr
22496  END IF
22500 END DEFine
22504 :
22508 DEFine PROCedure ws_rel(ad)
22512  LOCal a1,a2,ead
22516  a1=Spr(ad):ead=ad
22520  a2=a1-wst(rept)
22524  IF a2<32768 AND a2>-32768
22528   POKE_W ead,a2
22532  ELSE
22536   a2=ptr-wst(rept)
22540   IF a2<32768 AND a2>-32768
22544    POKE_W ead,a2+1
22548    SPOKE_L ptr,a1-ptr
22552   ELSE
22556    wrong 14
22560   END IF
22564  END IF
22568 END DEFine
22572 :
22576 DEFine PROCedure wrong(j%)
22580  LOCal x,a$(60)
22584  IF j%<1 OR j%>18:j%=2
22588  RESTORE 22644:FOR x=1 TO j%:READ a$
22592  x=j%
22596  SELect ON x
22600   =1:a$=a$&dv$&"f.."
22604   =3:a$=a$&dv$&"text_list"
22608   =4:a$=a$&dv$&"tmpo"
22612   =5,6:a$=a$&dv$&c$
22616   =7:a$=a$&b$
22620  END SELect
22624  PRINT#0,a$
22628  BRECHP
22632  SUSPEND_TASK 300:STOP
22636 END DEFine
22640 :
22644 DATA "Can't open the files ","":            REMark 1 & 2
22648 DATA "Can't open the file ":                REMark 3
22652 DATA "Can't open the file ":                REMark 4
22656 DATA "Can't open the file ":                REMark 5
22660 DATA "There is a fault in file ":           REMark 6
22664 DATA "Can't open the file ":                REMark 7
22668 DATA "Faulty type in M_LIL":                REMark 8
22672 DATA "Faulty parameter in g_sbp":           REMark 9
22676 DATA "Wrong number for sprite/blob/pattern":REMark 10
22680 DATA "Wrong number for text item":          REMark 11
22684 DATA "Faulty parameter for M_IOL":          REMark 12
22688 DATA "Faulty type in M_IOL":                REMark 13
22692 DATA "Faulty address in ws_rel":            REMark 14
22696 DATA "Faulty type in M_AOL":                REMark 15
22700 DATA "Faulty parameter for M_ASL":          REMark 16
22704 DATA "Faulty parameter for M_LIL":          REMark 17
22706 DATA "f.. length over 98302":               REMark 18
22708 :
22712 REFERENCE wher
22716 DEFine PROCedure set_adr(wher,thing)
22720  LOCal v
22724  IF thing=0:v=0:ELSE :v=thing-wher
22728  IF v<32768 AND v>=-32768
22732   SPOKE_W wher,v
22736  ELSE
22740   SPOKE_W wher,ptr-wher+1
22744   SPOKE_L ptr,thing-ptr
22748  END IF
22752 END DEFine
22756 :
22760 DEFine FuNction get_x%(d)
22764  RETurn INT(d/2^16)
22768 END DEFine
22772 :
22776 DEFine FuNction get_y%(d)
22780  RETurn h_cor%( d-2^16*get_x%(d))
22784 END DEFine
22788 :
22792 DEFine FuNction h_cor%(an)
22796  IF an>32767:RETurn an-65536
22800  RETurn an
22804 END DEFine
22808 :
22812 DEFine PROCedure init1
22816  LOCal x
22820  FOR x=0 TO 8:IF cm%(x):CLOSE#cm%(x)
22824  init2
22828 END DEFine
22832 :
22836 DEFine PROCedure init2
22840  LOCal x,b$(32)
22844  RESTORE 23336
22848  FOR x=1 TO 12:READ b$:DELETE dv$&b$
22852 END DEFine
22856 :
22860 DEFine FuNction BALCHP(n)
22864  REMark returns the address of ALLOCATION'd area of n bytes
22868  REMark Also keeps a count of these addresses
22872  REMark and puts the addresses in the array alc_ad
22876  LOCal ad,arr(0),x,y
22880  y=DIMN(alc_ad)
22884  nad%=nad%+1
22888  IF nad%>y
22892   IF NOT COMPILED:DIM arr(y):FOR x=0 TO y:arr(x)=alc_ad(x)
22896   DIM alc_ad(y+al_stp%)
22900   IF NOT COMPILED:FOR x=0 TO y:alc_ad(x)=arr(x)
22904  END IF
22908  ad=ALLOCATION(n)
22912  alc_ad(nad%)=ad
22916  RETurn ad
22920 END DEFine
22924 :
22928 DEFine PROCedure BRECHP
22932  REMark Returns all ALLOCATION'd areas to the heap
22936  LOCal x
22940  IF nad%<0:RETurn
22944  FOR x=nad% TO 0 STEP -1:IF alc_ad(x):DEALLOCATE(alc_ad(x))
22948  DIM alc_ad(0):nad%=-1
22952 END DEFine
22956 :
22960 DEFine FuNction ev%(s%)
22964  REMark makes s% even
22968  RETurn (s%&&1)+s%
22972 END DEFine
22976 :
22980 DEFine FuNction addr_litm(wwd)
22984  REMark returns the address of the loose item status list
22988  REMark for window wwd
22992  LOCal ad
22996  ad=PEEK_L(wwd)
23000  IF ad:ad=ad+64
23004  RETurn ad
23008 END DEFine
23012 :
23016 DEFine FuNction addr_appw(aw%,wwd)
23020  REMark returns the address of the menu status block
23024  REMark for application window number aw% (0, 1 ..)
23028  REMark wwd is the address of the working definition
23032  REMark If there are less than aw% + 1 windows 0 is returned
23036  IF PEEK_W(110+wwd)<=aw%:RETurn 0
23040  RETurn PEEK_L(PEEK_L(PEEK_L(112+wwd)+4*aw%)+100)
23044 END DEFine
23048 :
23052 REFERENCE ni%(0)
23056 DEFine PROCedure S_MDRAW(ni%,ai%,st%,wwd,o%)
23060  REMark Sets the menu items numbers in ni% to the status st%
23064  REMark in application window ai%. wwd is the address of the working definition
23068  REMark if o%<>0 the items are selectively redrawn
23072  LOCal x,d%,ms,mx%,mb
23076  IF NOT (st%=0 OR st%=16 OR st%=128):RETurn
23080  ms=addr_appw(ai%,wwd):IF NOT ms:RETurn
23084  mb=PEEK_L(PEEK_L(112+wwd)+4*ai%)
23088  mx%=PEEK_W(144+mb)*PEEK_W(146+mb)
23092  d%=DIMN(ni%)
23096  IF o%
23100   FOR x=0 TO d%:IF NOT ni%(x)>mx%:POKE ms+ni%(x),st%+1
23104   M_ADRW ai%,wwd
23108  END IF
23112  FOR x=0 TO d%:IF NOT ni%(x)>mx%:POKE ms+ni%(x),st%
23116 END DEFine
23120 :
23124 DEFine PROCedure g_mxw
23128  REMark To set max_x% & max_y%
23132  LOCal mxx
23136  mxx=W_MAX:_max_x%=get_x%(mxx):_max_y%=get_y%(mxx)
23140 END DEFine
23144 :
23152 DEFine FuNction fcomb%(o%)
23156  REMark ******************************************
23160  REMark * to combine/separate f.. and _list      *
23164  REMark * files to/from dv$&'_f'                 *
23168  REMark * If o% = 0  - do "set_sbp" then combine *
23172  REMark * If o% = -1 - just combine              *
23176  REMark * If o% = 1  - separate                  *
23180  REMark * This returns 1 if no error else 0      *
23184  REMark ******************************************
23188  LOCal ch%,ch1%,b$(16),x,y,devl,_bg,_k,_r,_rl
23192  RESTORE 23336
23196  ch%=N_CHAN%
23200  IF o%=1
23204   REMark * separate files  *
23208   IF DEVICE_STATUS(1,dv$&'f')<0:RETurn 0
23212   OPEN_IN#ch%,dv$&'f':ch1%=N_CHAN%
23216   FOR x=1 TO 11
23228    READ b$
23232    devl=DEVICE_STATUS(2,dv$&b$):devl=(devl=-8)+(devl<0)*2+(devl>0)*4
23236    SELect ON devl
23240     =3:DELETE dv$&b$
23244     =4:REMark OK
23248     =REMAINDER : CLOSE#ch%:RETurn 0
23252    END SELect
23253    _rl=GET%(#ch%):_bg=Real(_rl):_k=INT(_bg/32000):_r=_bg-32000*_k
23256    OPEN_NEW#ch1%,dv$&b$
23258    IF _k:FOR y=1 TO _k: PRINT#ch1%,INPUT$(#ch%,32000);
23260    IF _r:PRINT#ch1%,INPUT$(#ch%,_r);
23262    CLOSE#ch1%
23264   END FOR x
23268  ELSE
23272   REMark * combine files   *
23276   IF DEVICE_STATUS(0,dv$&'f')<0:RETurn 0
23280   DELETE dv$&'f':OPEN_NEW#ch%,dv$&'f'
23284   IF o%=0:set_sbp:REMark sets dv$&tmpo
23288   RESTORE 23336:ch1%=N_CHAN%
23292   FOR x=1 TO 11
23296    READ b$
23300    IF DEVICE_STATUS(1,dv$&b$)<0:CLOSE#ch%:RETurn 0
23304    OPEN_IN#ch1%,dv$&b$
23306    _bg=F_Len(ch1%):_k=INT(_bg/32000):_r=_bg-32000*_k
23307    PRINT#ch%,INTEGER$(Dereal%(_bg));
23309    IF _k:FOR y=1 TO _k: PRINT#ch%,INPUT$(#ch1%,32000);
23310    IF _r:PRINT#ch%,INPUT$(#ch1%,_r);
23311    IF _bg>32767:IF _r&&1:PRINT#ch%
23312    CLOSE#ch1%
23316   END FOR x
23320  END IF
23324  CLOSE#ch%:RETurn 1
23328 END DEFine
23332 :
23336  DATA 'text_list','tmpo'
23340  DATA 'fwd','fiw','fli','fio','fap','fcd','fas','fao','frw','f'
23344 :
23348 DEFine FuNction ope_fil%
23352  REMark to set cm%() -> f..
23356  LOCal lp,lp1,x%,a$(4),good%
23360  RESTORE 23424:good%=0:x%=0
23364  REPeat lp
23368   READ a$
23372   IF a$="":good%=1:EXIT lp
23376   cm%(x%)=N_CHAN%
23380   IF DEVICE_STATUS(1,dv$&a$)<0:EXIT lp
23384   OPEN_IN#cm%(x%),dv$&a$
23388   x%=x%+1
23392  END REPeat lp
23396  IF NOT good% AND x%
23400   REPeat lp1
23404    x%=x%-1:CLOSE#cm%(x%)
23408    IF x%=0:EXIT lp1
23412   END REPeat lp1
23416  END IF
23420  RETurn good%
23424  DATA 'fwd','fiw','fli','fio','fap','fcd','fas','fao','frw',''
23428 END DEFine
23432 :
23436 DEFine PROCedure Set_Spor
23440  REMark To set the standard sprite origins for "wr_spr"
23444  LOCal x
23448  DIM _spor%(1,7):RESTORE 23456
23452  FOR x=0 TO 7:READ _spor%(0,x),_spor%(1,x)
23456  DATA 3,5,8,7,8,6,8,6,6,6,6,6,8,6,8,6
23460 END DEFine
23464 :
23468 DEFine FuNction F_Loader(a$)
23472  REMark This loads the window definition.
23476  REMark If successful returns 1:else 0.
23480  REMark If a$ = "" - the info comes from DATA @ 19600
23484  REMark otherwise the info comes from the file  ram1_a$_WDA
23488  REMark dv$ is set to a unique file name in ram1
23492  LOCal xx,y%,out%,l,m%,bln$(4000),ch%
23496  out%=Set_Dv%:ch%=0:REMark dv$ is set and out% is the channel to dv$&"f"
23500  IF out%<0:RETurn 0
23504  IF a$<>"": Prepare_Bas: ELSE :RESTORE 19600
23508  IF ch%<0:CLOSE#out%:DELETE dv$&'f':RETurn 0
23512  xx=-1:l = B_Read:IF l=4.3:CLOSE#out%:DELETE dv$&'f':IF ch%:CLOSE#ch%:RETurn 0
23516  IF l=0
23520   CLOSE#out%:DELETE dv$&'f':IF ch%<>0:CLOSE#ch%
23524   RETurn 0
23528  END IF
23532  xx=0:m%=l-2*INT(l/2)
23536  l=INT(l/2):sum=0
23540  FOR xx=1 TO l:y%=B_Read:PRINT#out%,INTEGER$(y%);:sum=Sqz(sum+y%)
23544  IF m%:y%=B_Read:PRINT#out%,Secd$(INTEGER$(y%));:sum=sum+y%
23548  xx=-1:checksum=B_Read:IF ch%:CLOSE#ch%
23552  IF sum-checksum:CLOSE#out%:DELETE dv$&'f':RETurn 0
23556  CLOSE#out%:RETurn fcomb%(1)
23560 END DEFine
23564 :
23568 DEFine FuNction Secd$(a$)
23572  RETurn a$(2)
23576 END DEFine
23580 :
23584 DEFine FuNction Sqz(xx)
23588  IF xx<-66000:RETurn xx+66000
23592  IF xx>66000:RETurn xx-66000
23596  RETurn xx
23600 END DEFine
23604 :
23608 DEFine FuNction B_Read
23612  REMark to return the next DATA item
23616  REMark From DATA if a$="" else from channel ch%
23620  LOCal oo%,ans$(10),hhh
23624  IF a$="":READ hhh:RETurn hhh
23628  IF bln$="":IF EOF(#ch%):RETurn 4.3:ELSE :INPUT#ch%,bln$:bln$=bln$("DATA" INSTR bln$+4 TO)
23632  oo%=',' INSTR bln$
23636  IF oo%
23640   ans$=bln$(1 TO oo%-1):bln$=bln$(oo%+1 TO)
23644  ELSE
23648   ans$=bln$:bln$=""
23652  END IF
23656  RETurn _Num(ans$)
23660 END DEFine
23664 :
23668 DEFine PROCedure Prepare_Bas
23672  LOCal b$(12)
23676  REMark To open the _WDA file to channel ch%
23680  ch%=N_CHAN%
23684  IF DEVICE_STATUS(1,"ram1_"&a$&"_WDA")<0:ch%=-1:ELSE : OPEN_IN#ch%,"ram1_"&a$&"_WDA"
23688  bln$="":IF ch%=-1:RETurn
23692  IF F_Len(ch%)<11:CLOSE#ch%:ch%=-1:RETurn
23696  b$=INPUT$(#ch%,11):IF NOT b$=="19600 DATA ":CLOSE#ch%:ch%=-1:RETurn
23700  SET_POSITION#ch%,0
23704 END DEFine
23708 :
23712 DEFine PROCedure Set_Hex(a$,o%)
23716  REMark to set the HEX from dv$&'f..' to a$_WDA
23720  REMark if o% = -1 tmpo is used. If o% = 0 sprite_list etc
23724  LOCal in%,out%,l,line%,ct%,b$(2),c$(6),wd%,xx,m%,lx%
23728  IF a$="":RETurn
23732  IF NOT fcomb%(o%): PRINT#0, "Can't set 'f' file":Stip
23736  in%=N_CHAN%
23740  IF DEVICE_STATUS(1,dv$&'f')<0:PRINT#0, "Can't open "&dv$&'f':Stip
23744  OPEN_IN#in%,dv$&'f'
23748  out%=N_CHAN%
23752  l=DEVICE_STATUS(2,"ram1_"&a$&"_WDA"):l=(l=-8)+(l<0)*2+(l>0)*4
23756  SELect ON l
23760   =3:DELETE "ram1_"&a$&"_WDA"
23764   =4:REMark OK
23768   =REMAINDER :  PRINT#0,"Can't open "&a$&"_WDA":CLOSE#in%:DELETE dv$&'f':Stip
23772  END SELect
23776  OPEN_NEW#out%,"ram1_"&a$&"_WDA"
23780  l=F_Len(in%)
23784  lx%=max%(8,INT((l+795)/796)):REMark lx% is set so that _WDA lines are < 20000
23788  m%=l-2*INT(l/2)
23792  line%=19600:PRINT#out%,line%&" DATA "&l
23796  l=INT(l/2):sum=0:line%=line%+1:ct%=0:b$=",":c$=" DATA "
23800  FOR xx =1 TO l:wd%=GET%(#in%):sum=Sqz(sum+wd%):iput
23804  IF m%:wd%=CODE(INPUT$(#in%,1)):sum=sum+wd%:iput
23808  IF ct%:PRINT#out%,CHR$(10);
23812  PRINT#out%,line%&c$&sum
23816  CLOSE#in%:CLOSE#out%:init2
23820 END DEFine
23824 :
23828 DEFine PROCedure iput
23832  LOCal a$(100)
23836  IF ct%:a$=b$:ELSE a$=line%&c$:line%=line%+1
23840  a$=a$&wd%:ct%=ct%+1
23844  IF ct%=lx%:a$=a$&CHR$(10):ct%=0
23848  PRINT#out%,a$;
23852 END DEFine
23856 :
23860 DEFine PROCedure Stip
23864  IF COMPILED: SUSPEND_TASK 100
23868  STOP
23872 END DEFine
23876 :
23880 DEFine PROCedure Set_PD_Def
23884  REMark To set the defaults for data and prog in d_data$ and d_prog&
23888  REMark from the command string
23892  REMark The defaults are set by -d or -p followed immediately by the directory
23896  REMark Eg -dflp1_sprite
23900  LOCal a$(256),o%
23904  DIM d_prog$(40),d_data$(40)
23908  a$=OPTION_CMD$
23912  IF a$="":RETurn :REMark Nothing to do
23916  o%="-p" INSTR a$
23920  IF o%:d_prog$=Complete$(a$(o%+2 TO))
23924  o%="-d" INSTR a$
23928  IF o%:d_data$=Complete$(a$(o%+2 TO))
23932 END DEFine
23936 :
23940 DEFine FuNction Complete$(a$)
23944  LOCal o%,b$(40)
23948  b$=a$
23952  o%=' ' INSTR b$
23956  IF o%:b$=b$(1 TO o%-1)
23960  IF b$(LEN(b$))="_":RETurn b$:ELSE RETurn b$&"_"
23964 END DEFine
23968 :
23972 DEFine FuNction D_Test$(a$)
23976  REMark Returns  a$, d_data$&a$ or DATAD$&a$ if these can be opened, else ""
23980  LOCal b$(42)
23984  IF DEVICE_STATUS(1,a$)>0:RETurn a$
23988  IF d_data$<>"":IF DEVICE_STATUS(1,d_data$&a$)>0:RETurn d_data$&a$
23992  b$=G_Dflt$('d')&a$
23996  IF DEVICE_STATUS(1,b$)>0:RETurn b$
24000  RETurn ""
24004 END DEFine
24008 :
24012 DEFine FuNction P_Test(a$)
24016  REMark Returns 1 if a$,PROGD$&a$ or 2 if d_prog$&a$ can be opened else 0
24020  IF DEVICE_STATUS(1,a$)>0:RETurn 1
24024  IF d_prog$<>"":IF DEVICE_STATUS(1,d_prog$&a$)>0:RETurn 2
24028  IF DEVICE_STATUS(1,G_Dflt$('p')&a$)>0:RETurn 1
24032  RETurn 0
24036 END DEFine
24040 :
24044 DEFine FuNction F_In(a$)
24048  REMark Returns a channel opened to a$, DATAD$&a$ or d_data$&a$ or error
24052  LOCal ch%,b$(42)
24056  ch%=N_CHAN%
24060  b$= D_Test$(a$):IF b$="":RETurn -1
24064  OPEN_IN#ch%,b$
24068  RETurn ch%
24072 END DEFine
24076 :
24080 DEFine PROCedure Wclose(ch%)
24084  LOCal pum
24088  pum=ch%
24092  SELect ON pum
24096   =3 TO 31:CLOSE#ch%
24100  END SELect
24104 END DEFine
24108 :
24112 DEFine FuNction Set_Dv%
24116  REMark Sets dv$ and returns the channel for dv$_f
24120  LOCal a$(42),x,ch%
24124  a$="ram1_f#*":ch%=-1
24128  FOR x=65 TO 122
24132   IF DEVICE_STATUS(2,a$&CHR$(x)&"_f")>0:ch%=N_CHAN%:OPEN_NEW#ch%,a$&CHR$(x)&"_f":EXIT x
24136  END FOR x
24140  IF ch%>0:DIM dv$(32):dv$=a$&CHR$(x)&"_"
24144  RETurn ch%
24148 END DEFine
24152 :
24156 DEFine PROCedure Set_sbp1
24160  LOCal ch%,a$(2),x,top,_k,_r,_st,m%
24164  DIM sad(2):ch%=N_CHAN%:grub$="Set_sbp"
24168  IF DEVICE_STATUS(1,dv$&'tmpo')<0:wrong 4
24172  OPEN_IN#ch%,dv$&'tmpo'
24174  top=F_Len(ch%)-4:_k=INT(top/32000):_r=top-32000*_k
24180  st=BALCHP(top):top=top+st:sad(0)=st
24184  FOR x=1,2:sad(x)=st+GET%(#ch%)
24186  IF _k:m%=32000:FOR x=1 TO _k:SPOKE$ st,INPUT$(#ch%,32000)
24188  m%=_r:SPOKE$ st,INPUT$(#ch%,_r)
24196  CLOSE#ch%
24200 END DEFine
24204 :
24208 DEFine FuNction Set_Win
24212  REMark To set up the window definition from DATA
24216  REMark If successful this returns 1: else 0
24220  IF NOT F_Loader(""):RETurn 0
24224  init:REMark if this goes wrong the program halts
24228  RETurn 1
24232 END DEFine
24236 :
24244 DEFine FuNction F_Len(chan%)
24248  LOCal pos,l
24252  pos=POSITION(#chan%)
24256  SET_POSITION#chan%,1.6E6
24260  l=POSITION(#chan%):SET_POSITION#chan%,pos
24264  RETurn l
24268 END DEFine
24272 :
24276 DEFine FuNction F_Size(a$)
24280  LOCal l,chan%
24284  chan%=N_CHAN%:OPEN_IN#chan%,a$
24288  SET_POSITION#chan%,1.6E6
24292  l=POSITION(#chan%):CLOSE#chan%
24296  RETurn l
24300 END DEFine
24304 :
24308 DEFine FuNction G_Dflt$(a$)
24312  REMark This gets PROGD$ for a$=p else DATAD$
24316  LOCal adr,num
24320  IF a$=='p':num=172:ELSE num=176
24324  adr=PEEK_L(SYS_VARS+num)
24328  IF adr=0:RETurn ""
24332  RETurn PEEK$(adr+2,PEEK_W(adr))
24336 END DEFine
24340 :
24344 DEFine FuNction _Num(a$)
24348  LOCal l1,s,x,z,k
24352  l1=LEN(a$):s=0:k=0
24356  IF l1=0:RETurn 0
24360  IF a$(1)=" ":RETurn _Num(a$(2 TO l1))
24364  IF a$(1)="-":s=1
24368  IF l1-s=0 OR l1-s>6:RETurn 0
24372  FOR x=s+1 TO l1
24376   z=CODE(a$(x))-CODE('0')
24380   SELect ON z
24384    =0 TO 9:k=k*10+z
24388    =REMAINDER :RETurn 0
24392   END SELect
24396  END FOR x
24400  IF s:k=-k
24404  IF xx<>-1:IF k<-32768 OR k>32767:RETurn 0
24408  RETurn k
24412 END DEFine
24416 :
24420 DEFine FuNction Do_Linos%
24424  REMark To find the maximum number of loose items
24428  REMark in any window
24432  LOCal x,y,lp,o%,o1%,n%,a$(20)
24436  USE cm%(2):o1%=-1
24440  REPeat lp
24444   IF EOF(#cm%(2)):EXIT lp
24446   INPUT a$:IF a$="":EXIT lp:ELSE :n%=a$
24448   IF n%>o1%:o1%=n%
24452   IF n%<0:NEXT lp
24456   FOR x=0 TO n%
24460    FOR y=0 TO 8:INPUT o%
24464   END FOR x
24468   FOR x=0 TO 3
24472    INPUT n%:IF n%>-1:FOR y=0 TO n%:INPUT o%
24476   END FOR x
24480  END REPeat lp
24484  USE:SET_POSITION #cm%(2),0
24488  IF o1%<27:RETurn 2*o1%+2:ELSE : RETurn o1%+29
24492 END DEFine
24496 :
24500 DEFine FuNction Real(o%)
24504  LOCal k
24508  IF o%>=0:RETurn o%
24512  k=o%:RETurn 32766-2*k
24516 END DEFine
24520 :
24524 DEFine FuNction Dereal%(ad)
24528  IF ad>98302:wrong 18
24532  IF ad<32768:RETurn ad
24536  RETurn INT((32766-ad)/2)
24540 END DEFine
24544 :
30000 DEBUG 1
30002 DEFine PROCedure Remove_Sleep
30004  DLINE 29000 TO 29999
30006  STOP
30008 END DEFine
30010 :
30012 DEFine PROCedure Remove_Menu
30014  DLINE 28000 TO 28999
30016  STOP
30018 END DEFine
30020 :
30022 DEFine PROCedure Remove_Sprite
30024  DLINE 27000 TO 27999
30026  STOP
30028 END DEFine
30030 DEBUG 0
