; TPTR512_ASM
; on Q3 and win1_qptr (Q40)
; 25th October 2008
; BASIC keywords for use in QPTR_BASIC
;
; v 5.12	1. Restore previous lower case keywords
;
; v 5.11	1. Correct GVEC to check that both PTR_GEN and WMAN are there
;	2. Alter all keywords to upper case.
;
; v 5.10	1. SET_PTR corrected. (D6 may be corrupted by CA_GT..
;
; v 5.09	1. New function CL33T32 to switch mode 33/32 colours
;
; v 5.08	1. Stops D6 being smashed in BSVPW and BRSPW
;
; v 5.07	1. B_ID and BS_OWNER added
;
; v 5.06	1. BOUTL altered to allow ALL daughter basics
;
; v 5.05	1. Corrected calculation of "number" of procs/functions
;	   using FNPROC1 instead of FNPROC.
;
; v 5.04	1. S_PTR now allows the optional parameter "key"
;	2. S_PTR now has timeout - previously not set!
;	3. Preserve D6 in WRPTR/T. (See v 1.5!!)
;
; v 5.03	1. BRPTR sets job events properly
;
; v 5.02	1. Take out unnecessary instructions from DO_MDRW
;
; v 5.01	1. This allows up to 28 system sprites.
;
; v 4.02	1. BSPAL must allow a positive D0 from wm_jbpal to be correct!!
;
; v 4.01	1. Add BSPAL to set system palette
;
; v 3.9 - 1. Add Mode 64 to Sprite Size (SPRS)
;	2. Allow alpha blocks in BSPSET
;
; v 3.8 - 1. Add timeout to BRSPW and BSVPW
;	2. Check parameters of BRSPW and BSVPW if mode 8
;
; v 3.7 - 1. BRSPW and BSVPW added
;
; v 3.6 - 1. Correct timeout on WRPTR
;
; v 3.5 - 1. Add M_DRBDN. This has the same effect as M_DRBDR but returns the
;	   error code from WM.DRBDR
;	2. Add WRPTRT(wwd, timeout, events [,address])
;
; v 3.4 - 1. Add M_IDRW(n,wwd) to redraw information windows
;
; v 3.3 - 1. Set MACTION and LACTION so that bit 24 of D0 is 1 for DO and 0
;	   for a HIT
;	2. New procedure M_DRBDR(wwd,k%) to draw borders.
;
; v 3.2 - 1. Add BASIC_SRT%(dx%)
;	2. Alter W_MAX to use a subsidiary program.
;	3. Add SET_PTR to set the pointer position
;
; v 3.1 - 1. Add the keyword N_CHAN% (Like NEWCHAN%)
;
; v 2.10 - 1. Correction to "event sprites" in SETUP
;
; v 2.9 - 1. Set PNAME$ to return without error
;
; v 2.8 - 1. Allow BFRAME and BFREE to return without error even if no THING list
;
; v 2.7 - 1. G_PR and S_PR added to return and set the current job's priority
;
; v 2.6 - 1. Allows for different status areas for each repeated section
;	   in SETUP. This required a change in the addendum to the window
;	   definition.
;
; v 2.5 - 1. Sets a different return for BFRAME if error.
;	2. Allows BFREE to return without error even if there is!
;
; v 2.4 - 1. MODE%, PNAME$, BFREE and BFRAME added
;	2. HED1 used in place of HED. Ends on a word boundary
;
; v 2.3 - Correctly signal faulty parameter if > 1 in GWWD
;
; V 2.2 - To allow for BUTTONs in finding promary window in M_SETUP
;
; v 1h8 - To alter method of finding primary window in M_SETUP (= v2.1)
;
; v 1f8 - Again enhance meaning of SPR_SZE - 11 Oct 2000
;
; v 1e8 - Enhance meaning of SPR_SZE - 12 Sep 2000
;
; v 1d8 - Some more colours added
;
; v 1c8 - Altered W_MAX
;
; v 1b8 - SWIN correctly adjusted arithmetic stack
;
; v 1.8 - M_SETUP altered to get the primary window
;	Treatment of arithmetic stack different for compiled
;	(This affects CHECK)
;
; v 1.7 - W_MAX now works for compiled programs
;
; v 1.6 - A3 now preserved during ALCHP
;
; v 1.5 - D5 used in place of D6 since CA_G... smashes the latter
;
; v 1.4 - sets the QDOS colours as byte values (eg GREY% = 255 not -1)
;
; v 1.3 - no longer sets status area to zero in DO_MDRW
;
	LOW_EA
	NOLIST
	IN	WIN1_SYS_EQUBAS_ASM
	IN	WIN1_LIB_FNPROC_ASM
	IN	WIN1_LIB_HED1
;
VERSION	EQU	?"5.12"
IOP.WBLB	EQU	$73
IOP.WSPT	EQU	$76
IOP.RPTR	EQU	$71
IOP.SPTR	EQU	$7B
IOP.PINF	EQU	$70
IOP.OUTL	EQU	$7A
IOP.FLIM	EQU	$6C
IOP.SVPW	EQU	$6D
IOP.RSPW	EQU	$6E
SYS_CLNK	EQU	$C4
WM.FSIZE	EQU	$54
WD.ELEN	EQU	$A
WM.CHWIN	EQU	$40
WM.SETUP	EQU	4
WM.PRPOS	EQU	$C
WM.WDRAW	EQU	$1C
WM.PULLD	EQU	$10
WM.PANSC	EQU	$38
WWL_SKEY	EQU	$B
WM.MHIT	EQU	$34
WM.RPTR	EQU	$30
WM.RPTRT	EQU	$78
WM.SMENU	EQU	8
WM.INDEX	EQU	$24
WM.LDRAW	EQU	$2C
WM.MDRAW	EQU	$20
WM.IDRAW	EQU	$3C
WM.STIOB	EQU	$50
WM.STLOB	EQU	$4C
WM.UPBAR	EQU	$70
WM.UNSET	EQU	$14
WM.WRSET	EQU	$18
WM.DRBDR	EQU	$44
WM.JBPAL	EQU	$90
WSI..CHG	EQU	0
WS_PTPOS	EQU	$20
WS_LITEM	EQU	$40
WS_CITEM	EQU	$30
WS_CIACT	EQU	$2C
WW_NLITM	EQU	$68
WWL.ELEN	EQU	$16
WSP_WEVE	EQU	$15
PT..D0	EQU	16
PT..CAN	EQU	17
PT..HELP	EQU	18
PT..WMOV	EQU	19
PT..WSIZ	EQU	20
PT..ZZZZ	EQU	21
PT..WAKE	EQU	22
PT_XSCRS	EQU	$F2
N_Jobs	EQU	4
pt_vecs  equ	$150   ; long  pointer to block with vectored routines
pv_pinf  equ	$00    ; Get pointer information (IOP.PINF equivalent)
;
	LIST
;
; Print message
;
	LEA	MES,A1
	MOVEA.L	BV_CHBAS(A6),A0
	MOVEA.L	(A0,A6.L),A0
	MOVEA.W	UT_MTEXT,A2
	JSR	(A2)
;
START	LEA	DEFINE,A1
	MOVEA.W	BP_INIT,A2
	JMP	(A2)
;
	HED1	 <"TurboPTR v ",VERSION,10>,MES
DEFINE
	PROC_START
	PF_NAME	BRCHP,BRCHP
	PF_NAME	WRSET,BWRSET
	PF_NAME	BWSPR,BWSPR
	PF_NAME	BWBLO,BWBLO
	PF_NAME	CLOS,CLOS
	PF_NAME	CHW,BCHWIN
	PF_NAME	SP0000,BSPSET
	PF_NAME	LDRW,D_LDRW
	PF_NAME	ADRW,M_ADRW
	PF_NAME	IDRW,M_IDRW
	PF_NAME	UPBAR,M_UPBAR
	PF_NAME	OUTL,BOUTL
	PF_NAME	STLOB,STLOB
	PF_NAME	STIOB,STIOB
	PF_NAME	HX,HX
	PF_NAME	UNST,BUNST
	PF_NAME	CH_USE,USE
	PF_NAME	BRE,BFREE
	PF_NAME	S_PR,S_PR
	PF_NAME	S_PTR,SET_PTR
	PF_NAME	DRBDR,M_DRBDR
	PF_NAME	RSPW,BRSPW
	PF_NAME	BSPAL,BSPAL
	PF_NAME	OWNER,BS_OWNER
	PROC_END
	FN_START
	PF_NAME	SPRS,SPR_SZE
	PF_NAME	SETUP,M_SETUP
	PF_NAME	PULLD,M_PULLD
	PF_NAME	PRPOS,M_PRPOS
	PF_NAME	RPTR,BRPTR
	PF_NAME	WRPTR,WRPTR
	PF_NAME	WRPTRT,WRPTRT
	PF_NAME	LACT,M_LACT
	PF_NAME	MACT,M_MACT
	PF_NAME	MDRW,M_MDRW
	PF_NAME	ODRW,M_ODRW
	PF_NAME	MHIT,M_MHIT
	PF_NAME	ACR,ACR
	PF_NAME	ACR1,ACR1
	PF_NAME	OHIT,OHIT
	PF_NAME	MEN,M_LMEN
	PF_NAME	SWIN,SWIN
	PF_NAME	PAPPL,wd_pappl%	 8
	PF_NAME	PLITM,wd_plitm%	 6
	PF_NAME	PINFO,wd_pinfo%	 4
	PF_NAME	NXSC,wda_nxsc%	26
	PF_NAME	NYSC,wda_nysc%	28
	PF_NAME	EXT,wda_ext%	31
	PF_NAME	NROW,wda_nrow%	32
	PF_NAME	NCOL,wda_ncol%	30
	PF_NAME	POBL,wdi_pobl%	16
	PF_NAME	CLEN,wda_clen%	24
	PF_NAME	NROW,wda_blen%	32
	PF_NAME	GREY,GREY%	$FF
	PF_NAME	L_RED,L_RED%	$EA
	PF_NAME	L_GREEN,L_GREEN%	$DC
	PF_NAME	D_GREEN,D_GREEN%	$E4
	PF_NAME	D_RED,D_RED%	$D2
	PF_NAME	MUSTARD,MUSTARD%	$F2
	PF_NAME	WHITE,WHITE%	7
	PF_NAME	BLACK,BLACK%	0
	PF_NAME	RED,RED%		2
	PF_NAME	GREEN,GREEN%	4
	PF_NAME	CYAN,CYAN%	5
	PF_NAME	MAGENTA,MAGENTA%	3
	PF_NAME	YELLOW,YELLOW%	6
	PF_NAME	BLUE,BLUE%	1
	PF_NAME	AWHITE,AWHITE%	$FFFE
	PF_NAME	AGREEN,AGREEN%	$F800
	PF_NAME	ABLUE,ABLUE%	$3E
	PF_NAME	ARED,ARED%	$7C0
	PF_NAME	AYELLOW,AYELLOW%	$FFC0
	PF_NAME	ACYAN,ACYAN%	$F83E
	PF_NAME	AMAGENTA,AMAGENTA%	$7FE
	PF_NAME	OPE,OPE
	PF_NAME	GCU,GETCU
	PF_NAME	GCP,GETPX
	PF_NAME	GLEN,GLEN
	PF_NAME	PTR,IS_POINTER%
	PF_NAME	WH_P,WH_PTR
	PF_NAME	CH_SZ,BCHSZ
	PF_NAME	GWZ,W_MAX
	PF_NAME	CHB,CH_BAS
	PF_NAME	AD_SUB,AD_SUB
	PF_NAME	PNAM,PNAME$
	PF_NAME	MDE,MODE%
	PF_NAME	BFR,BFRAME
	PF_NAME	G_PR,G_PR
	PF_NAME	N_CHAN,N_CHAN%
	PF_NAME	B_SRT,BASIC_SRT%
	PF_NAME	DRBDN,M_DRBDN
	PF_NAME	SVPW,BSVPW
	PF_NAME	CL,CL33TO64
	PF_NAME	CL33,CL33T32
	PF_NAME	B_ID,B_ID
	FN_END
;
; BWSPR(#ch,x,y,sprt) writes a sprite to position x,y in channel #ch
; BWBLO(#ch,x,y,blob,patt) writes a blob with pattern patt to position
;	x,y in channel #ch
;
BWSPR	MOVEQ	#IOP.WSPT,D5	mark "sprite"
	LEA	4*8(A3),A0	4 parameters needed
	BRA	BW_1
;
BWBLO	MOVEQ	#IOP.WBLB,D5	mark "blob"
	LEA	5*8(A3),A0	5 parameters needed
BW_1	CMPA.L	A0,A5
	BNE	BAD_PARM	---->
	MOVEA.L	A5,A4
	BTST	#7,1(A3,A6.L) #? . .
	BEQ	BAD_PARM	---->	. . no
	LEA	3*8(A3),A5
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	SUBQ.W	#3,D3
	BNE	BAD_PARM ---->
	MOVEA.L	A5,A3
	MOVEA.L	A4,A5
	MOVEA.L	BV_CHBAS(A6),A0
	MOVE.W	(A1,A6.L),D0	channel number
	MULU.W	#$28,D0
	ADDA.L	D0,A0
	CMPA.L	BV_CHP(A6),A0
	BGE	NOT_CHAN	---->
	MOVE.L	(A0,A6.L),D0
	BLT	NOT_CHAN	---->
	MOVEA.L	D0,A4		keep ID in A4
	MOVEM.W	2(A1,A6.L),D6-7	x,y (which leaves top words zero)
	SWAP	D6
	ADD.L	D6,D7
	ADDQ.L	#6,BV_RIP(A6) adjust stack
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
;
; We have A4 = ID
;	D7 = x|y
;	D5 = IOP.WSPT or IOP.WBLB
;
	MOVEA.L	A4,A0		ID
	MOVEM.L	(A1,A6.L),A4-5	sprite/blob & -/pattern
	ADD.W	D3,D3
	ADD.W	D3,D3		(number of pars)*4
	LEA	(A1,D3.W),A1
	MOVE.L	A1,BV_RIP(A6) adjust stack
	BSR	GVEC_2		check pointer environment
	MOVEA.L	A4,A1		-> sprite/blob
	MOVEA.L	A5,A2		->   -   /pattern
	MOVE.L	D7,D1		x|y
	MOVEQ	#0,D2
	MOVEQ	#-1,D3		timeout
	MOVE.L	D5,D0
	TRAP	#3
	RTS			return to BASIC
;
; BCHWIN(wdef) moves the window
;
CHW	BSR	GWWD	wdef -> A4
	BSR	GVEC	vector -> A1
	MOVEA.L	(A4),A2	status area
	BSET	#PT..WMOV,WSP_WEVE(A2)
	JMP	WM.CHWIN(A1)
;
; BCHSZ(wwd) returns the x/y movement from WM.CHWIN
;
CH_SZ	BSR	GWWD
	BSR	GVEC
	MOVEA.L	(A4),A2	status area
	BSET	#PT..WSIZ,WSP_WEVE(A2)
	JSR	WM.CHWIN(A1)
	MOVE.L	D1,D5
	BRA	SE_3
;
; BUNST(wdef) unsets the window
;
UNST	BSR	GWWD	wdef -> A4
	BSR	GVEC
	JMP	WM.UNSET(A1)
;
; BRCHP(ad) RECHP's the area at ad
;
BRCHP	BSR	GWWD	address -> A4
	MOVEA.L	A4,A0
	MOVEQ	#MT_RECHP,D0
	TRAP	#1
	MOVEQ	#0,D0
	RTS
;
; SWIN(w%,n%,wdef) returns the ID for a window or object.
; w%=0 for information windows, n% = the number of window,
;   =1 for loose items,	  n% = the number of loose item,
;   =2 for application window,  n% = the number of the window.
;
SWIN	LEA	3*8(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->	3 parameters needed
	LEA	2*8(A3),A5
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)		get w% and n% . .
	BNE	BAD_PARM	---->
	MOVEM.W	(A1,A6.L),D5/D7	. . -> D5 & D7
	ADDQ.L	#4,BV_RIP(A6)
	MOVEA.L	A5,A3		point to the . . .
	LEA	8(A5),A5		. . . last parameter
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVEA.L	(A1,A6.L),A4	wdef
	ADDQ.L	#4,BV_RIP(A6)
	BSR	GVEC
	MOVEQ	#-1,D2
	MOVE.W	D7,D1
	ADD.W	D5,D5
	ADD.W	D5,D5		4*w%
	JSR	$58(A1,D5.W)	to WM.SWINF, WM.SWLIT or WM.SWAPP
	BNE	BAD_PARM	---->
;
; Now A0 = ID of window with correct dimensions.
; We have to open a CON with these and return that.
; But first, get 8 bytes on the stack.
;
	LEA	GET_W,A2		EXTOP routine to get dimensions
	MOVEQ	#-1,D3		timeout
	MOVEQ	#SD_EXTOP,D0
	TRAP	#3
	MOVE.L	A1,D7
	MOVE.L	D1,D6
	BSR	OPE1		A0 & D5 = ID
	MOVEQ	#8,D1
	BSR	CHECK
	MOVEM.L	D6-7,(A1,A6.L)
	MOVEQ	#0,D1
	MOVEQ	#0,D2
	MOVEQ	#-1,D3
	MOVEQ	#SD_WDEF,D0
	TRAP	#4
	TRAP	#3
	ADDQ.L	#8,BV_RIP(A6)	Restore stack
	TST.L	D0
	BNE	BAD_EXIT	---->
	BRA	SE_3
;
GET_W	MOVEA.L	SD_XMIN(A0),A1
	MOVE.L	SD_XSIZE(A0),D1
	MOVEQ	#0,D0
	RTS
;
; STLOB(n%,ptr,wdef) sets the object @ ptr to the loose item n%,
; STIOB(w%,n%,ptr,wdef) sets the object @ ptr to item number n%
;      in information window number w%.
;
; In both cases wdef is the address of the window working definition.
;
STLOB	MOVEQ	#WM.STLOB,D5
	LEA	3*8(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->	3 parameters needed
	MOVEA.L	A5,A4
	LEA	8(A3),A5
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)		get one integer
	BNE	BAD_PARM	---->
	MOVE.W	(A1,A6.L),D7	n% -> D7
	ADDQ.L	#2,BV_RIP(A6)
STLOB_1	MOVEA.L	A5,A3
	MOVEA.L	A4,A5
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)		get ptr & wdef
	BNE	BAD_PARM	---->
	MOVEA.L	4(A1,A6.L),A4 wdef
	MOVEA.L	(A1,A6.L),A2	ptr
	BSR	GVEC		vector to A1
	EXG	A1,A2
	MOVE.L	D7,D1
	JMP	(A2,D5.W) do WM.STLOB or WM.STIOB
;
STIOB	MOVEQ	#WM.STIOB,D5
	LEA	4*8(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->	4 parameters needed
	MOVEA.L	A5,A4
	LEA	16(A3),A5
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVE.L	(A1,A6.L),D7	window no | object no
	ADDQ.L	#4,BV_RIP(A6)
	BRA	STLOB_1
;
; SPR_SZE(w%,h%) returns the space needed for a sprite of width w%
; and height h%. These dimensions must be < 2048
;
; If w% > 0 & h% > 0 QL Mode
; If w% < 0 & h% > 0 Mode 31 (Palette)
; If w% < 0 & h% < 0 Mode 32/33
; If w% > 0 & h% < 0 Mode 64
;
SPRS	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	SUBQ.W	#2,D3
	BNE	BAD_PARM	---->	2 parameters needed
	MOVE.W	#$800,D3		Maximum size of dimension
	MOVEQ	#24,D5		Constant part
	MOVEQ	#0,D4		set the rounding
	MOVEQ	#3,D1		set the multiple
	MOVE.W	2(A1,A6.L),D2	height
	MOVE.W	(A1,A6.L),D0	width (neg for Palette)
	BPL	SPRS_1		QL/MODE 64
	NEG.W	D0
	TST.W	D2
	BPL	SPRS_2		palette
	NEG.W	D2
	BRA	SPRS_3		Mode 32/33
SPRS_1	TST.W	D2
	BPL	SPRS_4		QL
	NEG.W	D2
	BRA	SPRS_5		Mode 64
SPRS_4	ADD.W	#12,D4		QL
	SUBQ.W	#1,D1
SPRS_2	ADDQ.W	#2,D4		palette
	SUBQ.W	#1,D1
SPRS_3	ADDQ.W	#1,D4
	SUBQ.W	#1,D1		Mode 32/33
SPRS_5	ADD.W	D4,D0
	NOT.W	D4
	AND.W	D4,D0
	TST.W	D1
	BEQ	SPRS_6		QL
	LSL.W	D1,D0
	BRA	SPRS_7
SPRS_6	LSR.W	#1,D0
SPRS_7	CMP.W	D3,D0
	BGT	BAD_PARM	---->
	ADDQ.L	#4,BV_RIP(A6) tidy stack
	CMP.W	D3,D2
	BGT	BAD_PARM	---->
	MULU.W	D0,D2
	ADD.L	D2,D5		answer
	BRA	SE_3


;
; CH_BAS(ID) returns the base of channel ID
;
CHB	BSR	GWWD		ID -> A4
	MOVEA.L	A4,A0
	MOVEQ	#-1,D3		timeout
	LEA	F_CH,A2
	MOVEQ	#SD_EXTOP,D0
	TRAP	#3
	TST.L	D0
	BNE	BAD_EXIT	---->
	MOVE.L	A1,D5		address to D5
	BRA	SE_3
;
F_CH	MOVEA.L	A0,A1
	MOVEQ	#0,D0
	RTS
;
; BOUTL sets #0 (SBASIC or Master Basic) to managed, while leaving
; #0 unchanged. Nothing is done if the window is already managed.
;
OUTL:	BSR	Tstcmpld		Zero if not compiled
	BNE	NOT_IMP	---->	We only want S*BASIC
	MOVE.L	BV_CHBAS(A6),A0
	MOVE.L	(A6,A0.L),D0	ID of #0
	BLT	NOT_CHAN	---->
	MOVEA.L	D0,A0		set ID in A0
;	 TST.B	 $54(A6)
;	 BPL	 OUTL_1		 not SBASIC
;	 CMPI.L	 #"SBAS",-4(A6)
;	 BEQ.S	 SBAS		 SBASIC
;	 BRA	 NOT_IMP
;OUTL_1	 SUBA.L	 A0,A0		 ID #0
OUTL_2	MOVEQ	#-16,D0		space needed in buffer
	SUB.L	BV_BFBAS(A6),D0
	ADD.L	BV_TKBAS(A6),D0
	BMI	BUF_FUL	---->
	MOVEQ	#IOP.PINF,D0
	MOVEQ	#-1,D3		timeout
	TRAP	#3		see if pointer installed
	TST.L	D0
	BNE	BAD_EXIT	---->
	BSR	SET_WIN		put largest window -> Bas Buf
	MOVE.L	(A1,A6.L),D5	Maximum size to D5
	MOVEQ	#SD_PXENQ,D0	to get cursor position
	TRAP	#4		A1 is relative to A6
	TRAP	#3
	MOVE.L	(A1,A6.L),D4	current window size to D4
	MOVE.L	4(A1,A6.L),D6	cursor pixel position to D6
	LEA	GET_W,A2		routine to get the origin
	MOVEQ	#SD_EXTOP,D0
	TRAP	#3
	MOVE.L	A1,D7		sets the origin to D7
	MOVEA.L	BV_BFBAS(A6),A1	big size . .
	MOVE.L	D5,(A1,A6.L)	. . to buffer . .
	CLR.L	4(A1,A6.L)	. . and zero origin
	MOVEQ	#0,D1		no shadow
	MOVEQ	#0,D2		don't keep contents
	MOVEQ	#IOP.OUTL,D0
	TRAP	#4
	TRAP	#3		do the OUTLINE
	TST.L	D0
	BNE	BAD_EXIT	---->
	MOVE.L	D4,(A1,A6.L)	set current window size . .
	MOVE.L	D7,4(A1,A6.L)	. . and origin
	MOVEQ	#0,D1		no . . .
	MOVEQ	#0,D2		. . . border
	MOVEQ	#SD_WDEF,D0
	TRAP	#4
	TRAP	#3
	MOVE.W	D6,D2		cursor . . .
	SWAP	D6
	MOVE.W	D6,D1		. . . position
	MOVEQ	#SD_PIXP,D0
	TRAP	#3
	RTS
;
NOT_IMP	MOVEQ	#-19,D0
	BRA	BAD_EXIT
BUF_FUL	MOVEQ	#-5,D0
	BRA	BAD_EXIT
;
;SBAS	 MOVE.L	 BV_CHBAS(A6),A0
;	 MOVE.L	 (A6,A0.L),D0	 ID of #0
;	 BLT	 NOT_CHAN  ---->
;	 MOVEA.L	 D0,A0		 set ID in A0
;	 BRA	 OUTL_2
;
MUSTARD	MOVEQ	#$F2,D5
	BRA.S	DIB1
WHITE	MOVEQ	#7,D5
	BRA.S	DIB
BLACK	MOVEQ	#0,D5
	BRA	DIB
BLUE	MOVEQ	#1,D5
	BRA	DIB
MAGENTA	MOVEQ	#3,D5
	BRA	DIB
CYAN	MOVEQ	#5,D5
	BRA	DIB
YELLOW	MOVEQ	#6,D5
	BRA	DIB
RED	MOVEQ	#2,D5
	BRA	DIB
GREEN	MOVEQ	#4,D5
	BRA	DIB
GREY	MOVEQ	#$FF,D5
	BRA	DIB1
L_RED	MOVEQ	#$EA,D5
	BRA	DIB1
L_GREEN	MOVEQ	#$DC,D5
	BRA	DIB1
D_GREEN	MOVEQ	#$E4,D5
	BRA	DIB1
D_RED	MOVEQ	#$D2,D5
	BRA	DIB1
AWHITE	MOVEQ	#$FE,D5
	BRA	DIB
AGREEN	MOVE.W	#$F800,D5
	BRA	DIB
ABLUE	MOVEQ	#$3E,D5
	BRA	DIB
ARED	MOVE.W	#$7C0,D5
	BRA	DIB
AYELLOW	MOVEQ	#-64,D5
	BRA	DIB
ACYAN	MOVE.W	#$F83E,D5
	BRA	DIB
AMAGENTA	MOVE.W	#$7FE,D5
	BRA	DIB
PAPPL	MOVEQ	#8,D5
	BRA	DIB
PLITM	MOVEQ	#6,D5
	BRA	DIB
PINFO	MOVEQ	#4,D5
	BRA	DIB
NXSC	MOVEQ	#26,D5
	BRA	DIB
NYSC	MOVEQ	#28,D5
	BRA	DIB
EXT	MOVEQ	#31,D5
	BRA	DIB
NROW	MOVEQ	#32,D5
	BRA	DIB
NCOL	MOVEQ	#30,D5
	BRA	DIB
POBL	MOVEQ	#16,D5
	BRA	DIB
CLEN	MOVEQ	#24,D5
DIB1	ANDI.W	#$FF,D5	keep byte value
DIB	MOVEQ	#2,D1	space for integer
	BSR	CHECK
DIB2	MOVE.W	D5,(A1,A6.L)
	MOVEQ	#3,D4	mark integer
	MOVEQ	#0,D0
	RTS
;
NOT_CHAN	MOVEQ	#-6,D0
	RTS
;
BAD_PARM1 ADDQ.L	#4,A7
BAD_PARM	MOVEQ	#-15,D0
BAD_EXIT	RTS
;
; To reserve D1.L places on the arithmetic stack
; setting BV_RIP and A1 accordingly.
;
CHECK	MOVE.L	D1,-(A7)	keep the size needed
	bsr	Tstcmpld	compiled? . .
	bne.s	LAB106E	. . yes
	MOVEA.W	BV_CHRIX,A1
	JSR	(A1)
CHECK_1	MOVEA.L	$58(A6),A1
	SUBA.L	(A7)+,A1
	MOVE.L	A1,$58(A6)
	RTS
;
LAB106E	ADDQ.L	#2,D1		see that there are 2 more bytes as well
	NEG.L	D1
	ADD.L	$58(A6),D1	new value of stack in D1
	CMP.L	(A6),D1		is it OK? . .
	bpl.s	CHECK_1		. . yes
	moveq	#-3,d0		ERR.OM
	addq.l	#8,a7
	rts
*
* The following routine (from TurboToolkit)tests
* whether the calling job
* is running under a SuperBASIC Interpreter
* or a Compiled Job
* It should work under most QDOS variants
* and it works in current versions of SBASIC
*
* Idea gained from dissasembly of SMSQ/E JOB_NAME
* Procedure and comments in source of ENV_BIN
* assumes A6 points to basic variables
* No registers are corrupted
* only CCR is changed
*
* DCG
*
* PS If someone foolishly changes
* the appropriate area ie -4(A6)
* with a POKE on their heads be it
* That is also reason for checking
* what OS we are running under
*
Tstcmpld	movem.l	  d0-d2/a0,-(a7)
	tst.l	  $54(a6)
	beq.s	  Compiled	    for Qliberator DCG
	tst.b	  $54(a6)
	bpl.s	  Interp
	cmpi.l	  #'SBAS',-4(a6)
	bne.s	  Compiled
	moveq	  #0,d0
	trap	  #1
	cmpi.l	  #'SMSQ',(a0)
	bne.s	  Compiled
	cmpi.l	  #'2.00',d2
	blt.s	  Compiled
Interp	moveq	  #0,d0
	bra.s	  Myexit
Compiled	moveq	  #1,d0
Myexit	movem.l	  (a7)+,d0-d2/a0
	rts
;
; M_SETUP(#ch,wdef,size) is a function returning the address of the working
; definition.
;
; ch is the number of a BASIC CON channel
; ch > 99 if a primary window is wanted
;
; wdef is the address returned by M_WDEF
;
; To allow event sprites to be used as loose items, the first few
; loose items can be designated as such. This is done by using the
; last 10 or 28 bytes of the loose item status area to hold the sprite
; number. This is placed in the working definition address in place
; of a real address.
;
; There are two forms of window definition presented to SETUP.
;
; 1. The original version
; The status area for loose items is 40 bytes long - allowing 10
; "event" items and 30 others.
;
; The rth byte in the last ten refers to the rth loose item.
;
; 2. The new version
; The status area for loose items is of length "s" - see below
; If s < 59 the number of loose items is s/2 and all can be system sprites
; If s > 58 the number of loose items is s - 28 but only 28 can be
; system sprites.
;
; The rth byte in the last s/2 or (s - 28) bytes, whichever is smaller,
; refers to the rth loose item.
;
; Because it appears that the system of odd word pointers does not
; work relative to the status area, M_SETUP also sets the true
; addresses for pointers to menu control sections and the menu status
; area for all application windows.
;
; The format of the window definition starts:
;
; *********************************************
; * Fixed section - 48 bytes		      *
; * Repeated sections - each 10 bytes	      *
; * -1 to signal end - 2 bytes	      *
; *				      *
; * There are two versions of the following   *
; * distinguished by the size of border in    *
; * the fixed section having bit 15 set or    *
; * not set.			      *
; *				      *
; * ----------------------------------------  *
; * Old Version (Bit 15 not set)	      *
; * Repeated status areas - each 104 bytes    *
; *	plus a 4-byte size		      *
; *-----------------------------------------  *
; * New Version (Bit 15 set)		      *
; * One word giving the size of loose item    *
; * status area (s).		      *
; * Repeated status areas - each 64 + s       *
; * bytes long plus a 4-byte size.	      *
; *------------------------------------------ *
; *				      *
; * Then follows a pointer area (ptr)	      *
; * where long pointers can be put if needed  *
; *********************************************
SETUP	LEA	3*8(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->	not 3 parameters
	BTST	#7,1(A3,A6.L)	#? . .
	BEQ	BAD_PARM	---->	. . no
	LEA	8(A3),A5		to get one parameter
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVE.W	(A1,A6.L),D7	channel number
	ADDQ.L	#2,BV_RIP(A6)	reset BV_RIP
	MOVEA.L	A5,A3
	LEA	16(A3),A5 	prepare to get the next 2 parameters
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVEM.L	(A1,A6.L),A3-4	address of window definition & size
	ADDQ.L	#8,BV_RIP(A6)	tidy stack
;
; Get ID
;
	MOVE.W	D7,D6
	SUBI.W	#100,D6		is a primary wanted? . .
	BPL	SETUP_PRIM
	MOVEA.L	BV_CHBAS(A6),A0
	MULU	#$28,D7
	ADDA.L	D7,A0
	CMP.L	BV_CHP(A6),A0
	BGE	NOT_CHAN	---->
	MOVE.L	(A0,A6.L),D7	ID -> D7.L
	TST.W	D7
	BMI	NOT_CHAN	---->


SETUP_11	MOVEA.L	D7,A0
	BSR	GVEC_2
;
; A1 contains qptr vector
;
	MOVEA.L	A1,A2
	MOVE.L	A4,D1		default size
	MOVE.W	$A(A3),D6 	window border size
	BCLR	#7,$A(A3) 	clear marker bit
	JSR	WM.FSIZE(A2)
;
; D2 = layout number : D1 = size of window
; A0 = ID : A2 = vector : A3 = wdef
;
	MOVEA.L	A3,A1
	LEA	$30(A1),A1
SETUP_1	TST.W	(A1)+
	BMI	SETUP_2		end of repeated bits
	LEA	WD.ELEN-2(A1),A1	to next bit
	BRA	SETUP_1
;
SETUP_PRIM:
	MOVEQ	#MT_INF,D0
	TRAP	#1
	MOVEA.L	SV_CHTOP(A0),A5
	MOVEA.L	SV_CHBAS(A0),A1
	MOVE.L	(A1)+,D7		Channel #0
	BMI	NOT_CHAN	---->
	MOVEA.L	D7,A2
	MOVE.L	CH_DRIVR(A2),D3	Driver (of CON)?
	MOVEA.L	D3,A2
	CMPI.L	#"Syst",$4A(A2)	Is System asleep? . .
	BNE	SETUP_P1		. . no
	MOVE.L	$20(A2),D3	Put the real driver address -> D3
SETUP_P1	CMPA.L	A5,A1		Ended? . .
	BGE	NOT_CHAN	---->	. .	Yes
	MOVE.L	(A1)+,D7
	BMI	SETUP_P1		Not a channel
	MOVEA.L	D7,A2
	CMP.L	CH_DRIVR(A2),D3	CON? . .
	BNE	SETUP_P1		. . no
	CMP.L	CH_OWNER(A2),D1	This Job's channel? . .
	BNE	SETUP_P1		. . no
	BTST	#7,$41(A2)	Primary? . .
	BEQ	SETUP_P1		. . no
	MOVE.L	A1,D7
	SUB.L	SV_CHBAS(A0),D7
	LSR.W	#2,D7		Channel . .
	SUBQ.W	#1,D7		. . number
	SWAP	D7
	MOVE.W	CH_TAG(A2),D7	Tag
	SWAP	D7		ID
	BRA	SETUP_11
;
SETUP_2	MOVE.L	D1,-(A7)		keep size
	MOVEQ	#0,D1
	SWAP	D6		D6.L is negative for new version
	BMI	SETUP_13		new version
	MOVE.W	#40,D6		length of loose item status block (old)
	BRA	SETUP_14
SETUP_13	MOVE.W	(A1)+,D6		length of loose item status block
SETUP_14	ADDI.W	#68,D6
	MULU.W	D6,D2
	ADDA.L	D2,A1		A1 -> nth status area
	MOVE.L	-4(A1,D6.W),D1	set size for working definition in D1.L
	BSR	ALCH_1		sets address in A0 and D5
	MOVE.L	(A7)+,D1		replace size
	MOVEA.L	A0,A4		address for working definition
	MOVEA.L	D7,A0		ID
	JSR	WM.SETUP(A2)	done
	SWAP	D6
	MOVE.W	D6,$A(A3) 	reset marker
	SWAP	D6
;
; Here we set the correct long word pointers to control blocks
; and status area for application windows
;
; A1 -> status area
; A4 -> working definition
;
	MOVE.L	$70(A4),A5	app window list
	MOVE.W	$6E(A4),D0	number of app windows
	BRA	SETUP_6
SETUP_7	MOVE.L	(A5)+,A3		-> app window block
	TST.L	$14(A3)		Is there a menu? . .
	BEQ	SETUP_6		. . no
	MOVEQ	#2*$1E,D4 	offset to last of pointers
	MOVEQ	#$1E,D1		distance between pointers
SETUP_8	MOVE.L	$28(A3,D4.W),D2	pointer to D2
	BSR	SET_ALT		set D2 to the correct address
	BEQ	SETUP_9		no alteration needed
	MOVE.L	D2,$28(A3,D4.W)	set correct address
SETUP_9	SUB.L	D1,D4		to previous pointer
	BPL	SETUP_8		more to come
SETUP_6	DBF	D0,SETUP_7	next app window
;
; To set event numbers if needed for a loose item sprite
;
	TST.L	D6		old? . .
	BPL	SETUP_15		. . yes
	MOVEQ	#28,D4		maximum number of system sprites
	CMPI.W	#126,D6
	BGE	SETUP_16
	LSR.W	#1,D6
	ADDI.W	#62,D6
	BRA	SETUP_16
SETUP_15	MOVE.W	#126,D6
	MOVEQ	#10,D4		maximium number of system sprites
SETUP_16	LEA	-32(A1,D6.W),A1
	MOVE.W	$68(A4),D0	number of loose items
	CMP.W	D4,D0
	BLE	SETUP_12		less than maximum + 1
	MOVE.W	D4,D0		limit to maximum
SETUP_12	MOVEA.L	$6A(A4),A5	-> loose item list
	BRA	SETUP_3
SETUP_4	MOVE.B	(A1)+,D2		sprite number (if any)
	BEQ	SETUP_5		nothing to do
	CMPI.B	#2,$A(A5) 	type sprite? . .
	BNE	SETUP_5		. . no
	TST.L	$C(A5)		is the address really zero? . .
	BNE	SETUP_5		. . no!!!
	MOVE.B	D2,$C+3(A5)	set event sprite number
SETUP_5	LEA	WWL.ELEN(A5),A5	to next loose item
SETUP_3	DBF	D0,SETUP_4
;
; To set D5.L -> fp in D4.W & D5.L
;
SE_3	MOVE.W	D5,D4
	MOVE.L	D5,D1
	BEQ	SE_5
	MOVE.W	#$81F,D4		offset
	ADD.L	D1,D1
	BVS	SE_5
	SUBQ.W	#1,D4
	MOVE.L	D1,D5
	MOVEQ	#16,D0
SE_6	MOVE.L	D5,D1
	ASL.L	D0,D1
	BVS	SE_7
	SUB.W	D0,D4
	MOVE.L	D1,D5
SE_7	ASR.W	#1,D0
	BNE	SE_6
;
SE_5	MOVEQ	#6,D1		get 6 bytes on stack
	BSR	CHECK
	MOVE.L	D5,2(A1,A6.L)
	MOVE.W	D4,(A1,A6.L)
	MOVEQ	#2,D4		say 'fp'
EXIT	MOVEQ	#0,D0
	RTS
;
; SR to alter D2 to the correct offset from the status area
; Condition Code Zero set if no change
;
SET_ALT	BCLR	#0,D2		clear and test LS bit
	BEQ	SET_ALT1		nothing to do
	MOVEA.L	D2,A2
	ADD.L	(A2),D2		correct address
SET_ALT1	RTS
;
; M_PULLD(wwd,wh) and M_PRPOS(wwd,wh) return
; the ID of the window pulled down or positioned.
; wwd is the address returned by M_SETUP
; wh is the window "origin" (or -1)
;
PRPOS	MOVEQ	#WM.PRPOS,D5
	BRA	PULLD1
;
PULLD	MOVEQ	#WM.PULLD,D5
PULLD1	LEA	16(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->	we need 2 parameters
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVEA.L	(A1,A6.L),A4	wwd
	MOVE.L	4(A1,A6.L),D7	"origin"
	ADDQ.L	#8,BV_RIP(A6)
	BSR	GVEC
	MOVE.L	D7,D1
	JSR	(A1,D5.W) 	WM.PULLD or WM.PRPOS
	BNE	BAD_EXIT	---->
	JSR	WM.WDRAW(A1)
	BNE	BAD_EXIT	---->
	MOVE.L	A0,D5		ID -> D5.L
	BRA	SE_3
;
; BWRSET(wwd) resets and redraws the window @ working definition wwd
;
WRSET	BSR	GWWD		wwd -> A4
	BSR	GVEC		vector -> A1
	MOVEQ	#-1,D1
	JSR	WM.WRSET(A1)
	BNE	BAD_EXIT	---->
	JMP	WM.WDRAW(A1)
;
ALCH_1:
	MOVEM.L	D1/A1-3,-(A7)
	MOVEQ	#-1,D2		this JOB
	MOVEQ	#MT_ALCHP,D0
	TRAP	#1
	MOVEM.L	(A7)+,D1/A1-3
	TST.L	D0
	BNE	ALCH_E	---->	OOH!
	MOVE.L	A0,D5		keep address for return
	RTS
;
ALCH_E	ADDQ.L	#4,A7
	RTS
;
; To read the pointer and return on the conditions in
; termination vector k%.
;
; BRPTR(k%,ppos,wwd [,tim%]) returns the position of the pointer.
; k% is the termination record and wwd the working definition
; ppos is the initial position of the pointer.
; The optional parameter, tim%, is the timeout. The default value is -1
; tim% can be any signed integer, but all negatives are taken as -1.
;
; If BRPTR times out, the return is not the pointer's position, but -1.
;
RPTR	LEA	3*8(A3),A0
	CMPA.L	A0,A5
	BLT	BAD_PARM	---->	three or four parameters needed
	MOVEA.L	A5,A4
	MOVEA.W	CA_GTINT,A2
	LEA	8(A3),A5
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVE.W	(A1,A6.L),D7	k% -> D7
	ADDQ.L	#2,BV_RIP(A6)
	ADDQ.L	#8,A3
	LEA	16(A3),A5
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVE.L	(A1,A6.L),D1	initial position of pointer
	MOVEA.L	4(A1,A6.L),A1	working definition
	ADDQ.L	#8,BV_RIP(A6)
	CMPA.L	A5,A4
	BEQ	RPTR_2		No tim%
	MOVEA.L	A5,A3
	MOVEA.L	A4,A5
	MOVEA.L	D1,A4		Keep pointer pos
	MOVEA.W	CA_GTINT,A2
	MOVE.L	A1,D5		Preserve working definition
	JSR	(A2)
	BNE	BAD_PARM	---->
	SUBQ.W	#1,D3
	BNE	BAD_PARM	---->	Only 1 more parameter allowed
	ADDQ.L	#2,BV_RIP(A6)
	MOVE.L	A4,D1		Restore pointer pos
	MOVE.W	(A1,A6.L),D3	tim%
	MOVEA.L	D5,A1		Restore working definition
	BPL	RPTR_3		timeout set
RPTR_2	MOVEQ	#-1,D3		timeout
RPTR_3	MOVEQ	#0,D2
	MOVE.W	D7,D2		set termination vector
	ROR.W	#8,D2
	ROR.L	#8,D2
	MOVEA.L	8(A1),A0		channel ID
	MOVEA.L	(A1),A1		status block
	ADDQ.L	#8,A1		-> pointer record
	MOVEQ	#IOP.RPTR,D0
	TRAP	#3
	MOVE.L	D1,D5		pointer position
RPTR_1	MOVE.L	D0,D1		OK? . .
	BEQ	SE_3		. . yes
	MOVE.L	D1,D5		If OK -1 is returned
	ADDQ.L	#1,D1
	BEQ	SE_3
	RTS
;
; WRPTR(wwd [,address]) returns the long word k after reading the
; pointer via the window manager and passing control to
; MACTION and LACTION.
;
; WRPTRT(wwd, timeout, events [,address]) is exactly the same as WRPTR except
; for two things:
; 1. It has a timeout facility ("timeout")
; 2. It can exit with a job event (one of those requested in "events")
;
; The optional <address> is where
;
; There should be a forced exit with non-zero D0.
;
; The definition of k is:
;
;   Byte	  Byte	    Word
;  _______________________________
; |  pad	|  code |   item number |
;
; Bit 0 of pad is 1 for a "DO" and 0 for a "HIT". The other bits of pad are
; undefined.
;
; Code is -128 to signify an error
;	-4   to signal timeout
;	-3   to signify pan/scroll
;	-2   to signify an "event"
;	-1   to signify a  "loose item"
;	the number of application window otherwise.
;
; Item number is the value of the event, or the item number of loose item or of
; the application window menu or of the pan/scroll. The "value" of an event is:
;
;	1	for do (ENTER)
;	2	for quit
;	4	for help
;	8	for move
;        16	for change size
;        32	for sleep
;        64	for wake
;
; For a pan/scroll the "hit" position on a scroll bar is in the zero word at
; the end of the app window list. This MUST be zerod after use by WRPTR.
; The "hit" position must be transferred to the address given as the parameter
; of WRPTR. The "value" of a pan/scroll is given in the explanation of MACR1.
;
WRPTRT:
;	MOVEQ	#WM.RPTRT,D6
	PEA	WM.RPTRT
	LEA	3*8(A3),A0
	MOVE.L	A5,D7		keep end of parameters
	CMP.L	A0,D7
	BLT	BAD_PARM1 ---->	there must be 3 or 4 pars
	LEA	8(A3),A5		prepare to get 1 paramter
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	BAD_PARM1 ---->
	MOVEA.L	(A1,A6.L),A4	wwd
	MOVEA.L	A5,A3
	LEA	2*8(A3),A5	prepare to get 2 pars
	ADDQ.L	#4,BV_RIP(A6)
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM1 ---->
	MOVE.L	(A1,A6.L),D5
	MOVEA.L	A5,A3
	SUB.L	A5,D7		another par? . .
	BEQ	WRPTR2		. . no
	LEA	8(A3),A5
	ADDQ.L	#4,BV_RIP(A6)
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	BAD_PARM1 ---->
	MOVE.L	(A1,A6.L),D7	pointer to space
	BRA	WRPTR2
;
WRPTR:
;	MOVEQ	#WM.RPTR,D6
	PEA	WM.RPTR
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)		get 1 or 2 long integers
	BNE	BAD_PARM1 ---->
	MOVEQ	#0,D7		provisional value of 2nd par
	MOVE.L	(A1,A6.L),A4	wwd
	SUBQ.W	#1,D3
	BEQ	WRPTR2		only one parameter
	MOVE.L	4(A1,A6.L),D7	pointer to space
	ADDQ.L	#4,BV_RIP(A6)	adjust maths stack
	BTST	#0,D7
	BNE	BAD_PARM1 ---->	pointer must not be odd
	MOVEQ	#-1,D5		to set timeout of -1
WRPTR2	ADDQ.L	#4,BV_RIP(A6)	adjust maths stack
	MOVE.L	(A7)+,D6
	BSR	GVEC
	MOVE.W	D5,D2		job events
	SWAP	D5
	MOVE.W	D5,D3		timeout
	JSR	(A1,D6.L)
	MOVE.L	D0,D5
	BEQ	WRPTR1		event
	MOVE.L	D0,D1
	ADDQ.L	#1,D1
	BEQ	WRPTR4		timed out
	SWAP	D0
	ADDQ.B	#3,D0
	BEQ	WRPTR3		pan/scr
	BRA	SE_3
;
WRPTR1	MOVE.W	#$10FE,D5
	SWAP	D5
	MOVEA.L	(A4),A2
	MOVE.W	$14(A2),D5	job event/window event vector
	BRA	SE_3
;
WRPTR3	MOVEA.L	$70(A4),A2	-> app list
	MOVE.W	$6E(A4),D0	no of apps
	SUBQ.W	#1,D0
	BMI	BAD_PARM	---->
	LSL.W	#2,D0
	LEA	4(A2,D0.W),A2	-> end of list
	MOVE.L	(A2),D1
	CLR.L	(A2)
	TST.L	D7
	BEQ	BAD_PARM	---->
	MOVEA.L	D7,A0
	MOVE.L	D1,(A0)
	BRA	SE_3
;
WRPTR4	MOVEQ	#-4,D5		mark timed out
	SWAP	D5
	BRA	SE_3
;
; D_LDRW k,wdef redraws the loose item number n, with status s
; where k = 65536*s + n. The status, s, is 0 for available, 16
; for unavailable and 128 for selected.
;
LDRW	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)		get 2 long integers
	BNE	BAD_PARM	---->
	SUBQ.W	#2,D3
	BNE	BAD_PARM	---->	2 parameters needed
	MOVE.L	(A1,A6.L),D2	s | n
	MOVEA.L	4(A1,A6.L),A4 wdef
	ADDQ.L	#8,BV_RIP(A6)
	MOVE.W	D2,D4
	CMP.W	WW_NLITM(A4),D4
	BCC	BAD_PARM	---->
	SWAP	D2
	TST.W	D2
	BEQ	LDRW_1		OK
	CMP.W	#16,D2
	BEQ	LDRW_1
	CMP.W	#128,D2
	BNE	BAD_PARM	---->
LDRW_1	BSR	GVEC
	MOVEA.L	(A4),A3		status area
	ADDQ.W	#1,D2		mark 'redraw'
	MOVE.B	D2,WS_LITEM(A3,D4.W)
	MOVEQ	#-1,D3		selective redraw
	MOVEA.L	8(A4),A0		ID
	JSR	WM.LDRAW(A1)
	TST.L	D0
	BNE	BAD_EXIT
	BCLR	#WSI..CHG,WS_LITEM(A3,D4.W)
	BRA	EXIT
;
; M_ADRW(no%,wwd) selectively redraws the items in app window number no%.
; wwd is the address of the working definition
;
ADRW	LEA	2*8(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->	two parameters needed
	LEA	8(A3),A5		set to get no%
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVE.W	(A1,A6.L),D5	number of window (0, 1, etc)
	ADDQ.L	#2,BV_RIP(A6) adjust stack
	MOVEA.L	A5,A3		prepare for next . .
	ADDQ.L	#8,A5		. . parameter
	BSR	GWWD		get wwd -> A4
	BSR	GVEC		ptr vector -> A1
	CMP.W	$6E(A4),D5	number of windows v no%
	BGE	BAD_PARM	---->	(window doesn't exist)
	ADD.W	D5,D5
	ADD.W	D5,D5
	MOVEA.L	$70(A4),A3	pointer to window list
	MOVEA.L	(A3,D5.W),A3	pointer to window
	MOVEQ	#-1,D3		selective redraw
	JMP	WM.MDRAW(A1)
;
; M_IDRW(n, wwd) redraws the information windows indicated in n.
; n = 2^k0 + 2^k1 + 2^k2 . .	 where k0, k1, k2 etc are the numbers
; of the windows to be redrawn and -1 < ki < 31.
;
; A bad parameter is signalled unless all ki < the number of information
; windows.
;
IDRW	LEA	2*8(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->	two parameters needed
	LEA	8(A3),A5		set to get n
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVE.L	(A1,A6.L),D5	windows to be redrawn (2^k1 + 2^k2 . .)
	MOVEA.L	A5,A3		prepare for next . .
	ADDQ.L	#8,A5		. . parameter
	BSR	GWWD		get wwd -> A4
	BSR	GVEC		ptr vector -> A1
	MOVE.W	$60(A4),D3	number of windows
	MOVE.L	D5,D0
	LSR.L	D3,D0		test number . .
	BNE	BAD_PARM	---->	. . too big
	MOVE.L	D5,D3
	NOT.L	D3		set D3 for WM.IDRW
	JMP	WM.IDRAW(A1)

;
; M_UPBAR wwd, n, x_sec, y-sec redraws the scroll/pan bars of sections x-sec
;  and y_sec for app window n.
;
UPBAR	LEA	4*8(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->	four parameters needed
	LEA	8(A3),A5
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVE.L	(A1,A6.L),A4	wwd
	MOVEA.L	A5,A3
	LEA	3*8(A3),A5
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVEM.W	(A1,A6.L),D5-7
	MOVE.W	$6E(A4),D0	no of apps
	CMP.W	D0,D5
	BGE	BAD_PARM	---->	no such window
	ASL.W	#2,D5		4*n
	BMI	BAD_PARM	---->
	MOVEA.L	$70(A4),A3	-> app list
	MOVEA.L	(A3,D5.W),A3	-> app no n
	BSR	GVEC		sets A1 = vector & A0 = window ID
	MOVE.W	D6,D0
	SWAP	D0
	MOVE.W	D7,D0
	JMP	WM.UPBAR(A1)

; AD_SUB(wa%,o%,wwd) returns the address of the definition of a
; sub-window or loose item number wa% (0, 1 ..).
;
; o%= 0 for information windows
;     1	  application windows
;     2	  loose items
;
AD_SUB	LEA	3*8(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->
	LEA	2*8(A3),A5
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVEM.W	(A1,A6.L),D5/D7
	TST.W	D7
	BMI	BAD_PARM	---->
	CMPI.W	#2,D7
	BGT	BAD_PARM	---->
	ADDQ.L	#4,BV_RIP(A6)
	MOVEA.L	A5,A3
	LEA	8(A3),A5
	BSR	GWWD		wwd -> A4
	LSL.W	#3,D7		0, 8, 16
	LEA	AD_C(D7.W),A5	constants
	MOVE.W	(A5)+,D0
	CMP.W	(A4,D0.W),D5
	BGE	BAD_PARM	---->
	MOVE.W	(A5)+,D0
	MOVEA.L	(A4,D0.W),A0
	MULU.W	(A5)+,D5
	ADDA.L	D5,A0
	TST.W	(A5)
	BEQ	AD_SUB1		not app
	MOVEA.L	(A0),A0
AD_SUB1	MOVE.L	A0,D5
	BRA	SE_3
;
AD_C	DC.W	$60,$64,$14,0	INF
	DC.W	$6E,$70,$4,1	APP
	DC.W	$68,$6A,$16,0	LOOSE ITEM
;
; GCU (GETCU) ID returns the character cursor position (x*65532 + y)
; GCP (GETPX) ID returns the pixel cursor position (x*65532 + y)
;
GCU	MOVEQ	#SD_CHENQ,D5
	BRA	GCU1
GCP	MOVEQ	#SD_PXENQ,D5
GCU1	BSR	GWWD		ID -> A4
	MOVEA.L	A4,A0
	MOVEQ	#-1,D3
	MOVE.L	D5,D0
	TRAP	#0
	LINK	A5,#-8
	LEA	-8(A5),A1
	TRAP	#3
	TST.L	D0
	BNE	GCU_X	---->
	MOVE.L	-4(A5),D5 answer
	UNLK	A5
	ANDI	#$D8FF,SR
	BRA	SE_3
;
GCU_X	UNLK	A5
	ANDI	#$D8FF,SR
	BRA	BAD_EXIT	---->
;
; GLEN(<address>) returns the size of area needed to contain the
; string at <address>.
;
GLEN	BSR	GWWD	address -> A4
	MOVEQ	#0,D5	max characters in a line
	MOVEQ	#0,D2	no. of lines
	MOVE.W	(A4)+,D0	length of string
GLEN_1	SUBQ.W	#1,D0
	BMI	GLEN_3	done
	MOVE.W	D0,D3	count at start of line
	ADDQ.W	#1,D2	count lines
GLEN_2	CMPI.B	#10,(A4)+ LF? . . .
	DBEQ	D0,GLEN_2 . . . not yet
	BSR	G_MAX	set D5 to maximum line length so far
	BEQ	GLEN_1	more characters to look at
;
GLEN_3	SWAP	D5
	MOVE.W	D2,D5	max length | no. of lines
	BRA	SE_3	send answer
;
G_MAX	MOVE	CCR,-(A7)
	MOVE.W	D3,D1
	SUB.W	D0,D1	line length
	CMP.W	D1,D5
	BGT	G_MAX1
	MOVE.W	D1,D5
G_MAX1	RTR		return preserving COND CODES
;
LACTION
	MOVE.W	#$FF,D0		Mark "loose item"
	SWAP	D0
	MOVE.W	$10(A3),D0	item number
LACTION2	TST.B	D4		HIT = 0 : DO <> 0
	BEQ	LACTION1
	BSET	#24,D0		Set bit 24 for DO
LACTION1	BSET	#28,D0		Make D0 non-zero
	MOVEQ	#0,D4
	TST.L	D0
	RTS
;
; The action routine for an application window is called via WM.MHIT
; and refers to an item hit in the window.
;
; An exit from WM.RPTR is forced by setting a non-zero D0, which
; contains information. The third highest byte of D0 contains the
; application window number (0, 1, ...). The low word of D0 contains
; the item number (0, 1, ...).
; Bit 24 of D0 = 1 for a DO and 0 for a HIT
;
; (See also the notes on WRPTR.)
;
MACTION
	MOVEA.L	(A4),A1		status block
	MOVE.W	$C(A1),D0 	window number
	SWAP	D0
	MOVE.W	D2,D0		item number
	BRA	LACTION2
;
; MHITT calls WM.MHIT unless there is a 'do' or 'cancel'
; in which case D0 is set to $10yyFFFx where x=E for 'do' and F for 'cancel'
; and yy is the window number (0, 1, ...)
;
MHITT	TST.B	D4
	BEQ	MHITT2
	MOVEA.L	(A4),A1		status area
	TST.W	$30(A1)		is there an item? . .
	BMI	MHITT1		. . . no
MHITT2	JMP	WM.MHIT(A2)
MHITT1	MOVE.W	$C(A1),D0 	window number
	SWAP	D0
	BSET	#28,D0		Ensure D0 non-zero
	SUBI.W	#18,D4
	MOVE.W	D4,D0
	RTS
;
PANSC	JMP	WM.PANSC(A2)
;
OHT	JMP	WM.MHIT(A2)
;
SMEN	JMP	WM.SMENU(A2)
;
; DO_MDRW is the menu application drawing routine
; DO_ODRW is the drawing routine for a non menu application window
;
;	 movea.l	 $64(a3),a1	 address of status area
;	 MOVE.W	 $90(A3),D0	 number of actual columns . .
;	 MULU.W	 $92(A3),D0	 . . x number of actual rows
DO_MDRW	JSR	WM.INDEX(A2)
	BNE	DO_MDRW3
DO_ODRW	MOVEQ	#0,D3		draw all items
	JMP	WM.MDRAW(A2)
DO_MDRW3	RTS			---->
;
; MACR1 is the user control routine requested by ACR1.
;
; When the routine is called bt the PE software:
;	D2.W = 256*k + n
; where k = the item number and n the part of the bar to be panned/scrolled
; k is given as follows:
;
;  Space/Hit	Enter/Do		Where		D3.L
;      $70	     $74		Top arrows	-1
;      $71	     $75		Bottom arrows	-1
;      $72	     $76		Left arrows	-1
;      $73	     $77		Right arrows	-1
;      $78	     $7C		Scroll bar	pos | len
;      $7A	     $7E		Pan bar		pos | len
;
; In D3, pos is the position of the hit or do in the bar, and len is the length
; of the bar. Note that the "length of the bar" is not the length of the "indicator"
; inside the bar.
;
; <------ pos ------>
;  ------------------------------------------
; |    xxxxxxxxxxx			     |
;  ------------------------------------------
; <--------------- len ---------------------->
;
; In order that the value of D3 be made available to the S*BASIC programmer, it is
; stored in a space reserved by him. The pointer to this space is one of the
; parameters to WRPTR. So that the value of D3 can be found by WRPTR, MACR1 stores it
; temporarily in the zero long word marking the end of the application window list.
;
MACR1	BSR	APP_W
	BNE	MACR1_2	---->
MACR1_1	MOVE.L	D3,(A2)		store D3 there
	MOVEQ	#-3,D0		mark pan/scr
MACR1_2	SWAP	D0
	MOVE.W	D2,D0		keep D2 too and force an exit from WRPTR
	RTS
;
; APP_W sets A2 -> zero long word @ end of app list
;	   D1 -> no of app window
;	   D0 -> 0
;
;  If ERROR  D0 = -128
;
; At entry A4 = wwd
;
APP_W	MOVE.L	$70(A4),A2
	MOVE.W	$6E(A4),D0	no of apps
	SUBQ.W	#1,D0
	MOVE.W	D0,D1
	BMI	APP_WE		---->
APP_W1	CMPA.L	(A2)+,A3		This app window? . .
	DBEQ	D0,APP_W1 	. . no
	BNE	APP_WE		---->
	SUB.W	D0,D1		window no
	BRA	APP_W2
APP_W3	ADDQ.L	#4,A2
APP_W2	DBF	D0,APP_W3 	set A2 -> end of app list
	MOVEQ	#0,D0
APP_W4	RTS
;
APP_WE	MOVEQ	#-128,D0
	BRA	APP_W4
;
; LACT returns the address of the event action routine LACTION
;
LACT	LEA	LACTION,A0
LACT1	MOVE.L	A0,D5
	BRA	SE_3
;
; MACT returns the address of the menu action routine MACTION
;
MACT	LEA	MACTION,A0
	BRA	LACT1
;
; MHIT returns the address of the menu hit routine MHITT
;
MHIT	LEA	MHITT,A0
	BRA	LACT1
;
; ACR returns the address of the pan/scroll routine
;
ACR	LEA	PANSC,A0
	BRA	LACT1
;
; ACR1 returns the address of a user pan/scroll routine
;
ACR1	LEA	MACR1,A0
	BRA	LACT1
;
; OHIT returns the address of the basic hit routine
;
OHIT	LEA	OHT,A0
	BRA	LACT1
;
; MEN returns the address of the standard set menu routine
;
MEN	LEA	SMEN,A0
	BRA	LACT1
;
; M_MDRW returns the address of the draw routine for a menu
;
MDRW	LEA	DO_MDRW,A0
	BRA	LACT1
;
ODRW	LEA	DO_ODRW,A0
	BRA	LACT1
;
; OPE returns the ID of a con channel opened
;
OPE1	MOVEQ	#1,D4		mark SR
	BRA	OPE2
;
OPE	MOVEQ	#0,D4		mark OPE
OPE2	LEA	CON,A0
	MOVEQ	#-1,D1		this JOB
	MOVEQ	#0,D3
	MOVEQ	#IO_OPEN,D0
	TRAP	#2
	MOVE.L	A0,D5		ID
	TST.B	D4
	BEQ	RPTR_1
	RTS
;
CON	DC.W	3
	DC.B	"CON"
;
; CLOS(chid) closes channel chid
;
CLOS	LEA	8(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->	only one parameter wanted
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVE.L	(A1,A6.L),A0	ID
	ADDQ.L	#4,BV_RIP(A6)
CLOS_1	MOVEQ	#IO_CLOSE,D0
	TRAP	#2
	RTS
;
; IS_POINTER% returns 0 if no pointer environment, 1 otherwise
;
PTR	BSR	OPE1		set ID -> A0 . . .
	MOVE.L	A0,D6		. . . and D6
	MOVEQ	#-1,D3
	PEA	PTR_1
	BSR	GVEC_2
	MOVEQ	#1,D5		mark pointer present
	ADDQ.L	#4,A7		restore stack
	BRA	PTR_2
PTR_1	MOVEQ	#0,D5		mark pointer not present
PTR_2	MOVEA.L	D6,A0		restore ID
	BSR	CLOS_1		close channel
	BRA	DIB
;
; WH_PTR(wwd) returns the x,y coordinates of the pointer
;
WH_P	BSR	GWWD
	BSR	GVEC
	MOVEA.L	(A4),A1		status area
	MOVE.L	WS_PTPOS(A1),D5	pointer position
	BRA	SE_3		return it
;
; SET_PTR(wwd,pos[,key]) sets the pointer to the absolute position pos
; The position is absolute unless the optional parameter key is given.
; Key = -1 for position relative to the current window
;        0 for absolute position
;        1 for position relative to the hit area
;
S_PTR	MOVE.L	A5,A4		keep end of pars
	LEA	16(A3),A5
	CMP.L	A5,A4
	BLT	BAD_PARM	---->	we need at least 2 parameters
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVEM.L	(A1,A6.L),D6-7	wwd -> D6 | pos -> D7
;	 MOVE.L	(A1,A6.L),D6	wwd
;	 MOVE.L	 4(A1,A6.L),D7	 pos
	MOVEQ	#0,D2		set absolute pos
	CMPA.L	A5,A4		* corrected
	MOVEA.L	A5,A3		* 3 SEP 06
	MOVEA.L	A4,A5		*
	MOVEA.L	D6,A4		* condition codes not affected
	BEQ	S_PTR1		key = 0
;	 MOVEA.L	 A5,A3
;	 MOVEA.L	 D6,A5
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVE.W	(A1,A6.L),D2
S_PTR1	BSR	GVEC
	MOVE.L	D7,D1		pos
	MOVEQ	#-1,D3		timeout
	MOVEQ	#IOP.SPTR,D0
	TRAP	#3
	RTS

;
; GVEC sets the ptr vector to A1
; on entry A4 -> wdef
; no other registers used except A0, D0 and D1
;
GVEC	MOVEA.L	8(A4),A0		set ID -> A0
GVEC_2	MOVEQ	#IOP.PINF,D0
	MOVEQ	#-1,D3		Timeout
	TRAP	#3
	TST.L	D0
	BNE	GVEC_3	---->
	MOVE.L	A1,D0		Is WMAN vector there? . .
	BNE	GVEC_1		. . yes
	MOVEQ	#-7,D0		Mark NOT FOUND
GVEC_3	ADDQ.L	#4,A7
GVEC_1	RTS
;
; GWWD reads one long integer parameter to A4
;
GWWD	LEA	8(A3),A0
	CMPA.L	A5,A0
	BNE	GBAD	---->
GWWD1	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	GBAD	---->
	SUBQ.W	#1,D3
	BNE	GBAD	---->
	MOVEA.L	(A1,A6.L),A4
	ADDQ.L	#4,BV_RIP(A6)
	RTS
;
GBAD	ADDQ.L	#4,A7
	BRA	BAD_PARM	---->
;
; BSPSET addr,xorg,yorg,md,l[,alpha]
;
;	addr is where the result will be put
;	xorg,yorg is the sprite's origin
;	md is the QL mode (4 or 8)
;	l is the address of the sprite's data in an ALCHPd area
;	 containing what looks like a SuperBASIC array but with
;	 the 1st long word being a pointer to data relative to the
;	 start of the area.
;	alpha is optional. If present, it indicates that a alpha
;	 block is to be set up with value alpha (0 to 255).
;	 If alpha is -1 no block is set up.
;
;	The data for the sprite consists of a string for each row
;	ending with a null string. Each string indicates the colour
;	for each pixel.
;
;	The colours are indicated by:
;		a	black
;		u	blue
;		r	red
;		m	magenta
;		g	green
;		c	cyan
;		y	yellow
;		w	white
;		SPACE	transparent
;
;      Code disassembled with IDIS.SE
;      (C) by PL 1989
      

SP0000
       MOVEA.W $0118,A2		CA_GTLIN
       JSR	 (A2)
       BNE	 SP0001	---->
       MOVEQ	#-1,D7		mark no alpha pro tem  ** NEW **
       SUBQ.W  #$05,D3
       BEQ	SP_1				   ** NEW **
       SUBQ.W	#1,D3				   ** NEW **
       BNE	 SP0002	---->
       MOVE.L	$14(A6,A1.L),D7			   ** NEW **
SP_1   MOVE.L  $00(A6,A1.L),D0	addr (for sprite)
       BCLR	 #$00,D0
       BNE	 SP0002	---->
       MOVEA.L D0,A0
       MOVE.W  $06(A6,A1.L),$0008(A0)	xorg
       MOVE.W  $0A(A6,A1.L),$000A(A0)	yorg
       MOVE.W  $0E(A6,A1.L),D0	md
       MOVEQ	 #$00,D1
       ANDI.W  #$00FB,D0
       BEQ.S	 SP0003
       MOVEQ	 #$01,D1		set mode 8

SP0003 ORI.W	 #$0100,D1
       MOVE.W  D1,(A0)
       CLR.W	 $0002(A0)
       TST.W	D7		alpha block? . .	      ** NEW **
       BMI	SP_2		. . no		      ** NEW **
       CLR.B	(A0)		mark alpha block . .      ** NEW **
       MOVE.B	D7,3(A0)		. . and store the amount  ** NEW **
SP_2   MOVEA.L   $10(A6,A1.L),A2	address of sprite array
       CMPI.W  #$0002,$04(A2)
       BNE	SP0002	---->
       MOVE.W  $06(A2),D6
       ADDQ.W  #$01,D6
       MOVE.W  $0A(A2),D5
       MOVE.W  $08(A2),D4

SP0006 MOVE.W  D6,$0006(A0)		height
       SWAP	 D6
       SUB.W	 D5,D4
       SUBQ.W  #$02,D4

SP0007 MOVEQ	 #$01,D0
       AND.W	 (A0),D0
       ADDQ.W  #$01,D0
       MOVE.L  D0,D3		1 for mode 4, 2 for mode 8
       MOVE.W  D5,$0004(A0)		width
       MULU	 D5,D0
       BSR	 SP0008
       LEA	 $0018(A0),A3	-> start of colour pattern
       LEA	 $10(A0,D0.L),A4	-> start of pattern mask
       MOVEA.L	A4,A5		keep in A5 for alpha       ** NEW **
       ADDA.L    (A2),A2		-> start of data
       LEA	 SP0009,A1
       CMPI.W  #$0001,D3
       BEQ.S	 SP0010
       LEA	 SP0011,A1

SP0010 BSR.S	 SP0013
       MULU	 $0004(A0),D3	double width for . .
       MOVE.W  D3,$0004(A0)		. . mode 8
       TST.B	(A0)		alpha block? . .	   ** NEW **
       BEQ	SP_3		. . yes - process it   ** NEW **
SP_4   MOVEQ	 #$00,D0

SP0001 RTS

SP0002 MOVEQ	 #-$0F,D0
       BRA.S	 SP0001

;SP0012 BRA.S	  SP0013

SP0015 MOVE.W  (A1),D2

SP0022 SUB.L	 D3,D6
       TST.W	 D6
       BMI.S	 SP0016
       MOVEQ	 #$20,D1
       SUBQ.W  #$01,D7
       BMI.S	 SP0017
       MOVE.B  (A2)+,D1
       ORI.B	 #$20,D1

SP0017 MOVE.W  D2,D0
       NOT.W	 D0
       AND.W	 D0,(A3)
       AND.W	 D0,(A4)
       MOVEQ	 #$08,D0

SP0019 CMP.B	 SP0018(PC,D0.W),D1
       DBEQ	 D0,SP0019
       BNE.S	 SP0020	---->
       ADD.W	 D0,D0
       BEQ.S	 SP0021
       MOVE.W  $02(A1,D0.W),D0
       AND.W	 D2,D0
       OR.W	 D0,(A3)
       OR.W	 D2,(A4)

SP0021 LSR.W	 D3,D2
       BCC.S	 SP0022
       CMPM.W  (A3)+,(A4)+
       BRA.S	 SP0015

SP0016 ADDA.W  D4,A2

SP0013 CLR.W	 D6
       MOVEQ	 #$00,D0
       TST.L	 D6
       BEQ.S	 SP0014
       MOVE.W  D5,D6
;       MOVE.W  $0004(A0),D7
       MOVE.W  (A2)+,D7
       BRA.S	 SP0015

SP0020 MOVEQ	 #-$0F,D0

SP0014 RTS

SP0018 DC.B	 $20,$61
       DC.B	 $75,$72
       DC.B	 $6D,$67
       DC.B	 $63,$79
       DC.B	 $77,$00

SP0009 DC.B	 $80,$80
       DC.B	 $12,$34
       DC.B	 $00,$00
       DC.B	 $00,$00
       DC.B	 $00,$FF
       DC.B	 $00,$FF
       DC.B	 $FF,$00
       DC.B	 $FF,$00
       DC.B	 $FF,$FF
       DC.B	 $FF,$FF

SP0011 DC.B	 $C0,$C0
       DC.B	 $AB,$CD
       DC.B	 $00,$00
       DC.B	 $00,$55
       DC.B	 $00,$AA
       DC.B	 $00,$FF
       DC.B	 $AA,$00
       DC.B	 $AA,$55
       DC.B	 $AA,$AA
       DC.B	 $AA,$FF
       DC.B	 $00,$00

SP0008 ADDI.W  #$000F,D0
       ANDI.W  #$FFF0,D0
       MOVE.W  D0,D5
       ASR.W	 #2,D0
       MULU	 $0006(A0),D0
       ADDQ.L  #$08,D0
       MOVE.L  D0,$0010(A0)
       MOVE.L  #$0000000C,$000C(A0)
       CLR.L	 $0014(A0)
SP_5   RTS
;
; This sets an alpha block.
; Register usage:
;	D0 pixels
;	D1 count of 8 or residual pixels
;	D2 count of words
;	D3 residual pixels
;	D4 number of 8-pixel words (for resetting D2)
;	D5 height h
;	D6 size of alpha block
;	D7 alpha constant (0 to 255)
;
;	A0 alchp'd space for temporary alpha block
;	A1 pointer to that space
;	A5 start of alpha block/pattern mask
;	A4 pointer to pattern mask
;
SP_3	MOVE.B	3(A0),D7		alpha amount a
	MOVE.B	#$20,3(A0)	mark alpha block present
	MOVE.B	#1,(A0)		reset mode 4/8 marker
	MOVE.W	4(A0),D1		width
	MOVE.W	D1,D4		keep in D4
	MOVE.W	6(A0),D5		height
	MULU.W	D5,D1		width*height
	MOVE.L	D1,D6		size of alpha block
	MOVEQ	#-1,D2		this Job
	MOVEQ	#MT_ALCHP,D0
	TRAP	#1		get space
	TST.L	D0
	BNE	SP_5	---->
	MOVEA.L	A0,A1
	MOVEA.L	A5,A4
	MOVE.L	D4,D3
	ANDI.W	#15,D3		residual pixels
	SUBQ.W	#1,D3
	LSR.W	#4,D4		number of 16-pixel long words
	BRA	SP_6
SP_7	MOVE.W	D4,D2
	MOVEQ	#15,D1		count 16 pixels
SP_13	TST.W	D2		last block? . .
	BNE	SP_8		. . no
	MOVE.W	D3,D1		count residual pixels
	BMI	SP_9		ended
SP_8	MOVE.L	(A4)+,D0		get next four bytes  A|B|C|D
	LSR.L	#8,D0		D0.W -> B|C
SP_10	LSL.W	#1,D0
	BCS	SP_11
	CLR.B	(A1)
	BRA	SP_12
SP_11	MOVE.B	D7,(A1)
SP_12	ADDQ.L	#1,A1
	DBF	D1,SP_10		count up to 16 pixels
SP_9	DBF	D2,SP_13		count number of 16-pixel long words
SP_6	DBF	D5,SP_7		count number of rows
;
; Now the alpha block is set it must go to A5
;
	MOVEA.L	A0,A1
	BRA	SP_14
SP_15	MOVE.B	(A1)+,(A5)+
SP_14	DBF	D6,SP_15
	MOVEQ	#MT_RECHP,D0
	TRAP	#1
	BRA	SP_4		ended
;
; HX([#ch,] k) prints a long word k on channel #ch (default #1) as hex
;
HX	MOVEQ	#-10,D0		 space needed
	SUB.L	BV_BFBAS(A6),D0	 buffer top
	ADD.L	BV_TKBAS(A6),D0	 buffer base
	BMI	BUF_FUL	---->
	LEA	8(A3),A4		-> last parameter?
	MOVEQ	#1,D0		default channel -> D0
	BTST	#7,1(A3,A6.L)	#? . . .
	BEQ	HX_1		. . . no
	LEA	16(A3),A4 	-> last parameter!
	CMPA.L	A4,A5
	BNE	BAD_PARM	---->
	LEA	8(A3),A5		get one parameter
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)		get channel number . .
	BNE	BAD_PARM	---->
	MOVE.W	(A1,A6.L),D0	. . . -> D0
	ADDQ.L	#2,BV_RIP(A6)	adjust stack
	LEA	8(A5),A5		to next . . .
	LEA	8(A3),A3		. . . parameter
HX_1	CMPA.L	A4,A5
	BNE	BAD_PARM	---->
	MULU.W	#$28,D0
	MOVEA.L	BV_CHBAS(A6),A0
	ADDA.L	D0,A0
	CMPA.L	BV_CHP(A6),A0
	BGE	NOT_CHAN	---->
	MOVE.L	(A0,A6.L),D0
	BLT	NOT_CHAN	---->
	MOVEA.L	D0,A4		keep ID
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVEA.L	BV_BFBAS(A6),A0
	MOVE.B	#' ',(A0,A6.L)	set space to start
	ADDQ.L	#1,A0		make space for $
	MOVE.L	A0,D7		keep in D7
	MOVEA.W	CN_ITOHL,A2
	JSR	(A2)
	MOVEA.L	D7,A0		to start of hex number
	MOVEQ	#7,D0		count
	BRA	HX_2
HX_3	MOVE.B	#' ',(A0,A6.L)	replace '0' by SPACE
	ADDQ.L	#1,A0
HX_2	CMP.B	#'0',(A0,A6.L)
	DBNE	D0,HX_3		go on till not 0
	MOVE.B	#'$',-1(A0,A6.L)
;
; now the ASCII number (plus $) is in the basic buffer
;
	ADDQ.L	#4,BV_RIP(A6)	tidy stack
	MOVEA.L	A4,A0		ID
	MOVEA.L	BV_BFBAS(A6),A1	pointer to string (rel to A6)
	MOVEQ	#10,D2
	MOVE.B	D2,9(A1,A6.L)	LF
	MOVEQ	#-1,D3		timeout
	MOVEQ	#IO_SSTRG,D0
	TRAP	#4
	TRAP	#3
	RTS			return to BASIC (with any errors)
*
CH_USE	CMP.L	A3,A5	Pars?
	BNE.S	READ_CH	Yes
RESET_CHL MOVE.L	BV_CHBAS(A6),A1
	LEA	40(A1),A1
	LEA	JB_SP,A2
	MOVEQ	#MT_INF,D0	D1 = job ID
	TRAP	#1
	TRAP	#0
;
; Now in supervisor mode
;
	MOVE.W	SR,D7
	ORI	#$700,SR		stop interrupts
	MOVEQ	#N_Jobs-1,D2
L1	CMP.L	(A2)+,D1		see if this job in list
	DBEQ	D2,L1
	BNE	NO_ERROR1 ---->	not there
	MOVE.L	4*N_JOBS-4(A2),(A1,A6.L)	reset #ID
	ST	-2(A2)		clear this item
	ANDI.W	#$DFFF,D7
	MOVE	D7,SR
;
; Now back to user mode
;
	MOVEQ	#4,D3
CLEAR_CHL ADDQ.L	#4,A1
	CLR.L	(A1,A6.L)
	DBF	D3,CLEAR_CHL
	MOVEQ	#80,D3
	MOVE.L	D3,4(A1,A6.L)
	BRA	NO_ERROR
*
* Read channel no -> D3
*
READ_CH	LEA	8(A3),A0
	CMP.L	A0,A5
	BNE	BAD_PARM	---->
	MOVE.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_EXIT
	MOVE.W	(A1,A6.L),D3
	CMPI.W	#1,D3		USE#1 means reset
	BEQ	RESET_CHL
*
* Track down data in channel table
*
	MOVE.L	BV_CHBAS(A6),A1
	MOVEQ	#40,D4
*
* Check channel no in D3 and convert to offset
*
CHAN_SEL	MULU.W	D4,D3
	ADD.L	A1,D3
	CMP.L	BV_CHP(A6),D3
	BGE	NOT_CHAN ---->
	MOVE.L	(A6,D3.L),D5
	BMI	NOT_CHAN ---->
	ADD.L	A1,D4
	MOVEQ	#MT_INF,D0
	TRAP	#1		A0 -> SYS VARS, D1 = JOB ID
	LEA	JB_SP,A2
	MOVEQ	#N_Jobs-1,D2	count
	TRAP	#0
;
; supervisor mode
;
	MOVE.W	SR,D7
	ORI	#$700,SR		stop interrupts
L2	CMP.L	(A2)+,D1		is job in list? . .
	DBEQ	D2,L2
	BEQ	CPY_CH1		. . yes, #1 already saved
	MOVEQ	#N_Jobs-1,D2	count again
L3	TST.B	-2(A2)		free space? . .
	SUBQ.L	#4,A2
	DBMI	D2,L3
	BPL	L6		. . not yet
	ADDQ.L	#4,A2
	BRA	L4		space found
;
; We must see if jobs in the list are current
;
L6	MOVEQ	#N_Jobs-1,D2
	MOVE.L	SV_JBBAS(A0),A0	pointer to job list
L5	MOVE.L	(A2)+,D6		Job ID in list
	MOVE.W	D6,D0
	LSL.W	#2,D0
	MOVE.L	(A0,D0.W),D0	pointer to job
	BMI	L4		Job dead - so space found
	MOVEA.L	D0,A5
	MOVE.W	JB_TAG(A5),D0	current job tag
	SWAP	D6
	CMP.W	D6,D0		all same job? . .
	DBNE	D2,L5
	BEQ	NO_ROOM		. . yes - so no room
L4	MOVE.L	D1,-4(A2) 	set job ID
	MOVE.L	(A6,D4.L),4*N_JOBS-4(A2)	set #ID
*
* Copy from offset D3 -> offset D4
*
CPY_CH1	MOVEQ	#9,D2
COPY_CH	MOVE.L	(A6,D3.L),(A6,D4.L)
	ADDQ.L	#4,D3
	ADDQ.L	#4,D4
	DBF	D2,COPY_CH
*
NO_ERROR1 ANDI.W	#$DFFF,D7
	MOVE	D7,SR
NO_ERROR	MOVEQ	#0,D0
	RTS
;
NO_ROOM	ANDI.W	#$DFFF,D7
	MOVE	D7,SR
;
; -> user mode
;
	MOVEQ	#-5,D0
	RTS
;
JB_SP	DCB.L	N_Jobs,-1
	DCB.L	N_Jobs,0
;
; JB_SP is a table of N_Jobs job IDs where USE is in operation.
; An entry with negative bottom word indicates a free space.
; The second set of four long words is for the corresponding
; #IDs for that SBASIC's channel 1.
;

*
* MODE% returns the mode 4, 8, 33 or whatever
*
MDE	moveq	#-1,d1	ask for mode
	moveq	#-1,d2	ask for display
	moveq	#mt_dmode,d0
	trap	#1
	moveq	#0,d5
	move.b	d1,d5
	bne	DIB	not mode 4
	moveq	#4,d5	set mode 4
	BRA	DIB
;
; BSVPW([#ch], buffer, bxo, byo, wszx, wszy, wxo, wyo [, bszx, bszy])
;   saves part of a window in a buffer and returns its address.
;
; BRSPW [#ch], buffer, bxo, byo, wszx, wszy, wxo, wyo [, keep]
;   restores part of a window from a buffer.
;
; The channel, ch, is optional and defaults to #1. This channel defines
; the window.
;
; "buffer" is the address of the _PSA buffer. A new buffer is set up by
; BSVPW of size bszx/bszy pixels if these parameters are given, in which
; case "buffer" should be zero.
;
; bxo/byo   is the initial position in the buffer used for storing or
;	  restoring the partial window.
;
; wszx/wszy is the size of the partial area in pixels
;
; wxo/wyo   is the origin in the window of the partial area
;
; The parameter "keep" in BRSPW is optional. If it is not given, or given
; as zero, the buffer is thrown away after the area is restored.
;
; If the mode is 8, the parameters bxo, wszx, wxo and bszx must be even.
;
SVPW	MOVEQ	#IOP.SVPW,D7
	BRA	RSPW_1
;
RSPW	MOVEQ	#IOP.RSPW,D7
RSPW_1	MOVEQ	#-14,D0		 space needed
	SUB.L	BV_BFBAS(A6),D0	buffer top
	ADD.L	BV_TKBAS(A6),D0	buffer base
	BMI	BUF_FUL	---->
	MOVE.L	A3,D6		keep parameter pointer
	MOVEQ	#-1,D1		read mode
	MOVEQ	#-1,D2		read display
	MOVEQ	#MT_DMODE,D0
	TRAP	#1		set mode in D1.B
	MOVEA.L	D6,A3		restore parameter pointer
	MOVEQ	#0,D6		provisionally mark not mode 8
	SUBQ.B	#8,D1
	BNE	RSPW_M		not mode 8
	MOVEQ	#1,D6
	SWAP	D6		mark mode 8 and set mask
RSPW_M	CMPA.L	A3,A5		must be at least 1 par!
	MOVEA.L	A5,A4
	BLE	BAD_PARM	---->
	MOVEQ	#1,D0		default channel
	BTST	#7,1(A3,A6.L)	#? . . .
	BEQ	RSPW_2		. . . no
	LEA	8(A3),A5		to get channel number
	MOVEA.W	CA_GTINT,A2
	BSR	SVPW_4		preserves D6
;	 JSR	 (A2)		 get channel number . .
;	 BNE	 BAD_PARM  ---->
	MOVE.W	(A1,A6.L),D0	. . . -> D5
	ADDQ.L	#2,BV_RIP(A6)	adjust stack
	LEA	8(A3),A3		to next . . .
RSPW_2	LEA	8(A3),A5		prepare to get 1 parameter
	LEA	7*8(A3),A0
	CMPA.L	A0,A4
	BLT	BAD_PARM	---->	there must be > 6 parameters
	MULU.W	#$28,D0
	MOVEA.L	BV_CHBAS(A6),A0
	ADDA.L	D0,A0
	CMPA.L	BV_CHP(A6),A0
	BGE	NOT_CHAN	---->
	MOVE.L	(A0,A6.L),D0
	BLT	NOT_CHAN	---->
	MOVE.L	D0,D5		keep ID
	MOVEA.W	CA_GTLIN,A2
	BSR	SVPW_4		preserves D6
;	 JSR	 (A2)		 read buffer
;	 BNE	 BAD_PARM  ---->
	LEA	8(A3),A3		arrange to read . .
	LEA	6*8(A5),A5	. . six integers
	MOVEA.W	CA_GTINT,A2
	BSR	SVPW_4		preserves D6
;	 JSR	 (A2)
;	 BNE	 BAD_PARM  ---->
	MOVEQ	#16,D0
	ADD.L	D0,BV_RIP(A6)	adjust stack
	MOVEA.L	BV_BFBAS(A6),A0
	MOVE.L	12(A1,A6.L),(A0,A6.L) keep "buffer"
	MOVEQ	#2,D0
RSPW_4	MOVE.L	(A1,A6.L),D2
	MOVE.L	D2,4(A0,A6.L)
	AND.L	D6,D2		if mode 8 test for even x
	BNE	BAD_PARM	---->
	ADDQ.L	#4,A1
	ADDQ.L	#4,A0
	DBF	D0,RSPW_4
	MOVEA.L	A5,A3
	MOVEQ	#0,D2		set "don't keep" provisionally
	MOVEA.L	A4,A5
	CMP.B	#IOP.SVPW,D7
	BEQ	SVPW_1
	CMPA.L	A3,A5		is there a "keep" parameter? . .
	BEQ	SVPW_3		. . no - don't keep save area
	LEA	8(A3),A2
	CMPA.L	A2,A5
	BNE	BAD_PARM	---->
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)		read in "keep"
	BNE	BAD_PARM	---->
	MOVE.W	(A1,A6.L),D2	set "keep"
	ADDQ.L	#2,BV_RIP(A6)
SVPW_3	MOVEA.L	D5,A0		ID
	MOVEA.L	BV_BFBAS(A6),A5
	MOVE.L	4(A5,A6.L),D1	set start of block in area
	MOVEA.L	(A5,A6.L),A2	buffer address
	MOVE.L	D7,D0
	LEA	8(A5),A1		relative start of window block
	MOVEQ	#-1,D3		timeout
	TRAP	#4
	TRAP	#3
	MOVE.L	D1,D5		buffer base to D5 (for BSVPW)
	TST.L	D0
	RTS

;
SVPW_1	CMPA.L	A3,A5		is there a save area? . .
	BEQ	SVPW_2		. . no
	LEA	16(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->	there must be two parameters
	MOVEA.W	CA_GTINT,A2
	BSR	SVPW_4
;	 JSR	 (A2)
;	 BNE	 BAD_PARM  ---->
	ADDQ.L	#4,BV_RIP(A6)
	MOVE.L	(A1,A6.L),D2	size of save area
	AND.L	D2,D6		if mode 8 test for even x
	BNE	BAD_PARM	---->
SVPW_2	BSR	SVPW_3
	BNE	BAD_EXIT	---->
	BRA	SE_3
;
SVPW_4	MOVE.L	D6,-(A7)
	JSR	(A2)
	MOVEM.L	(A7)+,D6
	BNE	BAD_PARM1 ---->
	RTS


*
* PNAME$ returns the current program's name.
* if none it returns ANON.
*
PNAM	CMPA.L	A3,A5
	BNE	BAD_PARM	---->
	MOVEQ	#-1,D1
	MOVEQ	#0,D2
	MOVEQ	#MT_JINF,D0
	TRAP	#1
	LEA	6(A0),A0
	CMPI.W	#$4AFB,(A0)+	Is there a name? . .
	BEQ	PNAM_YES		. . yes
PNAM_NO	LEA	NO_NAME,A0
PNAM_YES	MOVEQ	#0,D1
	MOVE.W	(A0),D1		length of name
	BEQ	PNAM_NO
	ADDQ.L	#1,D1
	BCLR	#0,D1
	MOVE.L	D1,D4		KEEP IN d4
	ADDQ.L	#2,D1
	BSR	CHECK		get enough space
	LSR.L	#1,D4		number of words - 1
PNAM2	MOVE.W	(A0)+,(A1,A6.L)
	ADDQ.L	#2,A1
	DBF	D4,PNAM2
	MOVEQ	#1,D4		mark string
	MOVEQ	#0,D0		mark no error
	RTS
*
	HED1	 <"NO NAME">,NO_NAME
*
*
* CL33TO64(cl%) returns the internal 24 bit colour for the Mode 33 colour cl%
*
CL	LEA	8(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	ADDQ.L	#2,BV_RIP(A6)	Reset the maths stack
	MOVEQ	#0,D1		Make sure D1 top is zero
	MOVE.W	(A1,A6.L),D1	Mode 33 colour
	MOVEQ	#2,D5		count
	MOVEQ	#0,D7		prepare for w
	BCLR	#0,D1		is w zero? . .
	BEQ	CL_1		. . yes
	MOVEQ	#1,D7		set w = 1
CL_1	LSL.L	#5,D1		push the next 5 bits to D1 Top
	SWAP	D1		bits now in D1.W
	ADD.W	D1,D1		prepare to add . .
	ADD.W	D7,D1		. . w
	BEQ	CL_2		Black
	LSL.W	#2,D1		Fill in the . .
	ADDQ.W	#3,D1		. . bottom bits
CL_2	MOVE.W	D1,-(A7)		store the answer
	CLR.W	D1		prepare for the next colour
	SWAP	D1
	DBF	D5,CL_1
	MOVEQ	#2,D1		"count"
CL_3	ANDI.W	#7,D1		we only want the bottom three bits
	MOVE.W	(A7,D1.W),D0	Retrieve colours red, green, blue
	MOVE.B	D0,D5		Insert the colour . .
	LSL.L	#8,D5		. . and push it up
	ADD.W	D1,D1		2 -> 4 -> 8 -> 0
	BNE	CL_3
	LEA	6(A7),A7		Adjust the stack
	BRA	SE_3		Return the answer

*
* CL33T32 ( cl%, w% [, s%]) switches colours between Modes 33 and 32
* cl% = colour value
* w% = 0 for mode 32 -> mode 33
*      1 for mode 33 -> mode 32
* s% = 1 for mode 32 byte switch
*      0 (default) for no switch
*
* NB The switch triggered by s% <> 0 arises because the mode 32 colour value
*    appearing in the screen buffer and in a PSA (partial save area) has
*    the bytes reversed. Thus the value described in the GD2 manual is
*    $F800 for red, but this is $00F8 in the PSA.
*
CL33	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVEQ	#0,D7		s%=0 & w%=0
	SUBQ.W	#2,D3		Two pars? . .
	BMI	BAD_PARM	---->	. . no, less than two . .
	BEQ	CL33_1		. . yes, just 2
	SUBQ.W	#1,D3		Three pars? . .
	BNE	BAD_PARM	---->	. . no
	MOVE.W	4(A6,A1.L),D7	Set s%
	ADDQ.L	#2,BV_RIP(A6)
CL33_1	MOVE.W	(A6,A1.L),D0	cl%
	MOVE.W	2(A6,A1.L),D5	w%
	BEQ	CL33_2		w%=0
	BSET	#31,D7		Mark w%=1
	MOVEQ	#16,D5		set offset
	BRA	CL33_3
CL33_2	TST.W	D7		s% zero? . .
	BEQ	CL33_3		. . yes
	ROL.W	#8,D0		swap bytes
CL33_3	MOVEQ	#$1F,D1
	LEA	K32(D5.W),A0	set shifts
	MOVEQ	#0,D5		set answer to zero
	MOVEM.W	(A0)+,D3-4
	BTST	D3,D0		To set W bit
	BEQ	CL33_5
	BSET	D4,D5
CL33_5	MOVEQ	#2,D2		count of 3
CL33_4	BSR	CL33_GET
	DBF	D2,CL33_4
	TST.W	D7		s%
	BEQ	CL33_6
	TST.L	D7		w%
	BPL	CL33_6
	ROL.W	#8,D5		switch mode 32 answer
CL33_6	ADDQ.L	#2,BV_RIP(A6)	allow for an integer return
	MOVEA.L	BV_RIP(A6),A1
	BRA	DIB2		return an integer from D5

CL33_GET	MOVEM.W	(A0)+,D3-4
	LSL.L	D3,D0
	SWAP	D0
	AND.W	D1,D0
	LSL.W	D4,D0
	OR.W	D0,D5
	SWAP	D0
	RTS

K32	DC.W	5,0,5,6,5,11,6,1
K33	DC.W	0,5,5,6,5,11,5,0

************************************************
*	 For SMSQ/E v 3.x		       *
************************************************
* BSPAL pal [,job, tag] | address [,job, tag]
* sets the system palette for the job indicated. If the first parameter
* is "pal", a number between 0 and 3, the system palette of that number is set.
* If the first parameter is "address" the palette is set from that address.
*
* If no job ID is given the current job is assumed.
*
BSPAL	MOVE.L	A5,D7
	SUB.L	A3,D7
	LSR.L	#3,D7		number of pars
	BEQ	BAD_PARM	---->
	LEA	8(A3),A5		prepare to get one parameter
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVE.W	(A1,A6.L),D0
	BEQ	BSPAL_1		"pal"
	MOVEA.L	(A1,A6.L),A4	keep address in A4
	MOVEQ	#-1,D5		set "pal" to -1
	BRA	BSPAL_2
BSPAL_1	MOVE.W	2(A1,A6.L),D5	set "pal"
	SUBA.L	A4,A4		set zero pointer
BSPAL_2	SUBQ.L	#2,D7
	BMI	BSPAL_3		only one parameter (D7.L = -1)
	SUBQ.L	#1,D7
	BNE	BAD_PARM	---->
	MOVEA.L	A5,A3
	LEA	2*8(A5),A5
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVE.W	2(A1,A6.L),D7
	SWAP	D7
	MOVE.W	(A1,A6.L),D7	ID of job in D7
BSPAL_3	BSR	GVECS		set the WMAN vector in A1
	BNE	BAD_PARM	---->
	MOVEA.L	A1,A2
	MOVE.L	D7,D1
	MOVE.W	D5,D3
	MOVEA.L	A4,A1
	JSR	WM.JBPAL(A2)
	TST.L	D0
	BMI	BSPAL_4		True error - else 0 or -> palette
	MOVEQ	#0,D0
BSPAL_4	RTS
*
*
* BFRAME(sz_x,[sz_y]) returns the position (x|y) allocated in the button frame,
* -7 if no button frame or -4 if no room.
*
* The parameter sz_x, which is the width of the button, is mandatory.
* The parameter sz_y, which is the height, is optional. If it is not given
* a default value of 14 is used.
*
BFR	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	SUBQ.W	#1,D3
	BMI	BAD_PARM	---->	We need 1, or 2 pars
	ADDQ.L	#2,BV_RIP(A6)	Adjust for 1st parameter
	MOVEQ	#14,D2		Default sz_y
	SWAP	D2
	MOVE.W	(A1,A6.L),D2	1st parameter sz_x
	SWAP	D2
	SUBQ.W	#1,D3
	BMI	BFR1		Just one parameter
	BEQ	BFR2		2 parameters
	BRA	BAD_PARM	---->	More than 2 parameters
BFR2	MOVE.W	(A1,A6.L),D2
	ADDQ.L	#2,BV_RIP(A6)	Adjust for 2nd par
BFR1	BSR	GETVEC		Get THING vector -> A2
	TST.L	D0
	BNE	BFR4	---->
	MOVEQ	#-1,D1		this JOB
	MOVEQ	#0,D3		New allocation
	LEA	BUT,A0
	MOVEQ	#$28,D0		Use Thing
	JSR	(A2)
	TST.L	D0
	BEQ	BFR3		Button frame exists
BFR4	MOVE.L	D0,D2		Return error code
	MOVEQ	#0,D0		Mark no error
BFR3	MOVE.L	D2,D5
	BRA	SE_3
*
* BFREE frees the button. No parameters needed
*
BRE	CMPA.L	A3,A5
	BNE	BAD_PARM	---->
	BSR	GETVEC
	TST.L	D0
	BNE	BRE1	---->
	MOVEQ	#-1,D1		This JOB
	LEA	BUT,A0
	MOVEQ	#$29,D0		Free
	JSR	(A2)
BRE1	MOVEQ	#0,D0
	RTS
*
	HED1	<"Button Frame">,BUT
*
* G_PR returns the priority of the current job
*
G_PR	CMPA.L	A3,A5
	BNE	BAD_PARM	---->
	MOVEQ	#MT_JINF,D0
	MOVEQ	#-1,D1		This job
	MOVEQ	#0,D2
	TRAP	#1
	MOVE.B	JB_PRINC-$68(A0),D5     Priority
	BRA	DIB1
*
* S_PR p sets priority p to the current job. It is an error if p<1 or p>127
*
S_PR	LEA	8(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVE.B	1(A1,A6.L),D2	Priority
	BGT	S_PR1
	BNE	S_PR2
	MOVEQ	#1,D2
	BRA	S_PR1
S_PR2	MOVEQ	#127,D2
S_PR1	MOVEQ	#-1,D1		This job
	MOVEQ	#MT_PRIOR,D0
	TRAP	#1
	TST.L	D0
	RTS
*
* N_CHAN% sets the first free basic channel > 2
*
N_CHAN	MOVEQ	#3,D5		Set 1st to 3
	MOVEA.L	BV_CHBAS(A6),A2
	LEA	3*40(A2),A2	Start @ #3
	MOVEA.L	BV_CHP(A6),A3
N_CHAN1	CMPA.L	A3,A2		Finished? . .
	BCC	DIB		. . yes
	TST.B	(A2,A6.L) 	A closed channel? . .
	BMI	DIB		. . yes
	LEA	40(A2),A2 	To the next channel
	ADDQ.W	#1,D5		Advance the channel number
	BRA	N_CHAN1
*
* BASIC_SRT%(dx%) returns the 1st byte of the type word for item dx%
*
B_SRT	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	SUBQ.W	#1,D3
	BNE	BAD_PARM	---->	1 parameter needed
	MOVE.W	(A1,A6.L),D3	dx%
	BMI	BAD_PARM	---->
	TRAP	#0
	ORI.W	#$0700,SR
	MOVEQ	#MT_INF,D0
	TRAP	#1
	MOVEA.L	SV_JBBAS(A0),A0
	MOVEA.L	(A0),A0
	MOVEA.L	JB_A6(A0),A0
	MOVEA.L	BV_NTBAS(A0),A2
	ADDA.L	A0,A2
	LSL.W	#3,D3
	LEA	(A2,D3.W),A3
	SUBA.L	A0,A3
	CMPA.L	BV_NTP(A0),A3
	BPL	B_SRT1	---->
	MOVE.B	(A2,D3.W),D5
	ANDI.W	#15,D5
	ANDI	#-$2701,SR
	BRA	DIB2
*
B_SRT1	ANDI	#-$2701,SR
	BRA	BAD_PARM	---->
*
* A new get window size
* temporarily called GWZ
*
GWZ:
	MOVEQ	#MT_INF,D0
	TRAP	#1
	CMPI.L	#'1.03',D2
	BLE	PSET_DF	---->	The default 512/256
	CMPI.L	#'3.12',D2	SMSQE v3.12+? . .
	BGE	GWZF		. . yes
	MOVEQ	#64,D3
	ADD.L	D3,D3		Set 128 dataspace
	MOVEQ	#0,D2		Set zero code space
	LEA	PSET_WIN,A1	Set start address of job
	MOVEQ	#-1,D1		This job
	MOVEQ	#MT_CJOB,D0
	TRAP	#1
	TST.L	D0
	BNE	PSET_DF	---->	Something went wrong
	MOVEQ	#120,D2		Priority (quick!)
	MOVEQ	#-1,D3		EW
	MOVEQ	#MT_ACTIV,D0
	TRAP	#1
	TST.L	D0
	BGT	GWZ1
PSET_DF	MOVE.L	#$2000100,D0
GWZ1	MOVE.L	D0,D5
	BRA	SE_3

GWZF	MOVEA.L	SYS_CLNK(A0),A0
	MOVE.L	PT_XSCRS(A0),D5
	BRA	SE_3
*
PSET_WIN:
	LEA	(A6,A4.L),A6	-> DATA SPACE
	MOVE.L	#4,(A6)		Relative address of buffer
	BSR	SET_WIN
	MOVE.L	4(A6),D3		Answer
	MOVEQ	#-1,D1		This job
	MOVEQ	#MT_FRJOB,D0
	TRAP	#1
*
* M_DRBDR wwd,k% draws a border if k%=1 : unsets the border if k%=0
*	The status area must contain values of ws_citem, ws_cibrw, ws_cipap
*	and ws_cihit.
*
*	For unsetting, the MS bit of ws_citem is set.
*
* M_DRBDN wwd,k% is exactly the same as M_DRBDR except that it is a function
*	returning the value of D0 after the call to WM.DRBDR
*
DRBDN	MOVEQ	#1,D6		mark "function"
	BRA	DRBDR4
DRBDR	MOVEQ	#0,D6		mark "procedure"
DRBDR4	LEA	$10(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->
	LEA	8(A3),A5
	BSR	GWWD1		Set wwd -> A4
	MOVEA.L	A5,A3
	BSR	GVEC
	MOVE.L	A1,D5
	LEA	8(A3),A5
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVE.W	(A1,A6.L),D7
	MOVEA.L	(A4),A1		status area
	MOVEA.L	8(A4),A0		ID
	BNE	DRBDR2		Set
	BSET	#7,WS_CITEM(A1)	Set item for clear
	MOVE.L	WS_CIACT(A1),D0	Action routine? . .
	BEQ	DRBDR2		 . .  no
	BSR	DRBDR3
DRBDR2	MOVEA.L	D5,A2		Window Mwnager Vector
	JSR	WM.DRBDR(A2)
	BCLR	#7,WS_CITEM(A1)	Clear top bit if needed
	MOVE.L	D0,D5
	TST.L	D6
	BNE	DIB		If "function" return error code
	RTS
*
DRBDR3	MOVE.L	A1,-(A7)
	MOVE.L	$E(A1),D1
	ADD.L	$24(A4),D1	Abs pointer pos
	MOVEQ	#1,D2		A "hit"
	MOVEQ	#0,D4
	MOVE.W	WS_CITEM,D0
	BCLR	#8,D0		Item number
	MULU.W	#$16,D0
	ADD.L	$6A(A4),D0
	MOVEA.L	D0,A3		-> loose item
	JSR	WS_CIACT(A1)
	MOVEA.L	(A7)+,A1
	CLR.L	WS_CIACT(A1)
	RTS
*
GETVEC	MOVE.L	D2,-(A7)
	MOVEQ	#MT_INF,D0
	TRAP	#1
	MOVE.L	$B8(A0),D1	Thing list
	BEQ	GETVEC_E	---->	No thing list
	MOVEA.L	D1,A0
GETVEC1	MOVE.L	(A0),D1
	BEQ	GETVEC2		Found
	MOVEA.L	D1,A0
	BRA	GETVEC1
GETVEC2	MOVEA.L	$10(A0),A0
	MOVE.L	4(A0),D1
	ADDQ.L	#1,D1
	BNE	GETVEC_E	---->	Not THING thing
	MOVEA.L	8(A0),A2
GETVEC3	MOVE.L	(A7)+,D2
	RTS
*
GETVEC_E	MOVEQ	#-7,D0		Not found
	BRA	GETVEC3
;
; GVECS sets the WMAN vector without a channel being needed
; This is for SMSQ/E v 3.xx
; The WMAN vector is set in A1
; On a correct exit D0 = 0: Else it is -1
;
; A0, A1, A3, D0 - 2 are used
;
GVECS	MOVEQ	#MT_INF,D0
	TRAP	#1
	MOVE.L	$C4(A0),D0
	BEQ	GVECS_E	---->
	MOVEA.L	D0,A3
	MOVE.L	PT_VECS(A3),A0
	JSR	PV_PINF(A0)
	MOVEQ	#0,D0
	RTS
;
GVECS_E	MOVEQ	#-1,D0
	RTS

; To find the largest window
; The size is put in the Basic Buffer
;
SW_REG	REG	D7/A0
;
SET_WIN	MOVEM.L	SW_REG,-(A7)
	BSR	OPE1
	MOVE.L	#MIN_WIDTH,D6
	MOVE.L	#MAX_WIDTH,D7
	MOVEA.L	BV_BFBAS(A6),A4	basic buffer rel to A6
	MOVEQ	#2,D5		"count"
	MOVEQ	#-1,D3		Timeout
	MOVE.W	#2,2(A4,A6.L)	Set height 2
	CLR.L	4(A4,A6.L)	Set origin to 0
LOOP1	MOVE.W	D7,(A4,A6.L)	Set maximum width 1st time, then height
;
; Top is in D7 : Bot in D6
; Loop until Top = Bot
; Size window depth (Top+Bot)/2
; If successful - set Bot = (Top+Bot)/2
;  else set Top = (Top+Bot)/2
;
LOOP	MOVE.W	D7,D0
	SUB.W	D6,D0
	BEQ	DONE1
	CMPI.W	#1,D0
	BEQ	H_DONE
	MOVE.W	D6,D0
	ADD.W	D7,D0
	LSR.W	#1,D0	new trial height
	BSR	TRY
	BNE	NOGO
	MOVE.W	(A4,A6.L),D6
	BRA	LOOP
NOGO	MOVE.W	(A4,A6.L),D7
	BRA	LOOP
;
DONE1	MOVE.W	D6,(A4,A6.L)
	SUBQ.W	#2,D5		0 for second time
	BNE	DONE2		finished
	ADDQ.L	#2,A4		point to height now
	MOVE.L	#MIN_HGT,D6
	MOVE.L	#MAX_HGT,D7
	BRA	LOOP1
;
DONE2	MOVEQ	#IO_CLOSE,D0
	TRAP	#2
	MOVEA.L	BV_BFBAS(A6),A1
	BCLR	#0,1(A1,A6.L)	Make x_size and . .
	BCLR	#0,3(A1,A6.L)	. . x_origin even
	MOVEM.L	(A7)+,SW_REG
	RTS
;
TRY	MOVE.W	D0,(A4,A6.L)
	LEA	-2(A4,D5.W),A1	Set A1 to start of definition block
	MOVEQ	#0,D1
	MOVEQ	#0,D2
	MOVEQ	#SD_WDEF,D0
	TRAP	#4		A1 is relative to A6
	TRAP	#3
	TST.L	D0
	RTS
;
H_DONE	MOVE.W	D7,D0
	BSR	TRY
	BNE	DONE1
	MOVE.W	D7,D6
	BRA	DONE1
;
MIN_WIDTH EQU	256
MAX_WIDTH EQU	2048
MIN_HGT	EQU	128
MAX_HGT	EQU	1024

; BS_OWNER name$ sets the owner of the first independent program
; whose name is name$ to be "myself".
;
; Error returns may be "bad parameter" or "not found"

OWNER:
	LEA	8(A3),A0
	CMPA.L	A5,A0
	BNE	BAD_PARM	---->
	MOVEA.W	CA_GTSTR,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVEQ	#MT_INF,D0	Sets A0 = sys_vars & D1 = my ID
	TRAP	#1
	MOVEA.W	UT_CSTR,A2
	MOVEA.L	SV_JBBAS(A0),A3
	MOVEA.L	SV_JBTOP(A0),A4
	MOVE.W	#$4AFB,D2
;
OWNER_1	CMPA.L	A3,A4
	BLE	NOT_FOUND ---->
	MOVE.L	(A3)+,D0		The next prog address
	BMI	OWNER_1		Not a program
	MOVEA.L	D0,A5
	CMP.W	$6E(A5),D2	Is there a name? . .
	BNE	OWNER_1		. . no
	LEA	$70(A5),A0	-> name
	MOVEQ	#1,D0		comparison not case sensitive
	SUBA.L	A6,A0		not really dangerous - see NOTE
	JSR	(A2)		(comparison needs A0/A1 rel to A6)
	TST.L	D0		What happened? . .
	BNE	OWNER_1		. . not found yet
	TST.L	8(A5)		Who is the owner? . .
	BNE	OWNER_1		. . not Master BASIC
	MOVE.L	D1,8(A5)		Set myself as the owner
	RTS			NB D0 = 0 here

NOT_FOUND MOVEQ	#-7,D0
	RTS
;
; NOTE
; A6 may change if this routine is called by BASIC under early versions
; of QDOS.
;
; However, the effect of a change on a comparison of strings is much more
; likely to cause a test to fail if it should have succeeded than vice
; versa.	A false success would lead to no more than the owner being
; reconfirmed as BASIC, as indeed is the case in a true success!
;
; In later versions of QDOS and in SMSQ/E A6 does not change anyway.
;
; Finally, this routine is really intended for compiled tasks, where there
; is no question of A6 changing.

; B_ID returns the ID of the current job

B_ID	MOVEQ	#MT_INF,D0
	TRAP	#1
	MOVE.L	D1,D5
	BRA	SE_3
